/* FileIO.c generated by valac 0.48.3, the Vala compiler
 * generated from FileIO.vala, do not modify */

/*
 *    FileIO.vala
 *
 *    Copyright (C) 2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

#define VENOM_TYPE_FILE_IO (venom_file_io_get_type ())
#define VENOM_FILE_IO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_FILE_IO, VenomFileIO))
#define VENOM_FILE_IO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VENOM_TYPE_FILE_IO, VenomFileIOClass))
#define VENOM_IS_FILE_IO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_FILE_IO))
#define VENOM_IS_FILE_IO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VENOM_TYPE_FILE_IO))
#define VENOM_FILE_IO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VENOM_TYPE_FILE_IO, VenomFileIOClass))

typedef struct _VenomFileIO VenomFileIO;
typedef struct _VenomFileIOClass VenomFileIOClass;
typedef struct _VenomFileIOPrivate VenomFileIOPrivate;
enum  {
	VENOM_FILE_IO_0_PROPERTY,
	VENOM_FILE_IO_NUM_PROPERTIES
};
static GParamSpec* venom_file_io_properties[VENOM_FILE_IO_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _VenomFileIO {
	GObject parent_instance;
	VenomFileIOPrivate * priv;
};

struct _VenomFileIOClass {
	GObjectClass parent_class;
};

static gpointer venom_file_io_parent_class = NULL;

GType venom_file_io_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VenomFileIO, g_object_unref)
static VenomFileIO* venom_file_io_new (void);
static VenomFileIO* venom_file_io_construct (GType object_type);
gchar* venom_file_io_load_contents_text (const gchar* path,
                                         GError** error);
void venom_file_io_save_contents_text (const gchar* path,
                                       const gchar* data,
                                       GError** error);
static GType venom_file_io_get_type_once (void);

static VenomFileIO*
venom_file_io_construct (GType object_type)
{
	VenomFileIO * self = NULL;
#line 24 "../src/core/FileIO.vala"
	self = (VenomFileIO*) g_object_new (object_type, NULL);
#line 24 "../src/core/FileIO.vala"
	return self;
#line 79 "FileIO.c"
}

static VenomFileIO*
venom_file_io_new (void)
{
#line 24 "../src/core/FileIO.vala"
	return venom_file_io_construct (VENOM_TYPE_FILE_IO);
#line 87 "FileIO.c"
}

gchar*
venom_file_io_load_contents_text (const gchar* path,
                                  GError** error)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	guint8* buf = NULL;
	gint buf_length1 = 0;
	gint _buf_size_ = 0;
	guint8* _tmp1_ = NULL;
	gsize _tmp2_ = 0;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 26 "../src/core/FileIO.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 27 "../src/core/FileIO.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 27 "../src/core/FileIO.vala"
	file = _tmp0_;
#line 29 "../src/core/FileIO.vala"
	g_file_load_contents (file, NULL, &_tmp1_, &_tmp2_, NULL, &_inner_error0_);
#line 29 "../src/core/FileIO.vala"
	buf = (g_free (buf), NULL);
#line 29 "../src/core/FileIO.vala"
	buf = _tmp1_;
#line 29 "../src/core/FileIO.vala"
	buf_length1 = _tmp2_;
#line 29 "../src/core/FileIO.vala"
	_buf_size_ = buf_length1;
#line 29 "../src/core/FileIO.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 29 "../src/core/FileIO.vala"
		g_propagate_error (error, _inner_error0_);
#line 29 "../src/core/FileIO.vala"
		buf = (g_free (buf), NULL);
#line 29 "../src/core/FileIO.vala"
		_g_object_unref0 (file);
#line 29 "../src/core/FileIO.vala"
		return NULL;
#line 130 "FileIO.c"
	}
#line 30 "../src/core/FileIO.vala"
	_tmp3_ = g_strdup ((const gchar*) buf);
#line 30 "../src/core/FileIO.vala"
	result = _tmp3_;
#line 30 "../src/core/FileIO.vala"
	buf = (g_free (buf), NULL);
#line 30 "../src/core/FileIO.vala"
	_g_object_unref0 (file);
#line 30 "../src/core/FileIO.vala"
	return result;
#line 142 "FileIO.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1555 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1556 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1556 "glib-2.0.vapi"
	res_length1 = -1;
#line 1556 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1557 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1557 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1557 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1558 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1558 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1558 "glib-2.0.vapi"
	if (result_length1) {
#line 1558 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 179 "FileIO.c"
	}
#line 1558 "glib-2.0.vapi"
	result = _tmp2_;
#line 1558 "glib-2.0.vapi"
	return result;
#line 185 "FileIO.c"
}

void
venom_file_io_save_contents_text (const gchar* path,
                                  const gchar* data,
                                  GError** error)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint _tmp3__length1;
	GError* _inner_error0_ = NULL;
#line 33 "../src/core/FileIO.vala"
	g_return_if_fail (path != NULL);
#line 33 "../src/core/FileIO.vala"
	g_return_if_fail (data != NULL);
#line 34 "../src/core/FileIO.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 34 "../src/core/FileIO.vala"
	file = _tmp0_;
#line 35 "../src/core/FileIO.vala"
	_tmp1_ = string_get_data (data, &_tmp2_);
#line 35 "../src/core/FileIO.vala"
	_tmp1__length1 = _tmp2_;
#line 35 "../src/core/FileIO.vala"
	_tmp3_ = _tmp1_;
#line 35 "../src/core/FileIO.vala"
	_tmp3__length1 = _tmp1__length1;
#line 35 "../src/core/FileIO.vala"
	g_file_replace_contents (file, _tmp3_, (gsize) _tmp3__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, NULL, &_inner_error0_);
#line 35 "../src/core/FileIO.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "../src/core/FileIO.vala"
		g_propagate_error (error, _inner_error0_);
#line 35 "../src/core/FileIO.vala"
		_g_object_unref0 (file);
#line 35 "../src/core/FileIO.vala"
		return;
#line 227 "FileIO.c"
	}
#line 33 "../src/core/FileIO.vala"
	_g_object_unref0 (file);
#line 231 "FileIO.c"
}

static void
venom_file_io_class_init (VenomFileIOClass * klass,
                          gpointer klass_data)
{
#line 23 "../src/core/FileIO.vala"
	venom_file_io_parent_class = g_type_class_peek_parent (klass);
#line 240 "FileIO.c"
}

static void
venom_file_io_instance_init (VenomFileIO * self,
                             gpointer klass)
{
}

static GType
venom_file_io_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomFileIOClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_file_io_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VenomFileIO), 0, (GInstanceInitFunc) venom_file_io_instance_init, NULL };
	GType venom_file_io_type_id;
	venom_file_io_type_id = g_type_register_static (G_TYPE_OBJECT, "VenomFileIO", &g_define_type_info, 0);
	return venom_file_io_type_id;
}

GType
venom_file_io_get_type (void)
{
	static volatile gsize venom_file_io_type_id__volatile = 0;
	if (g_once_init_enter (&venom_file_io_type_id__volatile)) {
		GType venom_file_io_type_id;
		venom_file_io_type_id = venom_file_io_get_type_once ();
		g_once_init_leave (&venom_file_io_type_id__volatile, venom_file_io_type_id);
	}
	return venom_file_io_type_id__volatile;
}

