/* FileTransfer.c generated by valac 0.48.3, the Vala compiler
 * generated from FileTransfer.vala, do not modify */

/*
 *    FileTransfer.vala
 *
 *    Copyright (C) 2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	VENOM_FILE_TRANSFER_STATE_INIT,
	VENOM_FILE_TRANSFER_STATE_PAUSED,
	VENOM_FILE_TRANSFER_STATE_RUNNING,
	VENOM_FILE_TRANSFER_STATE_CANCEL,
	VENOM_FILE_TRANSFER_STATE_FINISHED,
	VENOM_FILE_TRANSFER_STATE_FAILED
} VenomFileTransferState;

#define VENOM_TYPE_FILE_TRANSFER_STATE (venom_file_transfer_state_get_type ())
typedef enum  {
	VENOM_FILE_TRANSFER_DIRECTION_INCOMING,
	VENOM_FILE_TRANSFER_DIRECTION_OUTGOING
} VenomFileTransferDirection;

#define VENOM_TYPE_FILE_TRANSFER_DIRECTION (venom_file_transfer_direction_get_type ())

#define VENOM_TYPE_FILE_TRANSFER (venom_file_transfer_get_type ())
#define VENOM_FILE_TRANSFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_FILE_TRANSFER, VenomFileTransfer))
#define VENOM_IS_FILE_TRANSFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_FILE_TRANSFER))
#define VENOM_FILE_TRANSFER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VENOM_TYPE_FILE_TRANSFER, VenomFileTransferIface))

typedef struct _VenomFileTransfer VenomFileTransfer;
typedef struct _VenomFileTransferIface VenomFileTransferIface;
enum  {
	VENOM_FILE_TRANSFER_STATE_CHANGED_SIGNAL,
	VENOM_FILE_TRANSFER_PROGRESS_CHANGED_SIGNAL,
	VENOM_FILE_TRANSFER_NUM_SIGNALS
};
static guint venom_file_transfer_signals[VENOM_FILE_TRANSFER_NUM_SIGNALS] = {0};

#define VENOM_TYPE_FILE_TRANSFER_IMPL (venom_file_transfer_impl_get_type ())
#define VENOM_FILE_TRANSFER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_FILE_TRANSFER_IMPL, VenomFileTransferImpl))
#define VENOM_FILE_TRANSFER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VENOM_TYPE_FILE_TRANSFER_IMPL, VenomFileTransferImplClass))
#define VENOM_IS_FILE_TRANSFER_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_FILE_TRANSFER_IMPL))
#define VENOM_IS_FILE_TRANSFER_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VENOM_TYPE_FILE_TRANSFER_IMPL))
#define VENOM_FILE_TRANSFER_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VENOM_TYPE_FILE_TRANSFER_IMPL, VenomFileTransferImplClass))

typedef struct _VenomFileTransferImpl VenomFileTransferImpl;
typedef struct _VenomFileTransferImplClass VenomFileTransferImplClass;
typedef struct _VenomFileTransferImplPrivate VenomFileTransferImplPrivate;
enum  {
	VENOM_FILE_TRANSFER_IMPL_0_PROPERTY,
	VENOM_FILE_TRANSFER_IMPL_NUM_PROPERTIES
};
static GParamSpec* venom_file_transfer_impl_properties[VENOM_FILE_TRANSFER_IMPL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	VENOM_FILE_TRANSFER_ERROR_READ,
	VENOM_FILE_TRANSFER_ERROR_WRITE,
	VENOM_FILE_TRANSFER_ERROR_INIT,
	VENOM_FILE_TRANSFER_ERROR_OVERFLOW
} VenomFileTransferError;
#define VENOM_FILE_TRANSFER_ERROR venom_file_transfer_error_quark ()
struct _VenomFileTransferIface {
	GTypeInterface parent_iface;
	VenomFileTransferDirection (*get_direction) (VenomFileTransfer* self);
	guint32 (*get_friend_number) (VenomFileTransfer* self);
	guint32 (*get_file_number) (VenomFileTransfer* self);
	guint64 (*get_file_size) (VenomFileTransfer* self);
	guint64 (*get_transmitted_size) (VenomFileTransfer* self);
	VenomFileTransferState (*get_state) (VenomFileTransfer* self);
	gboolean (*is_avatar) (VenomFileTransfer* self);
	guint8* (*get_avatar_buffer) (VenomFileTransfer* self, gint* result_length1);
	void (*init_file) (VenomFileTransfer* self, GFile* file, GError** error);
	void (*write_data) (VenomFileTransfer* self, guint8* data, gint data_length1, GError** error);
	guint8* (*read_data) (VenomFileTransfer* self, guint64 length, gint* result_length1, GError** error);
	gchar* (*get_file_name) (VenomFileTransfer* self);
	gchar* (*get_file_path) (VenomFileTransfer* self);
	void (*set_state) (VenomFileTransfer* self, VenomFileTransferState state);
};

struct _VenomFileTransferImpl {
	GObject parent_instance;
	VenomFileTransferImplPrivate * priv;
};

struct _VenomFileTransferImplClass {
	GObjectClass parent_class;
};

struct _VenomFileTransferImplPrivate {
	VenomFileTransferDirection direction;
	guint32 friend_number;
	guint32 file_number;
	guint64 file_size;
	guint64 transmitted_size;
	VenomFileTransferState state;
	gboolean _is_avatar;
	guint8* avatar_buffer;
	gint avatar_buffer_length1;
	gint _avatar_buffer_size_;
	gchar* file_name;
	GFile* file;
};

static gint VenomFileTransferImpl_private_offset;
static gpointer venom_file_transfer_impl_parent_class = NULL;
static VenomFileTransferIface * venom_file_transfer_impl_venom_file_transfer_parent_iface = NULL;

GType venom_file_transfer_state_get_type (void) G_GNUC_CONST;
GType venom_file_transfer_direction_get_type (void) G_GNUC_CONST;
GQuark venom_file_transfer_error_quark (void);
GType venom_file_transfer_get_type (void) G_GNUC_CONST;
VenomFileTransferDirection venom_file_transfer_get_direction (VenomFileTransfer* self);
guint32 venom_file_transfer_get_friend_number (VenomFileTransfer* self);
guint32 venom_file_transfer_get_file_number (VenomFileTransfer* self);
guint64 venom_file_transfer_get_file_size (VenomFileTransfer* self);
guint64 venom_file_transfer_get_transmitted_size (VenomFileTransfer* self);
VenomFileTransferState venom_file_transfer_get_state (VenomFileTransfer* self);
gboolean venom_file_transfer_is_avatar (VenomFileTransfer* self);
guint8* venom_file_transfer_get_avatar_buffer (VenomFileTransfer* self,
                                               gint* result_length1);
void venom_file_transfer_init_file (VenomFileTransfer* self,
                                    GFile* file,
                                    GError** error);
void venom_file_transfer_write_data (VenomFileTransfer* self,
                                     guint8* data,
                                     gint data_length1,
                                     GError** error);
guint8* venom_file_transfer_read_data (VenomFileTransfer* self,
                                       guint64 length,
                                       gint* result_length1,
                                       GError** error);
gchar* venom_file_transfer_get_file_name (VenomFileTransfer* self);
gchar* venom_file_transfer_get_file_path (VenomFileTransfer* self);
void venom_file_transfer_set_state (VenomFileTransfer* self,
                                    VenomFileTransferState state);
static GType venom_file_transfer_get_type_once (void);
GType venom_file_transfer_impl_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VenomFileTransferImpl, g_object_unref)
static VenomFileTransferImpl* venom_file_transfer_impl_new (VenomFileTransferDirection direction,
                                                     guint32 friend_number,
                                                     guint32 file_number,
                                                     guint64 file_size);
static VenomFileTransferImpl* venom_file_transfer_impl_construct (GType object_type,
                                                           VenomFileTransferDirection direction,
                                                           guint32 friend_number,
                                                           guint32 file_number,
                                                           guint64 file_size);
VenomFileTransferImpl* venom_file_transfer_impl_new_File (VenomFileTransferDirection direction,
                                                          guint32 friend_number,
                                                          guint32 file_number,
                                                          guint64 file_size,
                                                          const gchar* file_name);
VenomFileTransferImpl* venom_file_transfer_impl_construct_File (GType object_type,
                                                                VenomFileTransferDirection direction,
                                                                guint32 friend_number,
                                                                guint32 file_number,
                                                                guint64 file_size,
                                                                const gchar* file_name);
VenomFileTransferImpl* venom_file_transfer_impl_new_Avatar (VenomFileTransferDirection direction,
                                                            guint32 friend_number,
                                                            guint32 file_number,
                                                            guint64 file_size);
VenomFileTransferImpl* venom_file_transfer_impl_construct_Avatar (GType object_type,
                                                                  VenomFileTransferDirection direction,
                                                                  guint32 friend_number,
                                                                  guint32 file_number,
                                                                  guint64 file_size);
VenomFileTransferImpl* venom_file_transfer_impl_new_AvatarOutgoing (VenomFileTransferDirection direction,
                                                                    guint32 friend_number,
                                                                    guint32 file_number,
                                                                    guint8* buffer,
                                                                    gint buffer_length1);
VenomFileTransferImpl* venom_file_transfer_impl_construct_AvatarOutgoing (GType object_type,
                                                                          VenomFileTransferDirection direction,
                                                                          guint32 friend_number,
                                                                          guint32 file_number,
                                                                          guint8* buffer,
                                                                          gint buffer_length1);
static guint8* _vala_array_dup1 (guint8* self,
                          gint length);
static void venom_file_transfer_impl_real_init_file (VenomFileTransfer* base,
                                              GFile* file,
                                              GError** error);
static void venom_file_transfer_impl_copy_with_offset (guint8* dest,
                                                gint dest_length1,
                                                guint8* src,
                                                gint src_length1,
                                                guint64 offset);
static gboolean venom_file_transfer_impl_real_is_avatar (VenomFileTransfer* base);
static guint64 venom_file_transfer_impl_real_get_transmitted_size (VenomFileTransfer* base);
static guint64 venom_file_transfer_impl_real_get_file_size (VenomFileTransfer* base);
static void venom_file_transfer_impl_real_write_data (VenomFileTransfer* base,
                                               guint8* data,
                                               gint data_length1,
                                               GError** error);
static guint8* venom_file_transfer_impl_real_read_data (VenomFileTransfer* base,
                                                 guint64 length,
                                                 gint* result_length1,
                                                 GError** error);
static guint8* venom_file_transfer_impl_real_get_avatar_buffer (VenomFileTransfer* base,
                                                         gint* result_length1);
static VenomFileTransferState venom_file_transfer_impl_real_get_state (VenomFileTransfer* base);
static void venom_file_transfer_impl_real_set_state (VenomFileTransfer* base,
                                              VenomFileTransferState state);
static guint32 venom_file_transfer_impl_real_get_friend_number (VenomFileTransfer* base);
static guint32 venom_file_transfer_impl_real_get_file_number (VenomFileTransfer* base);
static VenomFileTransferDirection venom_file_transfer_impl_real_get_direction (VenomFileTransfer* base);
static gchar* venom_file_transfer_impl_real_get_file_name (VenomFileTransfer* base);
static gchar* venom_file_transfer_impl_real_get_file_path (VenomFileTransfer* base);
static void venom_file_transfer_impl_finalize (GObject * obj);
static GType venom_file_transfer_impl_get_type_once (void);

static GType
venom_file_transfer_state_get_type_once (void)
{
	static const GEnumValue values[] = {{VENOM_FILE_TRANSFER_STATE_INIT, "VENOM_FILE_TRANSFER_STATE_INIT", "init"}, {VENOM_FILE_TRANSFER_STATE_PAUSED, "VENOM_FILE_TRANSFER_STATE_PAUSED", "paused"}, {VENOM_FILE_TRANSFER_STATE_RUNNING, "VENOM_FILE_TRANSFER_STATE_RUNNING", "running"}, {VENOM_FILE_TRANSFER_STATE_CANCEL, "VENOM_FILE_TRANSFER_STATE_CANCEL", "cancel"}, {VENOM_FILE_TRANSFER_STATE_FINISHED, "VENOM_FILE_TRANSFER_STATE_FINISHED", "finished"}, {VENOM_FILE_TRANSFER_STATE_FAILED, "VENOM_FILE_TRANSFER_STATE_FAILED", "failed"}, {0, NULL, NULL}};
	GType venom_file_transfer_state_type_id;
	venom_file_transfer_state_type_id = g_enum_register_static ("VenomFileTransferState", values);
	return venom_file_transfer_state_type_id;
}

GType
venom_file_transfer_state_get_type (void)
{
	static volatile gsize venom_file_transfer_state_type_id__volatile = 0;
	if (g_once_init_enter (&venom_file_transfer_state_type_id__volatile)) {
		GType venom_file_transfer_state_type_id;
		venom_file_transfer_state_type_id = venom_file_transfer_state_get_type_once ();
		g_once_init_leave (&venom_file_transfer_state_type_id__volatile, venom_file_transfer_state_type_id);
	}
	return venom_file_transfer_state_type_id__volatile;
}

static GType
venom_file_transfer_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{VENOM_FILE_TRANSFER_DIRECTION_INCOMING, "VENOM_FILE_TRANSFER_DIRECTION_INCOMING", "incoming"}, {VENOM_FILE_TRANSFER_DIRECTION_OUTGOING, "VENOM_FILE_TRANSFER_DIRECTION_OUTGOING", "outgoing"}, {0, NULL, NULL}};
	GType venom_file_transfer_direction_type_id;
	venom_file_transfer_direction_type_id = g_enum_register_static ("VenomFileTransferDirection", values);
	return venom_file_transfer_direction_type_id;
}

GType
venom_file_transfer_direction_get_type (void)
{
	static volatile gsize venom_file_transfer_direction_type_id__volatile = 0;
	if (g_once_init_enter (&venom_file_transfer_direction_type_id__volatile)) {
		GType venom_file_transfer_direction_type_id;
		venom_file_transfer_direction_type_id = venom_file_transfer_direction_get_type_once ();
		g_once_init_leave (&venom_file_transfer_direction_type_id__volatile, venom_file_transfer_direction_type_id);
	}
	return venom_file_transfer_direction_type_id__volatile;
}

GQuark
venom_file_transfer_error_quark (void)
{
	return g_quark_from_static_string ("venom-file-transfer-error-quark");
}

VenomFileTransferDirection
venom_file_transfer_get_direction (VenomFileTransfer* self)
{
#line 48 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_direction (self);
#line 295 "FileTransfer.c"
}

guint32
venom_file_transfer_get_friend_number (VenomFileTransfer* self)
{
#line 49 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 49 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_friend_number (self);
#line 305 "FileTransfer.c"
}

guint32
venom_file_transfer_get_file_number (VenomFileTransfer* self)
{
#line 50 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 50 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_file_number (self);
#line 315 "FileTransfer.c"
}

guint64
venom_file_transfer_get_file_size (VenomFileTransfer* self)
{
#line 51 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 51 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_file_size (self);
#line 325 "FileTransfer.c"
}

guint64
venom_file_transfer_get_transmitted_size (VenomFileTransfer* self)
{
#line 52 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 52 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_transmitted_size (self);
#line 335 "FileTransfer.c"
}

VenomFileTransferState
venom_file_transfer_get_state (VenomFileTransfer* self)
{
#line 53 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_state (self);
#line 345 "FileTransfer.c"
}

gboolean
venom_file_transfer_is_avatar (VenomFileTransfer* self)
{
#line 54 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->is_avatar (self);
#line 355 "FileTransfer.c"
}

guint8*
venom_file_transfer_get_avatar_buffer (VenomFileTransfer* self,
                                       gint* result_length1)
{
#line 55 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_avatar_buffer (self, result_length1);
#line 366 "FileTransfer.c"
}

void
venom_file_transfer_init_file (VenomFileTransfer* self,
                               GFile* file,
                               GError** error)
{
#line 57 "../src/core/FileTransfer.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/core/FileTransfer.vala"
	VENOM_FILE_TRANSFER_GET_INTERFACE (self)->init_file (self, file, error);
#line 378 "FileTransfer.c"
}

void
venom_file_transfer_write_data (VenomFileTransfer* self,
                                guint8* data,
                                gint data_length1,
                                GError** error)
{
#line 59 "../src/core/FileTransfer.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/core/FileTransfer.vala"
	VENOM_FILE_TRANSFER_GET_INTERFACE (self)->write_data (self, data, data_length1, error);
#line 391 "FileTransfer.c"
}

guint8*
venom_file_transfer_read_data (VenomFileTransfer* self,
                               guint64 length,
                               gint* result_length1,
                               GError** error)
{
#line 60 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->read_data (self, length, result_length1, error);
#line 404 "FileTransfer.c"
}

gchar*
venom_file_transfer_get_file_name (VenomFileTransfer* self)
{
#line 62 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_file_name (self);
#line 414 "FileTransfer.c"
}

gchar*
venom_file_transfer_get_file_path (VenomFileTransfer* self)
{
#line 63 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../src/core/FileTransfer.vala"
	return VENOM_FILE_TRANSFER_GET_INTERFACE (self)->get_file_path (self);
#line 424 "FileTransfer.c"
}

void
venom_file_transfer_set_state (VenomFileTransfer* self,
                               VenomFileTransferState state)
{
#line 64 "../src/core/FileTransfer.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/core/FileTransfer.vala"
	VENOM_FILE_TRANSFER_GET_INTERFACE (self)->set_state (self, state);
#line 435 "FileTransfer.c"
}

static void
venom_file_transfer_default_init (VenomFileTransferIface * iface,
                                  gpointer iface_data)
{
#line 44 "../src/core/FileTransfer.vala"
	venom_file_transfer_signals[VENOM_FILE_TRANSFER_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", VENOM_TYPE_FILE_TRANSFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 44 "../src/core/FileTransfer.vala"
	venom_file_transfer_signals[VENOM_FILE_TRANSFER_PROGRESS_CHANGED_SIGNAL] = g_signal_new ("progress-changed", VENOM_TYPE_FILE_TRANSFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 446 "FileTransfer.c"
}

static GType
venom_file_transfer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomFileTransferIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_file_transfer_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType venom_file_transfer_type_id;
	venom_file_transfer_type_id = g_type_register_static (G_TYPE_INTERFACE, "VenomFileTransfer", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (venom_file_transfer_type_id, G_TYPE_OBJECT);
	return venom_file_transfer_type_id;
}

GType
venom_file_transfer_get_type (void)
{
	static volatile gsize venom_file_transfer_type_id__volatile = 0;
	if (g_once_init_enter (&venom_file_transfer_type_id__volatile)) {
		GType venom_file_transfer_type_id;
		venom_file_transfer_type_id = venom_file_transfer_get_type_once ();
		g_once_init_leave (&venom_file_transfer_type_id__volatile, venom_file_transfer_type_id);
	}
	return venom_file_transfer_type_id__volatile;
}

static inline gpointer
venom_file_transfer_impl_get_instance_private (VenomFileTransferImpl* self)
{
	return G_STRUCT_MEMBER_P (self, VenomFileTransferImpl_private_offset);
}

static VenomFileTransferImpl*
venom_file_transfer_impl_construct (GType object_type,
                                    VenomFileTransferDirection direction,
                                    guint32 friend_number,
                                    guint32 file_number,
                                    guint64 file_size)
{
	VenomFileTransferImpl * self = NULL;
#line 81 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) g_object_new (object_type, NULL);
#line 82 "../src/core/FileTransfer.vala"
	self->priv->friend_number = friend_number;
#line 83 "../src/core/FileTransfer.vala"
	self->priv->file_number = file_number;
#line 84 "../src/core/FileTransfer.vala"
	self->priv->direction = direction;
#line 85 "../src/core/FileTransfer.vala"
	self->priv->file_size = file_size;
#line 87 "../src/core/FileTransfer.vala"
	self->priv->state = VENOM_FILE_TRANSFER_STATE_INIT;
#line 88 "../src/core/FileTransfer.vala"
	self->priv->transmitted_size = (guint64) 0;
#line 81 "../src/core/FileTransfer.vala"
	return self;
#line 501 "FileTransfer.c"
}

static VenomFileTransferImpl*
venom_file_transfer_impl_new (VenomFileTransferDirection direction,
                              guint32 friend_number,
                              guint32 file_number,
                              guint64 file_size)
{
#line 81 "../src/core/FileTransfer.vala"
	return venom_file_transfer_impl_construct (VENOM_TYPE_FILE_TRANSFER_IMPL, direction, friend_number, file_number, file_size);
#line 512 "FileTransfer.c"
}

VenomFileTransferImpl*
venom_file_transfer_impl_construct_File (GType object_type,
                                         VenomFileTransferDirection direction,
                                         guint32 friend_number,
                                         guint32 file_number,
                                         guint64 file_size,
                                         const gchar* file_name)
{
	VenomFileTransferImpl * self = NULL;
	gchar* _tmp0_;
#line 91 "../src/core/FileTransfer.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 92 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) venom_file_transfer_impl_construct (object_type, direction, friend_number, file_number, file_size);
#line 93 "../src/core/FileTransfer.vala"
	_tmp0_ = g_strdup (file_name);
#line 93 "../src/core/FileTransfer.vala"
	_g_free0 (self->priv->file_name);
#line 93 "../src/core/FileTransfer.vala"
	self->priv->file_name = _tmp0_;
#line 94 "../src/core/FileTransfer.vala"
	self->priv->_is_avatar = FALSE;
#line 91 "../src/core/FileTransfer.vala"
	return self;
#line 539 "FileTransfer.c"
}

VenomFileTransferImpl*
venom_file_transfer_impl_new_File (VenomFileTransferDirection direction,
                                   guint32 friend_number,
                                   guint32 file_number,
                                   guint64 file_size,
                                   const gchar* file_name)
{
#line 91 "../src/core/FileTransfer.vala"
	return venom_file_transfer_impl_construct_File (VENOM_TYPE_FILE_TRANSFER_IMPL, direction, friend_number, file_number, file_size, file_name);
#line 551 "FileTransfer.c"
}

VenomFileTransferImpl*
venom_file_transfer_impl_construct_Avatar (GType object_type,
                                           VenomFileTransferDirection direction,
                                           guint32 friend_number,
                                           guint32 file_number,
                                           guint64 file_size)
{
	VenomFileTransferImpl * self = NULL;
	guint8* _tmp0_;
#line 98 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) venom_file_transfer_impl_construct (object_type, direction, friend_number, file_number, file_size);
#line 99 "../src/core/FileTransfer.vala"
	_tmp0_ = g_new0 (guint8, file_size);
#line 99 "../src/core/FileTransfer.vala"
	self->priv->avatar_buffer = (g_free (self->priv->avatar_buffer), NULL);
#line 99 "../src/core/FileTransfer.vala"
	self->priv->avatar_buffer = _tmp0_;
#line 99 "../src/core/FileTransfer.vala"
	self->priv->avatar_buffer_length1 = file_size;
#line 99 "../src/core/FileTransfer.vala"
	self->priv->_avatar_buffer_size_ = self->priv->avatar_buffer_length1;
#line 100 "../src/core/FileTransfer.vala"
	self->priv->_is_avatar = TRUE;
#line 97 "../src/core/FileTransfer.vala"
	return self;
#line 579 "FileTransfer.c"
}

VenomFileTransferImpl*
venom_file_transfer_impl_new_Avatar (VenomFileTransferDirection direction,
                                     guint32 friend_number,
                                     guint32 file_number,
                                     guint64 file_size)
{
#line 97 "../src/core/FileTransfer.vala"
	return venom_file_transfer_impl_construct_Avatar (VENOM_TYPE_FILE_TRANSFER_IMPL, direction, friend_number, file_number, file_size);
#line 590 "FileTransfer.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  gint length)
{
#line 105 "../src/core/FileTransfer.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 599 "FileTransfer.c"
}

VenomFileTransferImpl*
venom_file_transfer_impl_construct_AvatarOutgoing (GType object_type,
                                                   VenomFileTransferDirection direction,
                                                   guint32 friend_number,
                                                   guint32 file_number,
                                                   guint8* buffer,
                                                   gint buffer_length1)
{
	VenomFileTransferImpl * self = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
#line 104 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) venom_file_transfer_impl_construct (object_type, direction, friend_number, file_number, (guint64) buffer_length1);
#line 105 "../src/core/FileTransfer.vala"
	_tmp0_ = (buffer != NULL) ? _vala_array_dup1 (buffer, buffer_length1) : ((gpointer) buffer);
#line 105 "../src/core/FileTransfer.vala"
	_tmp0__length1 = buffer_length1;
#line 105 "../src/core/FileTransfer.vala"
	self->priv->avatar_buffer = (g_free (self->priv->avatar_buffer), NULL);
#line 105 "../src/core/FileTransfer.vala"
	self->priv->avatar_buffer = _tmp0_;
#line 105 "../src/core/FileTransfer.vala"
	self->priv->avatar_buffer_length1 = _tmp0__length1;
#line 105 "../src/core/FileTransfer.vala"
	self->priv->_avatar_buffer_size_ = self->priv->avatar_buffer_length1;
#line 106 "../src/core/FileTransfer.vala"
	self->priv->_is_avatar = TRUE;
#line 103 "../src/core/FileTransfer.vala"
	return self;
#line 631 "FileTransfer.c"
}

VenomFileTransferImpl*
venom_file_transfer_impl_new_AvatarOutgoing (VenomFileTransferDirection direction,
                                             guint32 friend_number,
                                             guint32 file_number,
                                             guint8* buffer,
                                             gint buffer_length1)
{
#line 103 "../src/core/FileTransfer.vala"
	return venom_file_transfer_impl_construct_AvatarOutgoing (VENOM_TYPE_FILE_TRANSFER_IMPL, direction, friend_number, file_number, buffer, buffer_length1);
#line 643 "FileTransfer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "../src/core/FileTransfer.vala"
	return self ? g_object_ref (self) : NULL;
#line 651 "FileTransfer.c"
}

static void
venom_file_transfer_impl_real_init_file (VenomFileTransfer* base,
                                         GFile* file,
                                         GError** error)
{
	VenomFileTransferImpl * self;
	GFile* _tmp0_;
	VenomFileTransferDirection _tmp1_;
	GError* _inner_error0_ = NULL;
#line 109 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 109 "../src/core/FileTransfer.vala"
	g_return_if_fail (file != NULL);
#line 110 "../src/core/FileTransfer.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 110 "../src/core/FileTransfer.vala"
	_g_object_unref0 (self->priv->file);
#line 110 "../src/core/FileTransfer.vala"
	self->priv->file = _tmp0_;
#line 111 "../src/core/FileTransfer.vala"
	_tmp1_ = self->priv->direction;
#line 111 "../src/core/FileTransfer.vala"
	if (_tmp1_ == VENOM_FILE_TRANSFER_DIRECTION_INCOMING) {
#line 677 "FileTransfer.c"
		GFileOutputStream* _tmp2_;
		GFileOutputStream* _tmp3_;
#line 112 "../src/core/FileTransfer.vala"
		_tmp2_ = g_file_replace (file, NULL, FALSE, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 112 "../src/core/FileTransfer.vala"
		_tmp3_ = _tmp2_;
#line 112 "../src/core/FileTransfer.vala"
		_g_object_unref0 (_tmp3_);
#line 112 "../src/core/FileTransfer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/core/FileTransfer.vala"
			g_propagate_error (error, _inner_error0_);
#line 112 "../src/core/FileTransfer.vala"
			return;
#line 692 "FileTransfer.c"
		}
	}
}

static void
venom_file_transfer_impl_copy_with_offset (guint8* dest,
                                           gint dest_length1,
                                           guint8* src,
                                           gint src_length1,
                                           guint64 offset)
{
	guint8* dest_ptr = NULL;
	gint dest_ptr_length1;
	gint _dest_ptr_size_;
#line 117 "../src/core/FileTransfer.vala"
	dest_ptr = dest + ((gint) offset);
#line 117 "../src/core/FileTransfer.vala"
	dest_ptr_length1 = dest_length1 - ((gint) offset);
#line 117 "../src/core/FileTransfer.vala"
	_dest_ptr_size_ = dest_ptr_length1;
#line 118 "../src/core/FileTransfer.vala"
	memcpy (dest_ptr, src, (gsize) src_length1);
#line 715 "FileTransfer.c"
}

static gboolean
venom_file_transfer_impl_real_is_avatar (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	gboolean result = FALSE;
#line 121 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 122 "../src/core/FileTransfer.vala"
	result = self->priv->_is_avatar;
#line 122 "../src/core/FileTransfer.vala"
	return result;
#line 729 "FileTransfer.c"
}

static guint64
venom_file_transfer_impl_real_get_transmitted_size (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	guint64 result = 0ULL;
#line 125 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 126 "../src/core/FileTransfer.vala"
	result = self->priv->transmitted_size;
#line 126 "../src/core/FileTransfer.vala"
	return result;
#line 743 "FileTransfer.c"
}

static guint64
venom_file_transfer_impl_real_get_file_size (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	guint64 result = 0ULL;
#line 129 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 130 "../src/core/FileTransfer.vala"
	result = self->priv->file_size;
#line 130 "../src/core/FileTransfer.vala"
	return result;
#line 757 "FileTransfer.c"
}

static void
venom_file_transfer_impl_real_write_data (VenomFileTransfer* base,
                                          guint8* data,
                                          gint data_length1,
                                          GError** error)
{
	VenomFileTransferImpl * self;
	GError* _inner_error0_ = NULL;
#line 133 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 134 "../src/core/FileTransfer.vala"
	if ((data_length1 + self->priv->transmitted_size) > self->priv->file_size) {
#line 772 "FileTransfer.c"
		GError* _tmp0_;
#line 135 "../src/core/FileTransfer.vala"
		venom_file_transfer_set_state ((VenomFileTransfer*) self, VENOM_FILE_TRANSFER_STATE_FAILED);
#line 136 "../src/core/FileTransfer.vala"
		_tmp0_ = g_error_new_literal (VENOM_FILE_TRANSFER_ERROR, VENOM_FILE_TRANSFER_ERROR_OVERFLOW, "Appending too much data, discarding data");
#line 136 "../src/core/FileTransfer.vala"
		_inner_error0_ = _tmp0_;
#line 136 "../src/core/FileTransfer.vala"
		g_propagate_error (error, _inner_error0_);
#line 136 "../src/core/FileTransfer.vala"
		return;
#line 784 "FileTransfer.c"
	}
#line 139 "../src/core/FileTransfer.vala"
	if (self->priv->_is_avatar) {
#line 788 "FileTransfer.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 140 "../src/core/FileTransfer.vala"
		_tmp1_ = self->priv->avatar_buffer;
#line 140 "../src/core/FileTransfer.vala"
		_tmp1__length1 = self->priv->avatar_buffer_length1;
#line 140 "../src/core/FileTransfer.vala"
		venom_file_transfer_impl_copy_with_offset (_tmp1_, (gint) _tmp1__length1, data, (gint) data_length1, self->priv->transmitted_size);
#line 797 "FileTransfer.c"
	} else {
		GFile* _tmp2_;
#line 142 "../src/core/FileTransfer.vala"
		_tmp2_ = self->priv->file;
#line 142 "../src/core/FileTransfer.vala"
		if (_tmp2_ == NULL) {
#line 804 "FileTransfer.c"
			GError* _tmp3_;
#line 143 "../src/core/FileTransfer.vala"
			venom_file_transfer_set_state ((VenomFileTransfer*) self, VENOM_FILE_TRANSFER_STATE_FAILED);
#line 144 "../src/core/FileTransfer.vala"
			_tmp3_ = g_error_new_literal (VENOM_FILE_TRANSFER_ERROR, VENOM_FILE_TRANSFER_ERROR_INIT, "File is not initialized");
#line 144 "../src/core/FileTransfer.vala"
			_inner_error0_ = _tmp3_;
#line 144 "../src/core/FileTransfer.vala"
			g_propagate_error (error, _inner_error0_);
#line 144 "../src/core/FileTransfer.vala"
			return;
#line 816 "FileTransfer.c"
		}
		{
			GFileOutputStream* _tmp4_ = NULL;
			GFile* _tmp5_;
			GFileOutputStream* _tmp6_;
#line 147 "../src/core/FileTransfer.vala"
			_tmp5_ = self->priv->file;
#line 147 "../src/core/FileTransfer.vala"
			_tmp6_ = g_file_append_to (_tmp5_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 147 "../src/core/FileTransfer.vala"
			_tmp4_ = _tmp6_;
#line 147 "../src/core/FileTransfer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 830 "FileTransfer.c"
				goto __catch0_g_error;
			}
#line 147 "../src/core/FileTransfer.vala"
			g_output_stream_write ((GOutputStream*) _tmp4_, data, (gsize) data_length1, NULL, &_inner_error0_);
#line 147 "../src/core/FileTransfer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/core/FileTransfer.vala"
				_g_object_unref0 (_tmp4_);
#line 839 "FileTransfer.c"
				goto __catch0_g_error;
			}
#line 146 "../src/core/FileTransfer.vala"
			_g_object_unref0 (_tmp4_);
#line 844 "FileTransfer.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GError* _tmp11_;
			GError* _tmp12_;
#line 146 "../src/core/FileTransfer.vala"
			e = _inner_error0_;
#line 146 "../src/core/FileTransfer.vala"
			_inner_error0_ = NULL;
#line 149 "../src/core/FileTransfer.vala"
			venom_file_transfer_set_state ((VenomFileTransfer*) self, VENOM_FILE_TRANSFER_STATE_FAILED);
#line 150 "../src/core/FileTransfer.vala"
			_tmp7_ = e;
#line 150 "../src/core/FileTransfer.vala"
			_tmp8_ = _tmp7_->message;
#line 150 "../src/core/FileTransfer.vala"
			_tmp9_ = g_strconcat ("Writing to file failed: ", _tmp8_, NULL);
#line 150 "../src/core/FileTransfer.vala"
			_tmp10_ = _tmp9_;
#line 150 "../src/core/FileTransfer.vala"
			_tmp11_ = g_error_new_literal (VENOM_FILE_TRANSFER_ERROR, VENOM_FILE_TRANSFER_ERROR_WRITE, _tmp10_);
#line 150 "../src/core/FileTransfer.vala"
			_tmp12_ = _tmp11_;
#line 150 "../src/core/FileTransfer.vala"
			_g_free0 (_tmp10_);
#line 150 "../src/core/FileTransfer.vala"
			_inner_error0_ = _tmp12_;
#line 150 "../src/core/FileTransfer.vala"
			_g_error_free0 (e);
#line 880 "FileTransfer.c"
			goto __finally0;
		}
		__finally0:
#line 146 "../src/core/FileTransfer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../src/core/FileTransfer.vala"
			g_propagate_error (error, _inner_error0_);
#line 146 "../src/core/FileTransfer.vala"
			return;
#line 890 "FileTransfer.c"
		}
	}
#line 154 "../src/core/FileTransfer.vala"
	self->priv->transmitted_size = self->priv->transmitted_size + data_length1;
#line 155 "../src/core/FileTransfer.vala"
	g_signal_emit ((VenomFileTransfer*) self, venom_file_transfer_signals[VENOM_FILE_TRANSFER_PROGRESS_CHANGED_SIGNAL], 0);
#line 897 "FileTransfer.c"
}

static guint8*
venom_file_transfer_impl_real_read_data (VenomFileTransfer* base,
                                         guint64 length,
                                         gint* result_length1,
                                         GError** error)
{
	VenomFileTransferImpl * self;
	guint8* buf = NULL;
	guint8* _tmp1_;
	gint buf_length1;
	gint _buf_size_;
	guint8* _tmp20_;
	gint _tmp20__length1;
	GError* _inner_error0_ = NULL;
	guint8* result = NULL;
#line 158 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 159 "../src/core/FileTransfer.vala"
	if ((length + self->priv->transmitted_size) > self->priv->file_size) {
#line 919 "FileTransfer.c"
		GError* _tmp0_;
#line 160 "../src/core/FileTransfer.vala"
		venom_file_transfer_set_state ((VenomFileTransfer*) self, VENOM_FILE_TRANSFER_STATE_FAILED);
#line 161 "../src/core/FileTransfer.vala"
		_tmp0_ = g_error_new_literal (VENOM_FILE_TRANSFER_ERROR, VENOM_FILE_TRANSFER_ERROR_OVERFLOW, "Appending too much data, discarding data");
#line 161 "../src/core/FileTransfer.vala"
		_inner_error0_ = _tmp0_;
#line 161 "../src/core/FileTransfer.vala"
		g_propagate_error (error, _inner_error0_);
#line 161 "../src/core/FileTransfer.vala"
		return NULL;
#line 931 "FileTransfer.c"
	}
#line 163 "../src/core/FileTransfer.vala"
	_tmp1_ = g_new0 (guint8, length);
#line 163 "../src/core/FileTransfer.vala"
	buf = _tmp1_;
#line 163 "../src/core/FileTransfer.vala"
	buf_length1 = length;
#line 163 "../src/core/FileTransfer.vala"
	_buf_size_ = buf_length1;
#line 164 "../src/core/FileTransfer.vala"
	if (self->priv->_is_avatar) {
#line 943 "FileTransfer.c"
		guint8* offset_ptr = NULL;
		guint8* _tmp2_;
		gint _tmp2__length1;
		guint8* _tmp3_;
		gint _tmp3__length1;
		gint offset_ptr_length1;
		gint _offset_ptr_size_;
		guint8* _tmp4_;
		gint _tmp4__length1;
		guint8* _tmp5_;
		gint _tmp5__length1;
		guint8* _tmp6_;
		gint _tmp6__length1;
#line 165 "../src/core/FileTransfer.vala"
		_tmp2_ = self->priv->avatar_buffer;
#line 165 "../src/core/FileTransfer.vala"
		_tmp2__length1 = self->priv->avatar_buffer_length1;
#line 165 "../src/core/FileTransfer.vala"
		_tmp3_ = self->priv->avatar_buffer;
#line 165 "../src/core/FileTransfer.vala"
		_tmp3__length1 = self->priv->avatar_buffer_length1;
#line 165 "../src/core/FileTransfer.vala"
		offset_ptr = _tmp2_ + ((gint) self->priv->transmitted_size);
#line 165 "../src/core/FileTransfer.vala"
		offset_ptr_length1 = _tmp3__length1 - ((gint) self->priv->transmitted_size);
#line 165 "../src/core/FileTransfer.vala"
		_offset_ptr_size_ = offset_ptr_length1;
#line 166 "../src/core/FileTransfer.vala"
		_tmp4_ = buf;
#line 166 "../src/core/FileTransfer.vala"
		_tmp4__length1 = buf_length1;
#line 166 "../src/core/FileTransfer.vala"
		_tmp5_ = offset_ptr;
#line 166 "../src/core/FileTransfer.vala"
		_tmp5__length1 = offset_ptr_length1;
#line 166 "../src/core/FileTransfer.vala"
		_tmp6_ = buf;
#line 166 "../src/core/FileTransfer.vala"
		_tmp6__length1 = buf_length1;
#line 166 "../src/core/FileTransfer.vala"
		memcpy (_tmp4_, _tmp5_, (gsize) _tmp6__length1);
#line 985 "FileTransfer.c"
	} else {
		GFile* _tmp7_;
#line 168 "../src/core/FileTransfer.vala"
		_tmp7_ = self->priv->file;
#line 168 "../src/core/FileTransfer.vala"
		if (_tmp7_ == NULL) {
#line 992 "FileTransfer.c"
			GError* _tmp8_;
#line 169 "../src/core/FileTransfer.vala"
			venom_file_transfer_set_state ((VenomFileTransfer*) self, VENOM_FILE_TRANSFER_STATE_FAILED);
#line 170 "../src/core/FileTransfer.vala"
			_tmp8_ = g_error_new_literal (VENOM_FILE_TRANSFER_ERROR, VENOM_FILE_TRANSFER_ERROR_INIT, "File is not initialized");
#line 170 "../src/core/FileTransfer.vala"
			_inner_error0_ = _tmp8_;
#line 170 "../src/core/FileTransfer.vala"
			g_propagate_error (error, _inner_error0_);
#line 170 "../src/core/FileTransfer.vala"
			buf = (g_free (buf), NULL);
#line 170 "../src/core/FileTransfer.vala"
			return NULL;
#line 1006 "FileTransfer.c"
		}
		{
			GFileInputStream* istream = NULL;
			GFile* _tmp9_;
			GFileInputStream* _tmp10_;
			GFileInputStream* _tmp11_;
			GFileInputStream* _tmp12_;
			guint8* _tmp13_;
			gint _tmp13__length1;
#line 173 "../src/core/FileTransfer.vala"
			_tmp9_ = self->priv->file;
#line 173 "../src/core/FileTransfer.vala"
			_tmp10_ = g_file_read (_tmp9_, NULL, &_inner_error0_);
#line 173 "../src/core/FileTransfer.vala"
			istream = _tmp10_;
#line 173 "../src/core/FileTransfer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1024 "FileTransfer.c"
				goto __catch0_g_error;
			}
#line 174 "../src/core/FileTransfer.vala"
			_tmp11_ = istream;
#line 174 "../src/core/FileTransfer.vala"
			G_FILE_INPUT_STREAM_GET_CLASS (_tmp11_)->seek (_tmp11_, (gint64) self->priv->transmitted_size, G_SEEK_SET, NULL, &_inner_error0_);
#line 174 "../src/core/FileTransfer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../src/core/FileTransfer.vala"
				_g_object_unref0 (istream);
#line 1035 "FileTransfer.c"
				goto __catch0_g_error;
			}
#line 175 "../src/core/FileTransfer.vala"
			_tmp12_ = istream;
#line 175 "../src/core/FileTransfer.vala"
			_tmp13_ = buf;
#line 175 "../src/core/FileTransfer.vala"
			_tmp13__length1 = buf_length1;
#line 175 "../src/core/FileTransfer.vala"
			g_input_stream_read ((GInputStream*) _tmp12_, _tmp13_, (gsize) _tmp13__length1, NULL, &_inner_error0_);
#line 175 "../src/core/FileTransfer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 175 "../src/core/FileTransfer.vala"
				_g_object_unref0 (istream);
#line 1050 "FileTransfer.c"
				goto __catch0_g_error;
			}
#line 172 "../src/core/FileTransfer.vala"
			_g_object_unref0 (istream);
#line 1055 "FileTransfer.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GError* _tmp18_;
			GError* _tmp19_;
#line 172 "../src/core/FileTransfer.vala"
			e = _inner_error0_;
#line 172 "../src/core/FileTransfer.vala"
			_inner_error0_ = NULL;
#line 177 "../src/core/FileTransfer.vala"
			venom_file_transfer_set_state ((VenomFileTransfer*) self, VENOM_FILE_TRANSFER_STATE_FAILED);
#line 178 "../src/core/FileTransfer.vala"
			_tmp14_ = e;
#line 178 "../src/core/FileTransfer.vala"
			_tmp15_ = _tmp14_->message;
#line 178 "../src/core/FileTransfer.vala"
			_tmp16_ = g_strconcat ("Writing to file failed: ", _tmp15_, NULL);
#line 178 "../src/core/FileTransfer.vala"
			_tmp17_ = _tmp16_;
#line 178 "../src/core/FileTransfer.vala"
			_tmp18_ = g_error_new_literal (VENOM_FILE_TRANSFER_ERROR, VENOM_FILE_TRANSFER_ERROR_WRITE, _tmp17_);
#line 178 "../src/core/FileTransfer.vala"
			_tmp19_ = _tmp18_;
#line 178 "../src/core/FileTransfer.vala"
			_g_free0 (_tmp17_);
#line 178 "../src/core/FileTransfer.vala"
			_inner_error0_ = _tmp19_;
#line 178 "../src/core/FileTransfer.vala"
			_g_error_free0 (e);
#line 1091 "FileTransfer.c"
			goto __finally0;
		}
		__finally0:
#line 172 "../src/core/FileTransfer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/core/FileTransfer.vala"
			g_propagate_error (error, _inner_error0_);
#line 172 "../src/core/FileTransfer.vala"
			buf = (g_free (buf), NULL);
#line 172 "../src/core/FileTransfer.vala"
			return NULL;
#line 1103 "FileTransfer.c"
		}
	}
#line 182 "../src/core/FileTransfer.vala"
	self->priv->transmitted_size = self->priv->transmitted_size + length;
#line 183 "../src/core/FileTransfer.vala"
	g_signal_emit ((VenomFileTransfer*) self, venom_file_transfer_signals[VENOM_FILE_TRANSFER_PROGRESS_CHANGED_SIGNAL], 0);
#line 184 "../src/core/FileTransfer.vala"
	_tmp20_ = buf;
#line 184 "../src/core/FileTransfer.vala"
	_tmp20__length1 = buf_length1;
#line 184 "../src/core/FileTransfer.vala"
	if (result_length1) {
#line 184 "../src/core/FileTransfer.vala"
		*result_length1 = _tmp20__length1;
#line 1118 "FileTransfer.c"
	}
#line 184 "../src/core/FileTransfer.vala"
	result = _tmp20_;
#line 184 "../src/core/FileTransfer.vala"
	return result;
#line 1124 "FileTransfer.c"
}

static guint8*
venom_file_transfer_impl_real_get_avatar_buffer (VenomFileTransfer* base,
                                                 gint* result_length1)
{
	VenomFileTransferImpl * self;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* result = NULL;
#line 187 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 188 "../src/core/FileTransfer.vala"
	_tmp0_ = self->priv->avatar_buffer;
#line 188 "../src/core/FileTransfer.vala"
	_tmp0__length1 = self->priv->avatar_buffer_length1;
#line 188 "../src/core/FileTransfer.vala"
	_tmp1_ = _tmp0_;
#line 188 "../src/core/FileTransfer.vala"
	_tmp1__length1 = _tmp0__length1;
#line 188 "../src/core/FileTransfer.vala"
	if (result_length1) {
#line 188 "../src/core/FileTransfer.vala"
		*result_length1 = _tmp1__length1;
#line 1151 "FileTransfer.c"
	}
#line 188 "../src/core/FileTransfer.vala"
	result = _tmp1_;
#line 188 "../src/core/FileTransfer.vala"
	return result;
#line 1157 "FileTransfer.c"
}

static VenomFileTransferState
venom_file_transfer_impl_real_get_state (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	VenomFileTransferState _tmp0_;
	VenomFileTransferState result = 0;
#line 191 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 192 "../src/core/FileTransfer.vala"
	_tmp0_ = self->priv->state;
#line 192 "../src/core/FileTransfer.vala"
	result = _tmp0_;
#line 192 "../src/core/FileTransfer.vala"
	return result;
#line 1174 "FileTransfer.c"
}

static void
venom_file_transfer_impl_real_set_state (VenomFileTransfer* base,
                                         VenomFileTransferState state)
{
	VenomFileTransferImpl * self;
#line 195 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 196 "../src/core/FileTransfer.vala"
	self->priv->state = state;
#line 197 "../src/core/FileTransfer.vala"
	g_signal_emit ((VenomFileTransfer*) self, venom_file_transfer_signals[VENOM_FILE_TRANSFER_STATE_CHANGED_SIGNAL], 0);
#line 1188 "FileTransfer.c"
}

static guint32
venom_file_transfer_impl_real_get_friend_number (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	guint32 result = 0U;
#line 200 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 201 "../src/core/FileTransfer.vala"
	result = self->priv->friend_number;
#line 201 "../src/core/FileTransfer.vala"
	return result;
#line 1202 "FileTransfer.c"
}

static guint32
venom_file_transfer_impl_real_get_file_number (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	guint32 result = 0U;
#line 204 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 205 "../src/core/FileTransfer.vala"
	result = self->priv->file_number;
#line 205 "../src/core/FileTransfer.vala"
	return result;
#line 1216 "FileTransfer.c"
}

static VenomFileTransferDirection
venom_file_transfer_impl_real_get_direction (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	VenomFileTransferDirection _tmp0_;
	VenomFileTransferDirection result = 0;
#line 208 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 209 "../src/core/FileTransfer.vala"
	_tmp0_ = self->priv->direction;
#line 209 "../src/core/FileTransfer.vala"
	result = _tmp0_;
#line 209 "../src/core/FileTransfer.vala"
	return result;
#line 1233 "FileTransfer.c"
}

static gchar*
venom_file_transfer_impl_real_get_file_name (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 212 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 213 "../src/core/FileTransfer.vala"
	_tmp0_ = self->priv->file_name;
#line 213 "../src/core/FileTransfer.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 213 "../src/core/FileTransfer.vala"
	result = _tmp1_;
#line 213 "../src/core/FileTransfer.vala"
	return result;
#line 1253 "FileTransfer.c"
}

static gchar*
venom_file_transfer_impl_real_get_file_path (VenomFileTransfer* base)
{
	VenomFileTransferImpl * self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 216 "../src/core/FileTransfer.vala"
	self = (VenomFileTransferImpl*) base;
#line 217 "../src/core/FileTransfer.vala"
	_tmp0_ = self->priv->file;
#line 217 "../src/core/FileTransfer.vala"
	if (_tmp0_ == NULL) {
#line 218 "../src/core/FileTransfer.vala"
		result = NULL;
#line 218 "../src/core/FileTransfer.vala"
		return result;
#line 1274 "FileTransfer.c"
	}
#line 220 "../src/core/FileTransfer.vala"
	_tmp1_ = self->priv->file;
#line 220 "../src/core/FileTransfer.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 220 "../src/core/FileTransfer.vala"
	result = _tmp2_;
#line 220 "../src/core/FileTransfer.vala"
	return result;
#line 1284 "FileTransfer.c"
}

static void
venom_file_transfer_impl_class_init (VenomFileTransferImplClass * klass,
                                     gpointer klass_data)
{
#line 67 "../src/core/FileTransfer.vala"
	venom_file_transfer_impl_parent_class = g_type_class_peek_parent (klass);
#line 67 "../src/core/FileTransfer.vala"
	g_type_class_adjust_private_offset (klass, &VenomFileTransferImpl_private_offset);
#line 67 "../src/core/FileTransfer.vala"
	G_OBJECT_CLASS (klass)->finalize = venom_file_transfer_impl_finalize;
#line 1297 "FileTransfer.c"
}

static void
venom_file_transfer_impl_venom_file_transfer_interface_init (VenomFileTransferIface * iface,
                                                             gpointer iface_data)
{
#line 67 "../src/core/FileTransfer.vala"
	venom_file_transfer_impl_venom_file_transfer_parent_iface = g_type_interface_peek_parent (iface);
#line 67 "../src/core/FileTransfer.vala"
	iface->init_file = (void (*) (VenomFileTransfer*, GFile*, GError**)) venom_file_transfer_impl_real_init_file;
#line 67 "../src/core/FileTransfer.vala"
	iface->is_avatar = (gboolean (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_is_avatar;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_transmitted_size = (guint64 (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_transmitted_size;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_file_size = (guint64 (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_file_size;
#line 67 "../src/core/FileTransfer.vala"
	iface->write_data = (void (*) (VenomFileTransfer*, guint8*, gint, GError**)) venom_file_transfer_impl_real_write_data;
#line 67 "../src/core/FileTransfer.vala"
	iface->read_data = (guint8* (*) (VenomFileTransfer*, guint64, gint*, GError**)) venom_file_transfer_impl_real_read_data;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_avatar_buffer = (guint8* (*) (VenomFileTransfer*, gint*)) venom_file_transfer_impl_real_get_avatar_buffer;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_state = (VenomFileTransferState (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_state;
#line 67 "../src/core/FileTransfer.vala"
	iface->set_state = (void (*) (VenomFileTransfer*, VenomFileTransferState)) venom_file_transfer_impl_real_set_state;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_friend_number = (guint32 (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_friend_number;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_file_number = (guint32 (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_file_number;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_direction = (VenomFileTransferDirection (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_direction;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_file_name = (gchar* (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_file_name;
#line 67 "../src/core/FileTransfer.vala"
	iface->get_file_path = (gchar* (*) (VenomFileTransfer*)) venom_file_transfer_impl_real_get_file_path;
#line 1334 "FileTransfer.c"
}

static void
venom_file_transfer_impl_instance_init (VenomFileTransferImpl * self,
                                        gpointer klass)
{
#line 67 "../src/core/FileTransfer.vala"
	self->priv = venom_file_transfer_impl_get_instance_private (self);
#line 1343 "FileTransfer.c"
}

static void
venom_file_transfer_impl_finalize (GObject * obj)
{
	VenomFileTransferImpl * self;
#line 67 "../src/core/FileTransfer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VENOM_TYPE_FILE_TRANSFER_IMPL, VenomFileTransferImpl);
#line 76 "../src/core/FileTransfer.vala"
	self->priv->avatar_buffer = (g_free (self->priv->avatar_buffer), NULL);
#line 78 "../src/core/FileTransfer.vala"
	_g_free0 (self->priv->file_name);
#line 79 "../src/core/FileTransfer.vala"
	_g_object_unref0 (self->priv->file);
#line 67 "../src/core/FileTransfer.vala"
	G_OBJECT_CLASS (venom_file_transfer_impl_parent_class)->finalize (obj);
#line 1360 "FileTransfer.c"
}

static GType
venom_file_transfer_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomFileTransferImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_file_transfer_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VenomFileTransferImpl), 0, (GInstanceInitFunc) venom_file_transfer_impl_instance_init, NULL };
	static const GInterfaceInfo venom_file_transfer_info = { (GInterfaceInitFunc) venom_file_transfer_impl_venom_file_transfer_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType venom_file_transfer_impl_type_id;
	venom_file_transfer_impl_type_id = g_type_register_static (G_TYPE_OBJECT, "VenomFileTransferImpl", &g_define_type_info, 0);
	g_type_add_interface_static (venom_file_transfer_impl_type_id, VENOM_TYPE_FILE_TRANSFER, &venom_file_transfer_info);
	VenomFileTransferImpl_private_offset = g_type_add_instance_private (venom_file_transfer_impl_type_id, sizeof (VenomFileTransferImplPrivate));
	return venom_file_transfer_impl_type_id;
}

GType
venom_file_transfer_impl_get_type (void)
{
	static volatile gsize venom_file_transfer_impl_type_id__volatile = 0;
	if (g_once_init_enter (&venom_file_transfer_impl_type_id__volatile)) {
		GType venom_file_transfer_impl_type_id;
		venom_file_transfer_impl_type_id = venom_file_transfer_impl_get_type_once ();
		g_once_init_leave (&venom_file_transfer_impl_type_id__volatile, venom_file_transfer_impl_type_id);
	}
	return venom_file_transfer_impl_type_id__volatile;
}

