/* Logger.c generated by valac 0.48.3, the Vala compiler
 * generated from Logger.vala, do not modify */

/*
 *    Logger.vala
 *
 *    Copyright (C) 2013-2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>

#define VENOM_TYPE_LOGGER (venom_logger_get_type ())
#define VENOM_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_LOGGER, VenomLogger))
#define VENOM_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_LOGGER))
#define VENOM_LOGGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VENOM_TYPE_LOGGER, VenomLoggerIface))

typedef struct _VenomLogger VenomLogger;
typedef struct _VenomLoggerIface VenomLoggerIface;
typedef enum  {
	VENOM_LOG_LEVEL_DEBUG,
	VENOM_LOG_LEVEL_INFO,
	VENOM_LOG_LEVEL_WARNING,
	VENOM_LOG_LEVEL_ERROR,
	VENOM_LOG_LEVEL_FATAL
} VenomLogLevel;

#define VENOM_TYPE_LOG_LEVEL (venom_log_level_get_type ())

#define VENOM_TYPE_COMMAND_LINE_LOGGER (venom_command_line_logger_get_type ())
#define VENOM_COMMAND_LINE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_COMMAND_LINE_LOGGER, VenomCommandLineLogger))
#define VENOM_COMMAND_LINE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VENOM_TYPE_COMMAND_LINE_LOGGER, VenomCommandLineLoggerClass))
#define VENOM_IS_COMMAND_LINE_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_COMMAND_LINE_LOGGER))
#define VENOM_IS_COMMAND_LINE_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VENOM_TYPE_COMMAND_LINE_LOGGER))
#define VENOM_COMMAND_LINE_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VENOM_TYPE_COMMAND_LINE_LOGGER, VenomCommandLineLoggerClass))

typedef struct _VenomCommandLineLogger VenomCommandLineLogger;
typedef struct _VenomCommandLineLoggerClass VenomCommandLineLoggerClass;
typedef struct _VenomCommandLineLoggerPrivate VenomCommandLineLoggerPrivate;
enum  {
	VENOM_COMMAND_LINE_LOGGER_0_PROPERTY,
	VENOM_COMMAND_LINE_LOGGER_NUM_PROPERTIES
};
static GParamSpec* venom_command_line_logger_properties[VENOM_COMMAND_LINE_LOGGER_NUM_PROPERTIES];
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _VenomLoggerIface {
	GTypeInterface parent_iface;
	void (*d) (VenomLogger* self, const gchar* message);
	void (*i) (VenomLogger* self, const gchar* message);
	void (*w) (VenomLogger* self, const gchar* message);
	void (*e) (VenomLogger* self, const gchar* message);
	void (*f) (VenomLogger* self, const gchar* message);
	gchar* (*get_log) (VenomLogger* self);
	void (*attach_to_glib) (VenomLogger* self);
};

struct _VenomCommandLineLogger {
	GObject parent_instance;
	VenomCommandLineLoggerPrivate * priv;
};

struct _VenomCommandLineLoggerClass {
	GObjectClass parent_class;
};

struct _VenomCommandLineLoggerPrivate {
	GString* log_builder;
};

static gint VenomCommandLineLogger_private_offset;
static gpointer venom_command_line_logger_parent_class = NULL;
static VenomLogLevel venom_command_line_logger__displayed_level;
static VenomLogLevel venom_command_line_logger__displayed_level = VENOM_LOG_LEVEL_WARNING;
static VenomLoggerIface * venom_command_line_logger_venom_logger_parent_iface = NULL;

GType venom_logger_get_type (void) G_GNUC_CONST;
void venom_logger_d (VenomLogger* self,
                     const gchar* message);
void venom_logger_i (VenomLogger* self,
                     const gchar* message);
void venom_logger_w (VenomLogger* self,
                     const gchar* message);
void venom_logger_e (VenomLogger* self,
                     const gchar* message);
void venom_logger_f (VenomLogger* self,
                     const gchar* message);
gchar* venom_logger_get_log (VenomLogger* self);
void venom_logger_attach_to_glib (VenomLogger* self);
static GType venom_logger_get_type_once (void);
#define VENOM_TERM_COLOR_BLACK "\x1B[30m"
#define VENOM_TERM_COLOR_RED "\x1B[31m"
#define VENOM_TERM_COLOR_GREEN "\x1B[32m"
#define VENOM_TERM_COLOR_YELLOW "\x1B[33m"
#define VENOM_TERM_COLOR_BLUE "\x1B[34m"
#define VENOM_TERM_COLOR_MAGENTA "\x1B[35m"
#define VENOM_TERM_COLOR_CYAN "\x1B[36m"
#define VENOM_TERM_COLOR_WHITE "\x1B[37m"
#define VENOM_TERM_COLOR_RESET "\x1B[0m"
#define VENOM_TERM_COLOR_INFO VENOM_TERM_COLOR_GREEN
#define VENOM_TERM_COLOR_WARNING VENOM_TERM_COLOR_YELLOW
#define VENOM_TERM_COLOR_ERROR VENOM_TERM_COLOR_RED
#define VENOM_TERM_COLOR_FATAL VENOM_TERM_COLOR_MAGENTA
gchar* venom_pango_helper_insert_span (const gchar* attributes,
                                       const gchar* content);
gchar* venom_pango_helper_bold (const gchar* text);
GType venom_log_level_get_type (void) G_GNUC_CONST;
gchar* venom_log_level_to_string (VenomLogLevel self);
gchar* venom_log_level_to_markup (VenomLogLevel self);
GType venom_command_line_logger_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VenomCommandLineLogger, g_object_unref)
static gchar* venom_command_line_logger_real_get_log (VenomLogger* base);
VenomCommandLineLogger* venom_command_line_logger_new (void);
VenomCommandLineLogger* venom_command_line_logger_construct (GType object_type);
static void venom_command_line_logger_real_d (VenomLogger* base,
                                       const gchar* message);
void venom_command_line_logger_log (VenomCommandLineLogger* self,
                                    VenomLogLevel level,
                                    const gchar* message);
static void venom_command_line_logger_real_i (VenomLogger* base,
                                       const gchar* message);
static void venom_command_line_logger_real_w (VenomLogger* base,
                                       const gchar* message);
static void venom_command_line_logger_real_e (VenomLogger* base,
                                       const gchar* message);
static void venom_command_line_logger_real_f (VenomLogger* base,
                                       const gchar* message);
static void venom_command_line_logger_glib_log_function (VenomCommandLineLogger* self,
                                                  const gchar* log_domain,
                                                  GLogLevelFlags log_levels,
                                                  const gchar* message);
static void venom_command_line_logger_real_attach_to_glib (VenomLogger* base);
static void _venom_command_line_logger_glib_log_function_glog_func (const gchar* log_domain,
                                                             GLogLevelFlags log_levels,
                                                             const gchar* message,
                                                             gpointer self);
VenomLogLevel venom_command_line_logger_get_displayed_level (void);
void venom_command_line_logger_set_displayed_level (VenomLogLevel value);
static void venom_command_line_logger_finalize (GObject * obj);
static GType venom_command_line_logger_get_type_once (void);
static void _vala_venom_command_line_logger_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_venom_command_line_logger_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

void
venom_logger_d (VenomLogger* self,
                const gchar* message)
{
#line 24 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/core/Logger.vala"
	VENOM_LOGGER_GET_INTERFACE (self)->d (self, message);
#line 178 "Logger.c"
}

void
venom_logger_i (VenomLogger* self,
                const gchar* message)
{
#line 25 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/core/Logger.vala"
	VENOM_LOGGER_GET_INTERFACE (self)->i (self, message);
#line 189 "Logger.c"
}

void
venom_logger_w (VenomLogger* self,
                const gchar* message)
{
#line 26 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/core/Logger.vala"
	VENOM_LOGGER_GET_INTERFACE (self)->w (self, message);
#line 200 "Logger.c"
}

void
venom_logger_e (VenomLogger* self,
                const gchar* message)
{
#line 27 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/core/Logger.vala"
	VENOM_LOGGER_GET_INTERFACE (self)->e (self, message);
#line 211 "Logger.c"
}

void
venom_logger_f (VenomLogger* self,
                const gchar* message)
{
#line 28 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/core/Logger.vala"
	VENOM_LOGGER_GET_INTERFACE (self)->f (self, message);
#line 222 "Logger.c"
}

gchar*
venom_logger_get_log (VenomLogger* self)
{
#line 29 "../src/core/Logger.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/core/Logger.vala"
	return VENOM_LOGGER_GET_INTERFACE (self)->get_log (self);
#line 232 "Logger.c"
}

void
venom_logger_attach_to_glib (VenomLogger* self)
{
#line 30 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/core/Logger.vala"
	VENOM_LOGGER_GET_INTERFACE (self)->attach_to_glib (self);
#line 242 "Logger.c"
}

static void
venom_logger_default_init (VenomLoggerIface * iface,
                           gpointer iface_data)
{
}

static GType
venom_logger_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomLoggerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_logger_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType venom_logger_type_id;
	venom_logger_type_id = g_type_register_static (G_TYPE_INTERFACE, "VenomLogger", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (venom_logger_type_id, G_TYPE_OBJECT);
	return venom_logger_type_id;
}

GType
venom_logger_get_type (void)
{
	static volatile gsize venom_logger_type_id__volatile = 0;
	if (g_once_init_enter (&venom_logger_type_id__volatile)) {
		GType venom_logger_type_id;
		venom_logger_type_id = venom_logger_get_type_once ();
		g_once_init_leave (&venom_logger_type_id__volatile, venom_logger_type_id);
	}
	return venom_logger_type_id__volatile;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1570 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1571 "glib-2.0.vapi"
	result = self;
#line 1571 "glib-2.0.vapi"
	return result;
#line 283 "Logger.c"
}

gchar*
venom_pango_helper_insert_span (const gchar* attributes,
                                const gchar* content)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 52 "../src/core/Logger.vala"
	g_return_val_if_fail (attributes != NULL, NULL);
#line 52 "../src/core/Logger.vala"
	g_return_val_if_fail (content != NULL, NULL);
#line 53 "../src/core/Logger.vala"
	_tmp0_ = string_to_string (attributes);
#line 53 "../src/core/Logger.vala"
	_tmp1_ = string_to_string (content);
#line 53 "../src/core/Logger.vala"
	_tmp2_ = g_strconcat ("<span ", _tmp0_, ">", _tmp1_, "</span>", NULL);
#line 53 "../src/core/Logger.vala"
	result = _tmp2_;
#line 53 "../src/core/Logger.vala"
	return result;
#line 308 "Logger.c"
}

gchar*
venom_pango_helper_bold (const gchar* text)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 55 "../src/core/Logger.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 56 "../src/core/Logger.vala"
	_tmp0_ = string_to_string (text);
#line 56 "../src/core/Logger.vala"
	_tmp1_ = g_strconcat ("<b>", _tmp0_, "</b>", NULL);
#line 56 "../src/core/Logger.vala"
	result = _tmp1_;
#line 56 "../src/core/Logger.vala"
	return result;
#line 327 "Logger.c"
}

gchar*
venom_log_level_to_string (VenomLogLevel self)
{
	gchar* result = NULL;
#line 68 "../src/core/Logger.vala"
	switch (self) {
#line 68 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_DEBUG:
#line 338 "Logger.c"
		{
			gchar* _tmp0_;
#line 70 "../src/core/Logger.vala"
			_tmp0_ = g_strdup ("DEBUG");
#line 70 "../src/core/Logger.vala"
			result = _tmp0_;
#line 70 "../src/core/Logger.vala"
			return result;
#line 347 "Logger.c"
		}
#line 68 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_INFO:
#line 351 "Logger.c"
		{
			gchar* _tmp1_;
#line 72 "../src/core/Logger.vala"
			_tmp1_ = g_strdup (VENOM_TERM_COLOR_INFO "INFO " VENOM_TERM_COLOR_RESET);
#line 72 "../src/core/Logger.vala"
			result = _tmp1_;
#line 72 "../src/core/Logger.vala"
			return result;
#line 360 "Logger.c"
		}
#line 68 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_WARNING:
#line 364 "Logger.c"
		{
			gchar* _tmp2_;
#line 74 "../src/core/Logger.vala"
			_tmp2_ = g_strdup (VENOM_TERM_COLOR_WARNING "WARN " VENOM_TERM_COLOR_RESET);
#line 74 "../src/core/Logger.vala"
			result = _tmp2_;
#line 74 "../src/core/Logger.vala"
			return result;
#line 373 "Logger.c"
		}
#line 68 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_ERROR:
#line 377 "Logger.c"
		{
			gchar* _tmp3_;
#line 76 "../src/core/Logger.vala"
			_tmp3_ = g_strdup (VENOM_TERM_COLOR_ERROR "ERROR" VENOM_TERM_COLOR_RESET);
#line 76 "../src/core/Logger.vala"
			result = _tmp3_;
#line 76 "../src/core/Logger.vala"
			return result;
#line 386 "Logger.c"
		}
#line 68 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_FATAL:
#line 390 "Logger.c"
		{
			gchar* _tmp4_;
#line 78 "../src/core/Logger.vala"
			_tmp4_ = g_strdup (VENOM_TERM_COLOR_FATAL "FATAL" VENOM_TERM_COLOR_RESET);
#line 78 "../src/core/Logger.vala"
			result = _tmp4_;
#line 78 "../src/core/Logger.vala"
			return result;
#line 399 "Logger.c"
		}
		default:
		{
#line 80 "../src/core/Logger.vala"
			g_assert_not_reached ();
#line 405 "Logger.c"
		}
	}
}

gchar*
venom_log_level_to_markup (VenomLogLevel self)
{
	gchar* result = NULL;
#line 85 "../src/core/Logger.vala"
	switch (self) {
#line 85 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_DEBUG:
#line 418 "Logger.c"
		{
			gchar* _tmp0_;
#line 87 "../src/core/Logger.vala"
			_tmp0_ = g_strdup ("DEBUG");
#line 87 "../src/core/Logger.vala"
			result = _tmp0_;
#line 87 "../src/core/Logger.vala"
			return result;
#line 427 "Logger.c"
		}
#line 85 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_INFO:
#line 431 "Logger.c"
		{
			gchar* _tmp1_;
#line 89 "../src/core/Logger.vala"
			_tmp1_ = venom_pango_helper_insert_span ("foreground=\"green\"", "INFO ");
#line 89 "../src/core/Logger.vala"
			result = _tmp1_;
#line 89 "../src/core/Logger.vala"
			return result;
#line 440 "Logger.c"
		}
#line 85 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_WARNING:
#line 444 "Logger.c"
		{
			gchar* _tmp2_;
#line 91 "../src/core/Logger.vala"
			_tmp2_ = venom_pango_helper_insert_span ("foreground=\"yellow\"", "WARN ");
#line 91 "../src/core/Logger.vala"
			result = _tmp2_;
#line 91 "../src/core/Logger.vala"
			return result;
#line 453 "Logger.c"
		}
#line 85 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_ERROR:
#line 457 "Logger.c"
		{
			gchar* _tmp3_;
#line 93 "../src/core/Logger.vala"
			_tmp3_ = venom_pango_helper_insert_span ("foreground=\"red\"", "ERROR");
#line 93 "../src/core/Logger.vala"
			result = _tmp3_;
#line 93 "../src/core/Logger.vala"
			return result;
#line 466 "Logger.c"
		}
#line 85 "../src/core/Logger.vala"
		case VENOM_LOG_LEVEL_FATAL:
#line 470 "Logger.c"
		{
			gchar* _tmp4_;
#line 95 "../src/core/Logger.vala"
			_tmp4_ = venom_pango_helper_insert_span ("foreground=\"magenta\"", "FATAL");
#line 95 "../src/core/Logger.vala"
			result = _tmp4_;
#line 95 "../src/core/Logger.vala"
			return result;
#line 479 "Logger.c"
		}
		default:
		{
#line 97 "../src/core/Logger.vala"
			g_assert_not_reached ();
#line 485 "Logger.c"
		}
	}
}

static GType
venom_log_level_get_type_once (void)
{
	static const GEnumValue values[] = {{VENOM_LOG_LEVEL_DEBUG, "VENOM_LOG_LEVEL_DEBUG", "debug"}, {VENOM_LOG_LEVEL_INFO, "VENOM_LOG_LEVEL_INFO", "info"}, {VENOM_LOG_LEVEL_WARNING, "VENOM_LOG_LEVEL_WARNING", "warning"}, {VENOM_LOG_LEVEL_ERROR, "VENOM_LOG_LEVEL_ERROR", "error"}, {VENOM_LOG_LEVEL_FATAL, "VENOM_LOG_LEVEL_FATAL", "fatal"}, {0, NULL, NULL}};
	GType venom_log_level_type_id;
	venom_log_level_type_id = g_enum_register_static ("VenomLogLevel", values);
	return venom_log_level_type_id;
}

GType
venom_log_level_get_type (void)
{
	static volatile gsize venom_log_level_type_id__volatile = 0;
	if (g_once_init_enter (&venom_log_level_type_id__volatile)) {
		GType venom_log_level_type_id;
		venom_log_level_type_id = venom_log_level_get_type_once ();
		g_once_init_leave (&venom_log_level_type_id__volatile, venom_log_level_type_id);
	}
	return venom_log_level_type_id__volatile;
}

static inline gpointer
venom_command_line_logger_get_instance_private (VenomCommandLineLogger* self)
{
	return G_STRUCT_MEMBER_P (self, VenomCommandLineLogger_private_offset);
}

static gchar*
venom_command_line_logger_real_get_log (VenomLogger* base)
{
	VenomCommandLineLogger * self;
	GString* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
#line 105 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) base;
#line 106 "../src/core/Logger.vala"
	_tmp0_ = self->priv->log_builder;
#line 106 "../src/core/Logger.vala"
	_tmp1_ = _tmp0_->str;
#line 106 "../src/core/Logger.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 106 "../src/core/Logger.vala"
	result = _tmp2_;
#line 106 "../src/core/Logger.vala"
	return result;
#line 537 "Logger.c"
}

VenomCommandLineLogger*
venom_command_line_logger_construct (GType object_type)
{
	VenomCommandLineLogger * self = NULL;
	GString* _tmp0_;
#line 109 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) g_object_new (object_type, NULL);
#line 110 "../src/core/Logger.vala"
	_tmp0_ = g_string_new ("");
#line 110 "../src/core/Logger.vala"
	_g_string_free0 (self->priv->log_builder);
#line 110 "../src/core/Logger.vala"
	self->priv->log_builder = _tmp0_;
#line 111 "../src/core/Logger.vala"
	venom_logger_d ((VenomLogger*) self, "CommandLineLogger created.");
#line 109 "../src/core/Logger.vala"
	return self;
#line 557 "Logger.c"
}

VenomCommandLineLogger*
venom_command_line_logger_new (void)
{
#line 109 "../src/core/Logger.vala"
	return venom_command_line_logger_construct (VENOM_TYPE_COMMAND_LINE_LOGGER);
#line 565 "Logger.c"
}

static void
venom_command_line_logger_real_d (VenomLogger* base,
                                  const gchar* message)
{
	VenomCommandLineLogger * self;
#line 118 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) base;
#line 118 "../src/core/Logger.vala"
	g_return_if_fail (message != NULL);
#line 119 "../src/core/Logger.vala"
	venom_command_line_logger_log (self, VENOM_LOG_LEVEL_DEBUG, message);
#line 579 "Logger.c"
}

static void
venom_command_line_logger_real_i (VenomLogger* base,
                                  const gchar* message)
{
	VenomCommandLineLogger * self;
#line 122 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) base;
#line 122 "../src/core/Logger.vala"
	g_return_if_fail (message != NULL);
#line 123 "../src/core/Logger.vala"
	venom_command_line_logger_log (self, VENOM_LOG_LEVEL_INFO, message);
#line 593 "Logger.c"
}

static void
venom_command_line_logger_real_w (VenomLogger* base,
                                  const gchar* message)
{
	VenomCommandLineLogger * self;
#line 126 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) base;
#line 126 "../src/core/Logger.vala"
	g_return_if_fail (message != NULL);
#line 127 "../src/core/Logger.vala"
	venom_command_line_logger_log (self, VENOM_LOG_LEVEL_WARNING, message);
#line 607 "Logger.c"
}

static void
venom_command_line_logger_real_e (VenomLogger* base,
                                  const gchar* message)
{
	VenomCommandLineLogger * self;
#line 130 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) base;
#line 130 "../src/core/Logger.vala"
	g_return_if_fail (message != NULL);
#line 131 "../src/core/Logger.vala"
	venom_command_line_logger_log (self, VENOM_LOG_LEVEL_ERROR, message);
#line 621 "Logger.c"
}

static void
venom_command_line_logger_real_f (VenomLogger* base,
                                  const gchar* message)
{
	VenomCommandLineLogger * self;
#line 134 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) base;
#line 134 "../src/core/Logger.vala"
	g_return_if_fail (message != NULL);
#line 135 "../src/core/Logger.vala"
	venom_command_line_logger_log (self, VENOM_LOG_LEVEL_FATAL, message);
#line 635 "Logger.c"
}

static void
venom_command_line_logger_glib_log_function (VenomCommandLineLogger* self,
                                             const gchar* log_domain,
                                             GLogLevelFlags log_levels,
                                             const gchar* message)
{
	gchar* _tmp0_ = NULL;
	gchar* concatMessage = NULL;
	gchar* _tmp5_;
#line 138 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/core/Logger.vala"
	g_return_if_fail (message != NULL);
#line 139 "../src/core/Logger.vala"
	if (log_domain != NULL) {
#line 653 "Logger.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 140 "../src/core/Logger.vala"
		_tmp1_ = g_strconcat (log_domain, " : ", NULL);
#line 140 "../src/core/Logger.vala"
		_tmp2_ = _tmp1_;
#line 140 "../src/core/Logger.vala"
		_tmp3_ = g_strconcat (_tmp2_, message, NULL);
#line 140 "../src/core/Logger.vala"
		_g_free0 (_tmp0_);
#line 140 "../src/core/Logger.vala"
		_tmp0_ = _tmp3_;
#line 140 "../src/core/Logger.vala"
		_g_free0 (_tmp2_);
#line 669 "Logger.c"
	} else {
		gchar* _tmp4_;
#line 141 "../src/core/Logger.vala"
		_tmp4_ = g_strdup (message);
#line 141 "../src/core/Logger.vala"
		_g_free0 (_tmp0_);
#line 141 "../src/core/Logger.vala"
		_tmp0_ = _tmp4_;
#line 678 "Logger.c"
	}
#line 139 "../src/core/Logger.vala"
	_tmp5_ = g_strdup (_tmp0_);
#line 139 "../src/core/Logger.vala"
	concatMessage = _tmp5_;
#line 142 "../src/core/Logger.vala"
	switch (log_levels) {
#line 142 "../src/core/Logger.vala"
		case G_LOG_FLAG_FATAL:
#line 142 "../src/core/Logger.vala"
		case G_LOG_LEVEL_CRITICAL:
#line 690 "Logger.c"
		{
			const gchar* _tmp6_;
#line 145 "../src/core/Logger.vala"
			_tmp6_ = concatMessage;
#line 145 "../src/core/Logger.vala"
			venom_logger_f ((VenomLogger*) self, _tmp6_);
#line 146 "../src/core/Logger.vala"
			break;
#line 699 "Logger.c"
		}
#line 142 "../src/core/Logger.vala"
		case G_LOG_LEVEL_ERROR:
#line 703 "Logger.c"
		{
			const gchar* _tmp7_;
#line 148 "../src/core/Logger.vala"
			_tmp7_ = concatMessage;
#line 148 "../src/core/Logger.vala"
			venom_logger_e ((VenomLogger*) self, _tmp7_);
#line 149 "../src/core/Logger.vala"
			break;
#line 712 "Logger.c"
		}
#line 142 "../src/core/Logger.vala"
		case G_LOG_LEVEL_WARNING:
#line 716 "Logger.c"
		{
			const gchar* _tmp8_;
#line 151 "../src/core/Logger.vala"
			_tmp8_ = concatMessage;
#line 151 "../src/core/Logger.vala"
			venom_logger_w ((VenomLogger*) self, _tmp8_);
#line 152 "../src/core/Logger.vala"
			break;
#line 725 "Logger.c"
		}
#line 142 "../src/core/Logger.vala"
		case G_LOG_LEVEL_INFO:
#line 729 "Logger.c"
		{
			const gchar* _tmp9_;
#line 154 "../src/core/Logger.vala"
			_tmp9_ = concatMessage;
#line 154 "../src/core/Logger.vala"
			venom_logger_i ((VenomLogger*) self, _tmp9_);
#line 155 "../src/core/Logger.vala"
			break;
#line 738 "Logger.c"
		}
#line 142 "../src/core/Logger.vala"
		case G_LOG_LEVEL_DEBUG:
#line 742 "Logger.c"
		{
			const gchar* _tmp10_;
#line 157 "../src/core/Logger.vala"
			_tmp10_ = concatMessage;
#line 157 "../src/core/Logger.vala"
			venom_logger_d ((VenomLogger*) self, _tmp10_);
#line 158 "../src/core/Logger.vala"
			break;
#line 751 "Logger.c"
		}
		default:
		{
			const gchar* _tmp11_;
#line 160 "../src/core/Logger.vala"
			_tmp11_ = concatMessage;
#line 160 "../src/core/Logger.vala"
			venom_logger_w ((VenomLogger*) self, _tmp11_);
#line 161 "../src/core/Logger.vala"
			break;
#line 762 "Logger.c"
		}
	}
#line 138 "../src/core/Logger.vala"
	_g_free0 (concatMessage);
#line 138 "../src/core/Logger.vala"
	_g_free0 (_tmp0_);
#line 769 "Logger.c"
}

static void
_venom_command_line_logger_glib_log_function_glog_func (const gchar* log_domain,
                                                        GLogLevelFlags log_levels,
                                                        const gchar* message,
                                                        gpointer self)
{
#line 167 "../src/core/Logger.vala"
	venom_command_line_logger_glib_log_function ((VenomCommandLineLogger*) self, log_domain, log_levels, message);
#line 780 "Logger.c"
}

static void
venom_command_line_logger_real_attach_to_glib (VenomLogger* base)
{
	VenomCommandLineLogger * self;
#line 165 "../src/core/Logger.vala"
	self = (VenomCommandLineLogger*) base;
#line 167 "../src/core/Logger.vala"
	g_log_set_handler (NULL, G_LOG_LEVEL_MASK, _venom_command_line_logger_glib_log_function_glog_func, self);
#line 168 "../src/core/Logger.vala"
	g_log_set_handler ("GLib", G_LOG_LEVEL_MASK, _venom_command_line_logger_glib_log_function_glog_func, self);
#line 169 "../src/core/Logger.vala"
	g_log_set_handler ("GLib-GObject", G_LOG_LEVEL_MASK, _venom_command_line_logger_glib_log_function_glog_func, self);
#line 170 "../src/core/Logger.vala"
	g_log_set_handler ("Gdk", G_LOG_LEVEL_MASK, _venom_command_line_logger_glib_log_function_glog_func, self);
#line 171 "../src/core/Logger.vala"
	g_log_set_handler ("Json", G_LOG_LEVEL_MASK, _venom_command_line_logger_glib_log_function_glog_func, self);
#line 799 "Logger.c"
}

void
venom_command_line_logger_log (VenomCommandLineLogger* self,
                               VenomLogLevel level,
                               const gchar* message)
{
	GString* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	VenomLogLevel _tmp5_;
	VenomLogLevel _tmp6_;
	FILE* _tmp7_ = NULL;
	FILE* s = NULL;
	FILE* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
#line 174 "../src/core/Logger.vala"
	g_return_if_fail (self != NULL);
#line 174 "../src/core/Logger.vala"
	g_return_if_fail (message != NULL);
#line 175 "../src/core/Logger.vala"
	_tmp0_ = self->priv->log_builder;
#line 175 "../src/core/Logger.vala"
	_tmp1_ = venom_log_level_to_markup (level);
#line 175 "../src/core/Logger.vala"
	_tmp2_ = _tmp1_;
#line 175 "../src/core/Logger.vala"
	_tmp3_ = g_strdup_printf ("[%s] %s\n", _tmp2_, message);
#line 175 "../src/core/Logger.vala"
	_tmp4_ = _tmp3_;
#line 175 "../src/core/Logger.vala"
	g_string_append (_tmp0_, _tmp4_);
#line 175 "../src/core/Logger.vala"
	_g_free0 (_tmp4_);
#line 175 "../src/core/Logger.vala"
	_g_free0 (_tmp2_);
#line 177 "../src/core/Logger.vala"
	_tmp5_ = venom_command_line_logger_get_displayed_level ();
#line 177 "../src/core/Logger.vala"
	_tmp6_ = _tmp5_;
#line 177 "../src/core/Logger.vala"
	if (level < _tmp6_) {
#line 178 "../src/core/Logger.vala"
		return;
#line 847 "Logger.c"
	}
#line 181 "../src/core/Logger.vala"
	if (level < VENOM_LOG_LEVEL_ERROR) {
#line 851 "Logger.c"
		FILE* _tmp8_;
#line 181 "../src/core/Logger.vala"
		_tmp8_ = stdout;
#line 181 "../src/core/Logger.vala"
		_tmp7_ = _tmp8_;
#line 857 "Logger.c"
	} else {
		FILE* _tmp9_;
#line 181 "../src/core/Logger.vala"
		_tmp9_ = stderr;
#line 181 "../src/core/Logger.vala"
		_tmp7_ = _tmp9_;
#line 864 "Logger.c"
	}
#line 181 "../src/core/Logger.vala"
	s = _tmp7_;
#line 182 "../src/core/Logger.vala"
	_tmp10_ = s;
#line 182 "../src/core/Logger.vala"
	_tmp11_ = venom_log_level_to_string (level);
#line 182 "../src/core/Logger.vala"
	_tmp12_ = _tmp11_;
#line 182 "../src/core/Logger.vala"
	fprintf (_tmp10_, "[%s] %s\n", _tmp12_, message);
#line 182 "../src/core/Logger.vala"
	_g_free0 (_tmp12_);
#line 878 "Logger.c"
}

VenomLogLevel
venom_command_line_logger_get_displayed_level (void)
{
	VenomLogLevel result;
	VenomLogLevel _tmp0_;
#line 103 "../src/core/Logger.vala"
	_tmp0_ = venom_command_line_logger__displayed_level;
#line 103 "../src/core/Logger.vala"
	result = _tmp0_;
#line 103 "../src/core/Logger.vala"
	return result;
#line 892 "Logger.c"
}

void
venom_command_line_logger_set_displayed_level (VenomLogLevel value)
{
#line 103 "../src/core/Logger.vala"
	venom_command_line_logger__displayed_level = value;
#line 900 "Logger.c"
}

static void
venom_command_line_logger_class_init (VenomCommandLineLoggerClass * klass,
                                      gpointer klass_data)
{
#line 102 "../src/core/Logger.vala"
	venom_command_line_logger_parent_class = g_type_class_peek_parent (klass);
#line 102 "../src/core/Logger.vala"
	g_type_class_adjust_private_offset (klass, &VenomCommandLineLogger_private_offset);
#line 102 "../src/core/Logger.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_venom_command_line_logger_get_property;
#line 102 "../src/core/Logger.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_venom_command_line_logger_set_property;
#line 102 "../src/core/Logger.vala"
	G_OBJECT_CLASS (klass)->finalize = venom_command_line_logger_finalize;
#line 917 "Logger.c"
}

static void
venom_command_line_logger_venom_logger_interface_init (VenomLoggerIface * iface,
                                                       gpointer iface_data)
{
#line 102 "../src/core/Logger.vala"
	venom_command_line_logger_venom_logger_parent_iface = g_type_interface_peek_parent (iface);
#line 102 "../src/core/Logger.vala"
	iface->get_log = (gchar* (*) (VenomLogger*)) venom_command_line_logger_real_get_log;
#line 102 "../src/core/Logger.vala"
	iface->d = (void (*) (VenomLogger*, const gchar*)) venom_command_line_logger_real_d;
#line 102 "../src/core/Logger.vala"
	iface->i = (void (*) (VenomLogger*, const gchar*)) venom_command_line_logger_real_i;
#line 102 "../src/core/Logger.vala"
	iface->w = (void (*) (VenomLogger*, const gchar*)) venom_command_line_logger_real_w;
#line 102 "../src/core/Logger.vala"
	iface->e = (void (*) (VenomLogger*, const gchar*)) venom_command_line_logger_real_e;
#line 102 "../src/core/Logger.vala"
	iface->f = (void (*) (VenomLogger*, const gchar*)) venom_command_line_logger_real_f;
#line 102 "../src/core/Logger.vala"
	iface->attach_to_glib = (void (*) (VenomLogger*)) venom_command_line_logger_real_attach_to_glib;
#line 940 "Logger.c"
}

static void
venom_command_line_logger_instance_init (VenomCommandLineLogger * self,
                                         gpointer klass)
{
#line 102 "../src/core/Logger.vala"
	self->priv = venom_command_line_logger_get_instance_private (self);
#line 949 "Logger.c"
}

static void
venom_command_line_logger_finalize (GObject * obj)
{
	VenomCommandLineLogger * self;
#line 102 "../src/core/Logger.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VENOM_TYPE_COMMAND_LINE_LOGGER, VenomCommandLineLogger);
#line 115 "../src/core/Logger.vala"
	venom_logger_d ((VenomLogger*) self, "CommandLineLogger destroyed.");
#line 104 "../src/core/Logger.vala"
	_g_string_free0 (self->priv->log_builder);
#line 102 "../src/core/Logger.vala"
	G_OBJECT_CLASS (venom_command_line_logger_parent_class)->finalize (obj);
#line 964 "Logger.c"
}

static GType
venom_command_line_logger_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomCommandLineLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_command_line_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VenomCommandLineLogger), 0, (GInstanceInitFunc) venom_command_line_logger_instance_init, NULL };
	static const GInterfaceInfo venom_logger_info = { (GInterfaceInitFunc) venom_command_line_logger_venom_logger_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType venom_command_line_logger_type_id;
	venom_command_line_logger_type_id = g_type_register_static (G_TYPE_OBJECT, "VenomCommandLineLogger", &g_define_type_info, 0);
	g_type_add_interface_static (venom_command_line_logger_type_id, VENOM_TYPE_LOGGER, &venom_logger_info);
	VenomCommandLineLogger_private_offset = g_type_add_instance_private (venom_command_line_logger_type_id, sizeof (VenomCommandLineLoggerPrivate));
	return venom_command_line_logger_type_id;
}

GType
venom_command_line_logger_get_type (void)
{
	static volatile gsize venom_command_line_logger_type_id__volatile = 0;
	if (g_once_init_enter (&venom_command_line_logger_type_id__volatile)) {
		GType venom_command_line_logger_type_id;
		venom_command_line_logger_type_id = venom_command_line_logger_get_type_once ();
		g_once_init_leave (&venom_command_line_logger_type_id__volatile, venom_command_line_logger_type_id);
	}
	return venom_command_line_logger_type_id__volatile;
}

static void
_vala_venom_command_line_logger_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	VenomCommandLineLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VENOM_TYPE_COMMAND_LINE_LOGGER, VenomCommandLineLogger);
#line 102 "../src/core/Logger.vala"
	switch (property_id) {
#line 1001 "Logger.c"
		default:
#line 102 "../src/core/Logger.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 102 "../src/core/Logger.vala"
		break;
#line 1007 "Logger.c"
	}
}

static void
_vala_venom_command_line_logger_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	VenomCommandLineLogger * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VENOM_TYPE_COMMAND_LINE_LOGGER, VenomCommandLineLogger);
#line 102 "../src/core/Logger.vala"
	switch (property_id) {
#line 1021 "Logger.c"
		default:
#line 102 "../src/core/Logger.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 102 "../src/core/Logger.vala"
		break;
#line 1027 "Logger.c"
	}
}

