/* Message.c generated by valac 0.48.3, the Vala compiler
 * generated from Message.vala, do not modify */

/*
 *    Message.vala
 *
 *    Copyright (C) 2013-2018  Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

typedef enum  {
	VENOM_MESSAGE_SENDER_REMOTE,
	VENOM_MESSAGE_SENDER_LOCAL,
	VENOM_MESSAGE_SENDER_SYSTEM
} VenomMessageSender;

#define VENOM_TYPE_MESSAGE_SENDER (venom_message_sender_get_type ())
typedef enum  {
	VENOM_TRANSMISSION_STATE_NONE,
	VENOM_TRANSMISSION_STATE_SENT,
	VENOM_TRANSMISSION_STATE_RECEIVED
} VenomTransmissionState;

#define VENOM_TYPE_TRANSMISSION_STATE (venom_transmission_state_get_type ())

#define VENOM_TYPE_MESSAGE (venom_message_get_type ())
#define VENOM_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_MESSAGE, VenomMessage))
#define VENOM_IS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_MESSAGE))
#define VENOM_MESSAGE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VENOM_TYPE_MESSAGE, VenomMessageIface))

typedef struct _VenomMessage VenomMessage;
typedef struct _VenomMessageIface VenomMessageIface;

#define VENOM_TYPE_FORMATTED_MESSAGE (venom_formatted_message_get_type ())
#define VENOM_FORMATTED_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_FORMATTED_MESSAGE, VenomFormattedMessage))
#define VENOM_IS_FORMATTED_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_FORMATTED_MESSAGE))
#define VENOM_FORMATTED_MESSAGE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VENOM_TYPE_FORMATTED_MESSAGE, VenomFormattedMessageIface))

typedef struct _VenomFormattedMessage VenomFormattedMessage;
typedef struct _VenomFormattedMessageIface VenomFormattedMessageIface;

struct _VenomMessageIface {
	GTypeInterface parent_iface;
	gboolean (*is_conference_message) (VenomMessage* self);
	gboolean (*equals_sender) (VenomMessage* self, VenomMessage* m);
	gint (*get_id) (VenomMessage* self);
	void (*set_id) (VenomMessage* self, gint value);
	gint (*get_peers_index) (VenomMessage* self);
	void (*set_peers_index) (VenomMessage* self, gint value);
	GDateTime* (*get_timestamp) (VenomMessage* self);
	void (*set_timestamp) (VenomMessage* self, GDateTime* value);
	VenomMessageSender (*get_sender) (VenomMessage* self);
	void (*set_sender) (VenomMessage* self, VenomMessageSender value);
	const gchar* (*get_message) (VenomMessage* self);
	void (*set_message) (VenomMessage* self, const gchar* value);
	gboolean (*get_is_action) (VenomMessage* self);
	void (*set_is_action) (VenomMessage* self, gboolean value);
	VenomTransmissionState (*get_state) (VenomMessage* self);
	void (*set_state) (VenomMessage* self, VenomTransmissionState value);
};

struct _VenomFormattedMessageIface {
	GTypeInterface parent_iface;
	gchar* (*get_sender_plain) (VenomFormattedMessage* self);
	gchar* (*get_sender_full) (VenomFormattedMessage* self);
	gchar* (*get_sender_id) (VenomFormattedMessage* self);
	gchar* (*get_conversation_id) (VenomFormattedMessage* self);
	gchar* (*get_message_plain) (VenomFormattedMessage* self);
	gchar* (*get_time_plain) (VenomFormattedMessage* self);
	GdkPixbuf* (*get_sender_image) (VenomFormattedMessage* self);
};

GType venom_message_sender_get_type (void) G_GNUC_CONST;
GType venom_transmission_state_get_type (void) G_GNUC_CONST;
GType venom_message_get_type (void) G_GNUC_CONST;
gboolean venom_message_is_conference_message (VenomMessage* self);
gboolean venom_message_equals_sender (VenomMessage* self,
                                      VenomMessage* m);
gint venom_message_get_id (VenomMessage* self);
void venom_message_set_id (VenomMessage* self,
                           gint value);
gint venom_message_get_peers_index (VenomMessage* self);
void venom_message_set_peers_index (VenomMessage* self,
                                    gint value);
GDateTime* venom_message_get_timestamp (VenomMessage* self);
void venom_message_set_timestamp (VenomMessage* self,
                                  GDateTime* value);
VenomMessageSender venom_message_get_sender (VenomMessage* self);
void venom_message_set_sender (VenomMessage* self,
                               VenomMessageSender value);
const gchar* venom_message_get_message (VenomMessage* self);
void venom_message_set_message (VenomMessage* self,
                                const gchar* value);
gboolean venom_message_get_is_action (VenomMessage* self);
void venom_message_set_is_action (VenomMessage* self,
                                  gboolean value);
VenomTransmissionState venom_message_get_state (VenomMessage* self);
void venom_message_set_state (VenomMessage* self,
                              VenomTransmissionState value);
static GType venom_message_get_type_once (void);
GType venom_formatted_message_get_type (void) G_GNUC_CONST;
gchar* venom_formatted_message_get_sender_plain (VenomFormattedMessage* self);
gchar* venom_formatted_message_get_sender_full (VenomFormattedMessage* self);
gchar* venom_formatted_message_get_sender_id (VenomFormattedMessage* self);
gchar* venom_formatted_message_get_conversation_id (VenomFormattedMessage* self);
gchar* venom_formatted_message_get_message_plain (VenomFormattedMessage* self);
gchar* venom_formatted_message_get_time_plain (VenomFormattedMessage* self);
GdkPixbuf* venom_formatted_message_get_sender_image (VenomFormattedMessage* self);
static GType venom_formatted_message_get_type_once (void);

static GType
venom_message_sender_get_type_once (void)
{
	static const GEnumValue values[] = {{VENOM_MESSAGE_SENDER_REMOTE, "VENOM_MESSAGE_SENDER_REMOTE", "remote"}, {VENOM_MESSAGE_SENDER_LOCAL, "VENOM_MESSAGE_SENDER_LOCAL", "local"}, {VENOM_MESSAGE_SENDER_SYSTEM, "VENOM_MESSAGE_SENDER_SYSTEM", "system"}, {0, NULL, NULL}};
	GType venom_message_sender_type_id;
	venom_message_sender_type_id = g_enum_register_static ("VenomMessageSender", values);
	return venom_message_sender_type_id;
}

GType
venom_message_sender_get_type (void)
{
	static volatile gsize venom_message_sender_type_id__volatile = 0;
	if (g_once_init_enter (&venom_message_sender_type_id__volatile)) {
		GType venom_message_sender_type_id;
		venom_message_sender_type_id = venom_message_sender_get_type_once ();
		g_once_init_leave (&venom_message_sender_type_id__volatile, venom_message_sender_type_id);
	}
	return venom_message_sender_type_id__volatile;
}

static GType
venom_transmission_state_get_type_once (void)
{
	static const GEnumValue values[] = {{VENOM_TRANSMISSION_STATE_NONE, "VENOM_TRANSMISSION_STATE_NONE", "none"}, {VENOM_TRANSMISSION_STATE_SENT, "VENOM_TRANSMISSION_STATE_SENT", "sent"}, {VENOM_TRANSMISSION_STATE_RECEIVED, "VENOM_TRANSMISSION_STATE_RECEIVED", "received"}, {0, NULL, NULL}};
	GType venom_transmission_state_type_id;
	venom_transmission_state_type_id = g_enum_register_static ("VenomTransmissionState", values);
	return venom_transmission_state_type_id;
}

GType
venom_transmission_state_get_type (void)
{
	static volatile gsize venom_transmission_state_type_id__volatile = 0;
	if (g_once_init_enter (&venom_transmission_state_type_id__volatile)) {
		GType venom_transmission_state_type_id;
		venom_transmission_state_type_id = venom_transmission_state_get_type_once ();
		g_once_init_leave (&venom_transmission_state_type_id__volatile, venom_transmission_state_type_id);
	}
	return venom_transmission_state_type_id__volatile;
}

gboolean
venom_message_is_conference_message (VenomMessage* self)
{
#line 44 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->is_conference_message (self);
#line 181 "Message.c"
}

gboolean
venom_message_equals_sender (VenomMessage* self,
                             VenomMessage* m)
{
#line 45 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 45 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->equals_sender (self, m);
#line 192 "Message.c"
}

gint
venom_message_get_id (VenomMessage* self)
{
#line 36 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->get_id (self);
#line 202 "Message.c"
}

void
venom_message_set_id (VenomMessage* self,
                      gint value)
{
#line 36 "../src/core/Message.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/core/Message.vala"
	VENOM_MESSAGE_GET_INTERFACE (self)->set_id (self, value);
#line 213 "Message.c"
}

gint
venom_message_get_peers_index (VenomMessage* self)
{
#line 37 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->get_peers_index (self);
#line 223 "Message.c"
}

void
venom_message_set_peers_index (VenomMessage* self,
                               gint value)
{
#line 37 "../src/core/Message.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/core/Message.vala"
	VENOM_MESSAGE_GET_INTERFACE (self)->set_peers_index (self, value);
#line 234 "Message.c"
}

GDateTime*
venom_message_get_timestamp (VenomMessage* self)
{
#line 38 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->get_timestamp (self);
#line 244 "Message.c"
}

void
venom_message_set_timestamp (VenomMessage* self,
                             GDateTime* value)
{
#line 38 "../src/core/Message.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/core/Message.vala"
	VENOM_MESSAGE_GET_INTERFACE (self)->set_timestamp (self, value);
#line 255 "Message.c"
}

VenomMessageSender
venom_message_get_sender (VenomMessage* self)
{
#line 39 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->get_sender (self);
#line 265 "Message.c"
}

void
venom_message_set_sender (VenomMessage* self,
                          VenomMessageSender value)
{
#line 39 "../src/core/Message.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/core/Message.vala"
	VENOM_MESSAGE_GET_INTERFACE (self)->set_sender (self, value);
#line 276 "Message.c"
}

const gchar*
venom_message_get_message (VenomMessage* self)
{
#line 40 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->get_message (self);
#line 286 "Message.c"
}

void
venom_message_set_message (VenomMessage* self,
                           const gchar* value)
{
#line 40 "../src/core/Message.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/core/Message.vala"
	VENOM_MESSAGE_GET_INTERFACE (self)->set_message (self, value);
#line 297 "Message.c"
}

gboolean
venom_message_get_is_action (VenomMessage* self)
{
#line 41 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->get_is_action (self);
#line 307 "Message.c"
}

void
venom_message_set_is_action (VenomMessage* self,
                             gboolean value)
{
#line 41 "../src/core/Message.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/core/Message.vala"
	VENOM_MESSAGE_GET_INTERFACE (self)->set_is_action (self, value);
#line 318 "Message.c"
}

VenomTransmissionState
venom_message_get_state (VenomMessage* self)
{
#line 42 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/core/Message.vala"
	return VENOM_MESSAGE_GET_INTERFACE (self)->get_state (self);
#line 328 "Message.c"
}

void
venom_message_set_state (VenomMessage* self,
                         VenomTransmissionState value)
{
#line 42 "../src/core/Message.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/core/Message.vala"
	VENOM_MESSAGE_GET_INTERFACE (self)->set_state (self, value);
#line 339 "Message.c"
}

static void
venom_message_default_init (VenomMessageIface * iface,
                            gpointer iface_data)
{
#line 35 "../src/core/Message.vala"
	g_object_interface_install_property (iface, g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/core/Message.vala"
	g_object_interface_install_property (iface, g_param_spec_int ("peers-index", "peers-index", "peers-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/core/Message.vala"
	g_object_interface_install_property (iface, g_param_spec_boxed ("timestamp", "timestamp", "timestamp", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/core/Message.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("sender", "sender", "sender", VENOM_TYPE_MESSAGE_SENDER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/core/Message.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("message", "message", "message", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/core/Message.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("is-action", "is-action", "is-action", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 35 "../src/core/Message.vala"
	g_object_interface_install_property (iface, g_param_spec_enum ("state", "state", "state", VENOM_TYPE_TRANSMISSION_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 360 "Message.c"
}

static GType
venom_message_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomMessageIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_message_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType venom_message_type_id;
	venom_message_type_id = g_type_register_static (G_TYPE_INTERFACE, "VenomMessage", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (venom_message_type_id, G_TYPE_OBJECT);
	return venom_message_type_id;
}

GType
venom_message_get_type (void)
{
	static volatile gsize venom_message_type_id__volatile = 0;
	if (g_once_init_enter (&venom_message_type_id__volatile)) {
		GType venom_message_type_id;
		venom_message_type_id = venom_message_get_type_once ();
		g_once_init_leave (&venom_message_type_id__volatile, venom_message_type_id);
	}
	return venom_message_type_id__volatile;
}

gchar*
venom_formatted_message_get_sender_plain (VenomFormattedMessage* self)
{
#line 49 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/core/Message.vala"
	return VENOM_FORMATTED_MESSAGE_GET_INTERFACE (self)->get_sender_plain (self);
#line 392 "Message.c"
}

gchar*
venom_formatted_message_get_sender_full (VenomFormattedMessage* self)
{
#line 50 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/core/Message.vala"
	return VENOM_FORMATTED_MESSAGE_GET_INTERFACE (self)->get_sender_full (self);
#line 402 "Message.c"
}

gchar*
venom_formatted_message_get_sender_id (VenomFormattedMessage* self)
{
#line 51 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/core/Message.vala"
	return VENOM_FORMATTED_MESSAGE_GET_INTERFACE (self)->get_sender_id (self);
#line 412 "Message.c"
}

gchar*
venom_formatted_message_get_conversation_id (VenomFormattedMessage* self)
{
#line 52 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/core/Message.vala"
	return VENOM_FORMATTED_MESSAGE_GET_INTERFACE (self)->get_conversation_id (self);
#line 422 "Message.c"
}

gchar*
venom_formatted_message_get_message_plain (VenomFormattedMessage* self)
{
#line 53 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/core/Message.vala"
	return VENOM_FORMATTED_MESSAGE_GET_INTERFACE (self)->get_message_plain (self);
#line 432 "Message.c"
}

gchar*
venom_formatted_message_get_time_plain (VenomFormattedMessage* self)
{
#line 54 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/core/Message.vala"
	return VENOM_FORMATTED_MESSAGE_GET_INTERFACE (self)->get_time_plain (self);
#line 442 "Message.c"
}

GdkPixbuf*
venom_formatted_message_get_sender_image (VenomFormattedMessage* self)
{
#line 55 "../src/core/Message.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/core/Message.vala"
	return VENOM_FORMATTED_MESSAGE_GET_INTERFACE (self)->get_sender_image (self);
#line 452 "Message.c"
}

static void
venom_formatted_message_default_init (VenomFormattedMessageIface * iface,
                                      gpointer iface_data)
{
}

static GType
venom_formatted_message_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomFormattedMessageIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_formatted_message_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType venom_formatted_message_type_id;
	venom_formatted_message_type_id = g_type_register_static (G_TYPE_INTERFACE, "VenomFormattedMessage", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (venom_formatted_message_type_id, G_TYPE_OBJECT);
	return venom_formatted_message_type_id;
}

GType
venom_formatted_message_get_type (void)
{
	static volatile gsize venom_formatted_message_type_id__volatile = 0;
	if (g_once_init_enter (&venom_formatted_message_type_id__volatile)) {
		GType venom_formatted_message_type_id;
		venom_formatted_message_type_id = venom_formatted_message_get_type_once ();
		g_once_init_leave (&venom_formatted_message_type_id__volatile, venom_formatted_message_type_id);
	}
	return venom_formatted_message_type_id__volatile;
}

