/* Profile.c generated by valac 0.48.3, the Vala compiler
 * generated from Profile.vala, do not modify */

/*
 *    Profile.vala
 *
 *    Copyright (C) 2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <tox/toxencryptsave.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <gee.h>

#define VENOM_TYPE_PROFILE (venom_profile_get_type ())
#define VENOM_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_PROFILE, VenomProfile))
#define VENOM_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VENOM_TYPE_PROFILE, VenomProfileClass))
#define VENOM_IS_PROFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_PROFILE))
#define VENOM_IS_PROFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VENOM_TYPE_PROFILE))
#define VENOM_PROFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VENOM_TYPE_PROFILE, VenomProfileClass))

typedef struct _VenomProfile VenomProfile;
typedef struct _VenomProfileClass VenomProfileClass;
typedef struct _VenomProfilePrivate VenomProfilePrivate;
enum  {
	VENOM_PROFILE_0_PROPERTY,
	VENOM_PROFILE_NAME_PROPERTY,
	VENOM_PROFILE_DIR_PROPERTY,
	VENOM_PROFILE_TOXFILE_PROPERTY,
	VENOM_PROFILE_WINDOWSTATEFILE_PROPERTY,
	VENOM_PROFILE_DBFILE_PROPERTY,
	VENOM_PROFILE_ACCELSFILE_PROPERTY,
	VENOM_PROFILE_IS_ENCRYPTED_PROPERTY,
	VENOM_PROFILE_NUM_PROPERTIES
};
static GParamSpec* venom_profile_properties[VENOM_PROFILE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _tox_pass_key_free0(var) ((var == NULL) ? NULL : (var = (tox_pass_key_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define VENOM_TYPE_LOGGER (venom_logger_get_type ())
#define VENOM_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_LOGGER, VenomLogger))
#define VENOM_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_LOGGER))
#define VENOM_LOGGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VENOM_TYPE_LOGGER, VenomLoggerIface))

typedef struct _VenomLogger VenomLogger;
typedef struct _VenomLoggerIface VenomLoggerIface;
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))

typedef enum  {
	ERROR_ENCRYPTION_CREATE,
	ERROR_ENCRYPTION_ENCRYPT,
	ERROR_ENCRYPTION_DECRYPT
} ErrorEncryption;
#define ERROR_ENCRYPTION error_encryption_quark ()
struct _VenomProfile {
	GObject parent_instance;
	VenomProfilePrivate * priv;
	Tox_Pass_Key* pass_key;
};

struct _VenomProfileClass {
	GObjectClass parent_class;
};

struct _VenomProfilePrivate {
	gchar* _name;
	gchar* _dir;
	gchar* _toxfile;
	gchar* _windowstatefile;
	gchar* _dbfile;
	gchar* _accelsfile;
	gboolean _is_encrypted;
};

struct _VenomLoggerIface {
	GTypeInterface parent_iface;
	void (*d) (VenomLogger* self, const gchar* message);
	void (*i) (VenomLogger* self, const gchar* message);
	void (*w) (VenomLogger* self, const gchar* message);
	void (*e) (VenomLogger* self, const gchar* message);
	void (*f) (VenomLogger* self, const gchar* message);
	gchar* (*get_log) (VenomLogger* self);
	void (*attach_to_glib) (VenomLogger* self);
};

static gint VenomProfile_private_offset;
static gpointer venom_profile_parent_class = NULL;

GQuark error_encryption_quark (void);
GType venom_profile_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VenomProfile, g_object_unref)
VenomProfile* venom_profile_new (const gchar* path,
                                 const gchar* username);
VenomProfile* venom_profile_construct (GType object_type,
                                       const gchar* path,
                                       const gchar* username);
void venom_profile_set_name (VenomProfile* self,
                             const gchar* value);
void venom_profile_set_dir (VenomProfile* self,
                            const gchar* value);
const gchar* venom_profile_get_dir (VenomProfile* self);
const gchar* venom_profile_get_name (VenomProfile* self);
void venom_profile_set_toxfile (VenomProfile* self,
                                const gchar* value);
void venom_profile_set_windowstatefile (VenomProfile* self,
                                        const gchar* value);
void venom_profile_set_dbfile (VenomProfile* self,
                               const gchar* value);
void venom_profile_set_accelsfile (VenomProfile* self,
                                   const gchar* value);
void venom_profile_set_is_encrypted (VenomProfile* self,
                                     gboolean value);
guint8* venom_profile_load_sessiondata (VenomProfile* self,
                                        gint* result_length1,
                                        GError** error);
const gchar* venom_profile_get_toxfile (VenomProfile* self);
static guint8* venom_profile_decrypt (VenomProfile* self,
                               guint8* data,
                               gint data_length1,
                               gint* result_length1,
                               GError** error);
gchar* venom_profile_get_db_key (VenomProfile* self);
gchar* venom_tools_bin_to_hexstring (guint8* bin,
                                     gint bin_length1);
void venom_profile_save_sessiondata (VenomProfile* self,
                                     guint8* sessiondata,
                                     gint sessiondata_length1,
                                     GError** error);
static guint8* _vala_array_dup2 (guint8* self,
                          gint length);
static const char* _tox_err_encryption_to_string (TOX_ERR_ENCRYPTION value);
gboolean venom_profile_test_is_encrypted (VenomProfile* self);
static guint8* _vala_array_dup3 (guint8* self,
                          gint length);
static const char* _tox_err_decryption_to_string (TOX_ERR_DECRYPTION value);
guint8* venom_profile_load (VenomProfile* self,
                            const gchar* password,
                            gint* result_length1,
                            GError** error);
gboolean venom_profile_get_is_encrypted (VenomProfile* self);
static guint8* _vala_array_dup4 (guint8* self,
                          gint length);
static const char* _tox_err_get_salt_to_string (TOX_ERR_GET_SALT value);
static const char* _tox_err_key_derivation_to_string (TOX_ERR_KEY_DERIVATION value);
gboolean venom_profile_is_sane (VenomProfile* self);
static gboolean venom_profile_exists (const gchar* path);
VenomProfile* venom_profile_create (const gchar* path,
                                    const gchar* username,
                                    const gchar* password,
                                    GError** error);
gboolean venom_profile_is_username_available (const gchar* path,
                                              const gchar* username);
GType venom_logger_get_type (void) G_GNUC_CONST;
GeeIterable* venom_profile_scan_profiles (VenomLogger* logger,
                                          const gchar* directory);
void venom_logger_w (VenomLogger* self,
                     const gchar* message);
const gchar* venom_profile_get_windowstatefile (VenomProfile* self);
const gchar* venom_profile_get_dbfile (VenomProfile* self);
const gchar* venom_profile_get_accelsfile (VenomProfile* self);
static void venom_profile_finalize (GObject * obj);
static GType venom_profile_get_type_once (void);
static void _vala_venom_profile_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_venom_profile_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

GQuark
error_encryption_quark (void)
{
	return g_quark_from_static_string ("error-encryption-quark");
}

static inline gpointer
venom_profile_get_instance_private (VenomProfile* self)
{
	return G_STRUCT_MEMBER_P (self, VenomProfile_private_offset);
}

VenomProfile*
venom_profile_construct (GType object_type,
                         const gchar* path,
                         const gchar* username)
{
	VenomProfile * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
#line 39 "../src/core/Profile.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 39 "../src/core/Profile.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 39 "../src/core/Profile.vala"
	self = (VenomProfile*) g_object_new (object_type, NULL);
#line 40 "../src/core/Profile.vala"
	venom_profile_set_name (self, username);
#line 41 "../src/core/Profile.vala"
	venom_profile_set_dir (self, path);
#line 42 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_dir;
#line 42 "../src/core/Profile.vala"
	_tmp1_ = self->priv->_name;
#line 42 "../src/core/Profile.vala"
	_tmp2_ = g_strconcat (_tmp1_, ".tox", NULL);
#line 42 "../src/core/Profile.vala"
	_tmp3_ = _tmp2_;
#line 42 "../src/core/Profile.vala"
	_tmp4_ = g_build_filename (_tmp0_, _tmp3_, NULL);
#line 42 "../src/core/Profile.vala"
	_tmp5_ = _tmp4_;
#line 42 "../src/core/Profile.vala"
	venom_profile_set_toxfile (self, _tmp5_);
#line 42 "../src/core/Profile.vala"
	_g_free0 (_tmp5_);
#line 42 "../src/core/Profile.vala"
	_g_free0 (_tmp3_);
#line 43 "../src/core/Profile.vala"
	_tmp6_ = self->priv->_dir;
#line 43 "../src/core/Profile.vala"
	_tmp7_ = self->priv->_name;
#line 43 "../src/core/Profile.vala"
	_tmp8_ = g_strconcat (_tmp7_, ".json", NULL);
#line 43 "../src/core/Profile.vala"
	_tmp9_ = _tmp8_;
#line 43 "../src/core/Profile.vala"
	_tmp10_ = g_build_filename (_tmp6_, _tmp9_, NULL);
#line 43 "../src/core/Profile.vala"
	_tmp11_ = _tmp10_;
#line 43 "../src/core/Profile.vala"
	venom_profile_set_windowstatefile (self, _tmp11_);
#line 43 "../src/core/Profile.vala"
	_g_free0 (_tmp11_);
#line 43 "../src/core/Profile.vala"
	_g_free0 (_tmp9_);
#line 44 "../src/core/Profile.vala"
	_tmp12_ = self->priv->_dir;
#line 44 "../src/core/Profile.vala"
	_tmp13_ = self->priv->_name;
#line 44 "../src/core/Profile.vala"
	_tmp14_ = g_strconcat (_tmp13_, ".db", NULL);
#line 44 "../src/core/Profile.vala"
	_tmp15_ = _tmp14_;
#line 44 "../src/core/Profile.vala"
	_tmp16_ = g_build_filename (_tmp12_, _tmp15_, NULL);
#line 44 "../src/core/Profile.vala"
	_tmp17_ = _tmp16_;
#line 44 "../src/core/Profile.vala"
	venom_profile_set_dbfile (self, _tmp17_);
#line 44 "../src/core/Profile.vala"
	_g_free0 (_tmp17_);
#line 44 "../src/core/Profile.vala"
	_g_free0 (_tmp15_);
#line 45 "../src/core/Profile.vala"
	_tmp18_ = self->priv->_dir;
#line 45 "../src/core/Profile.vala"
	_tmp19_ = self->priv->_name;
#line 45 "../src/core/Profile.vala"
	_tmp20_ = g_strconcat (_tmp19_, ".accels", NULL);
#line 45 "../src/core/Profile.vala"
	_tmp21_ = _tmp20_;
#line 45 "../src/core/Profile.vala"
	_tmp22_ = g_build_filename (_tmp18_, _tmp21_, NULL);
#line 45 "../src/core/Profile.vala"
	_tmp23_ = _tmp22_;
#line 45 "../src/core/Profile.vala"
	venom_profile_set_accelsfile (self, _tmp23_);
#line 45 "../src/core/Profile.vala"
	_g_free0 (_tmp23_);
#line 45 "../src/core/Profile.vala"
	_g_free0 (_tmp21_);
#line 46 "../src/core/Profile.vala"
	venom_profile_set_is_encrypted (self, FALSE);
#line 39 "../src/core/Profile.vala"
	return self;
#line 322 "Profile.c"
}

VenomProfile*
venom_profile_new (const gchar* path,
                   const gchar* username)
{
#line 39 "../src/core/Profile.vala"
	return venom_profile_construct (VENOM_TYPE_PROFILE, path, username);
#line 331 "Profile.c"
}

guint8*
venom_profile_load_sessiondata (VenomProfile* self,
                                gint* result_length1,
                                GError** error)
{
	const gchar* _tmp0_;
	guint8* data = NULL;
	gint data_length1 = 0;
	gint _data_size_ = 0;
	const gchar* _tmp2_;
	guint8* _tmp3_ = NULL;
	size_t _tmp4_ = 0;
	Tox_Pass_Key* _tmp5_;
	guint8* _tmp12_;
	gint _tmp12__length1;
	GError* _inner_error0_ = NULL;
	guint8* result = NULL;
#line 49 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_toxfile;
#line 50 "../src/core/Profile.vala"
	if (!g_file_test (_tmp0_, G_FILE_TEST_EXISTS)) {
#line 357 "Profile.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 51 "../src/core/Profile.vala"
		_tmp1_ = NULL;
#line 51 "../src/core/Profile.vala"
		_tmp1__length1 = 0;
#line 51 "../src/core/Profile.vala"
		if (result_length1) {
#line 51 "../src/core/Profile.vala"
			*result_length1 = _tmp1__length1;
#line 368 "Profile.c"
		}
#line 51 "../src/core/Profile.vala"
		result = _tmp1_;
#line 51 "../src/core/Profile.vala"
		return result;
#line 374 "Profile.c"
	}
#line 55 "../src/core/Profile.vala"
	_tmp2_ = self->priv->_toxfile;
#line 55 "../src/core/Profile.vala"
	g_file_get_contents (_tmp2_, (gchar**) (&_tmp3_), &_tmp4_, &_inner_error0_);
#line 55 "../src/core/Profile.vala"
	data = (g_free (data), NULL);
#line 55 "../src/core/Profile.vala"
	data = _tmp3_;
#line 55 "../src/core/Profile.vala"
	data_length1 = _tmp4_;
#line 55 "../src/core/Profile.vala"
	_data_size_ = data_length1;
#line 55 "../src/core/Profile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/core/Profile.vala"
		g_propagate_error (error, _inner_error0_);
#line 55 "../src/core/Profile.vala"
		data = (g_free (data), NULL);
#line 55 "../src/core/Profile.vala"
		return NULL;
#line 396 "Profile.c"
	}
#line 57 "../src/core/Profile.vala"
	_tmp5_ = self->pass_key;
#line 57 "../src/core/Profile.vala"
	if (_tmp5_ != NULL) {
#line 402 "Profile.c"
		guint8* _tmp6_ = NULL;
		guint8* _tmp7_;
		gint _tmp7__length1;
		gint _tmp8_ = 0;
		guint8* _tmp9_;
		gint _tmp6__length1;
		gint __tmp6__size_;
		guint8* _tmp10_;
		gint _tmp10__length1;
		guint8* _tmp11_;
		gint _tmp11__length1;
#line 58 "../src/core/Profile.vala"
		_tmp7_ = data;
#line 58 "../src/core/Profile.vala"
		_tmp7__length1 = data_length1;
#line 58 "../src/core/Profile.vala"
		_tmp9_ = venom_profile_decrypt (self, _tmp7_, (gint) _tmp7__length1, &_tmp8_, &_inner_error0_);
#line 58 "../src/core/Profile.vala"
		_tmp6_ = _tmp9_;
#line 58 "../src/core/Profile.vala"
		_tmp6__length1 = _tmp8_;
#line 58 "../src/core/Profile.vala"
		__tmp6__size_ = _tmp6__length1;
#line 58 "../src/core/Profile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "../src/core/Profile.vala"
			g_propagate_error (error, _inner_error0_);
#line 58 "../src/core/Profile.vala"
			data = (g_free (data), NULL);
#line 58 "../src/core/Profile.vala"
			return NULL;
#line 434 "Profile.c"
		}
#line 58 "../src/core/Profile.vala"
		_tmp10_ = _tmp6_;
#line 58 "../src/core/Profile.vala"
		_tmp10__length1 = _tmp6__length1;
#line 58 "../src/core/Profile.vala"
		_tmp6_ = NULL;
#line 58 "../src/core/Profile.vala"
		_tmp6__length1 = 0;
#line 58 "../src/core/Profile.vala"
		_tmp11_ = _tmp10_;
#line 58 "../src/core/Profile.vala"
		_tmp11__length1 = _tmp10__length1;
#line 58 "../src/core/Profile.vala"
		if (result_length1) {
#line 58 "../src/core/Profile.vala"
			*result_length1 = _tmp11__length1;
#line 452 "Profile.c"
		}
#line 58 "../src/core/Profile.vala"
		result = _tmp11_;
#line 58 "../src/core/Profile.vala"
		_tmp6_ = (g_free (_tmp6_), NULL);
#line 58 "../src/core/Profile.vala"
		data = (g_free (data), NULL);
#line 58 "../src/core/Profile.vala"
		return result;
#line 462 "Profile.c"
	}
#line 60 "../src/core/Profile.vala"
	_tmp12_ = data;
#line 60 "../src/core/Profile.vala"
	_tmp12__length1 = data_length1;
#line 60 "../src/core/Profile.vala"
	if (result_length1) {
#line 60 "../src/core/Profile.vala"
		*result_length1 = _tmp12__length1;
#line 472 "Profile.c"
	}
#line 60 "../src/core/Profile.vala"
	result = _tmp12_;
#line 60 "../src/core/Profile.vala"
	return result;
#line 478 "Profile.c"
}

gchar*
venom_profile_get_db_key (VenomProfile* self)
{
	Tox_Pass_Key* _tmp0_;
	guint8* data = NULL;
	Tox_Pass_Key* _tmp2_;
	gint data_length1;
	gint _data_size_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 63 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/core/Profile.vala"
	_tmp0_ = self->pass_key;
#line 64 "../src/core/Profile.vala"
	if (_tmp0_ == NULL) {
#line 499 "Profile.c"
		gchar* _tmp1_;
#line 65 "../src/core/Profile.vala"
		_tmp1_ = g_strdup ("");
#line 65 "../src/core/Profile.vala"
		result = _tmp1_;
#line 65 "../src/core/Profile.vala"
		return result;
#line 507 "Profile.c"
	}
#line 67 "../src/core/Profile.vala"
	_tmp2_ = self->pass_key;
#line 67 "../src/core/Profile.vala"
	data = (guint8*) _tmp2_;
#line 67 "../src/core/Profile.vala"
	data_length1 = -1;
#line 67 "../src/core/Profile.vala"
	_data_size_ = data_length1;
#line 68 "../src/core/Profile.vala"
	data_length1 = 64;
#line 69 "../src/core/Profile.vala"
	_tmp3_ = data;
#line 69 "../src/core/Profile.vala"
	_tmp3__length1 = data_length1;
#line 69 "../src/core/Profile.vala"
	_tmp4_ = venom_tools_bin_to_hexstring (_tmp3_ + 32, (gint) (64 - 32));
#line 69 "../src/core/Profile.vala"
	result = _tmp4_;
#line 69 "../src/core/Profile.vala"
	return result;
#line 529 "Profile.c"
}

/**
     * Encrypt a plain text with a key produced by {@link PassKey.PassKey.derive} or {@link PassKey.PassKey.derive_with_salt}.
     *
     * The output array must be at least ``plaintext.length + {@link pass_encryption_extra_length}``
     * bytes long.
     *
     * @param plaintext A byte array of length ``plaintext.length``.
     *
     * @return ciphertext on success.
     */
static guint8*
_vala_array_dup2 (guint8* self,
                  gint length)
{
#line 217 "toxencryptsave.vapi"
	return g_memdup (self, length * sizeof (guint8));
#line 548 "Profile.c"
}

static guint8*
vala_tox_pass_key_encrypt (Tox_Pass_Key* self,
                           guint8* plaintext,
                           gint plaintext_length1,
                           TOX_ERR_ENCRYPTION* _error_,
                           gint* result_length1)
{
	TOX_ERR_ENCRYPTION _vala__error_ = 0;
	guint8* t = NULL;
	guint8* _tmp0_;
	gint t_length1;
	gint _t_size_;
	gboolean ret = FALSE;
	guint8* _tmp1_;
	gint _tmp1__length1;
	TOX_ERR_ENCRYPTION _tmp2_ = 0;
	gboolean _tmp3_;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint __tmp4__size_ = 0;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* result = NULL;
#line 214 "toxencryptsave.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "toxencryptsave.vapi"
	_tmp0_ = g_new0 (guint8, plaintext_length1 + TOX_PASS_ENCRYPTION_EXTRA_LENGTH);
#line 215 "toxencryptsave.vapi"
	t = _tmp0_;
#line 215 "toxencryptsave.vapi"
	t_length1 = plaintext_length1 + TOX_PASS_ENCRYPTION_EXTRA_LENGTH;
#line 215 "toxencryptsave.vapi"
	_t_size_ = t_length1;
#line 216 "toxencryptsave.vapi"
	_tmp1_ = t;
#line 216 "toxencryptsave.vapi"
	_tmp1__length1 = t_length1;
#line 216 "toxencryptsave.vapi"
	_tmp3_ = tox_pass_key_encrypt (self, plaintext, (gint) plaintext_length1, _tmp1_, &_tmp2_);
#line 216 "toxencryptsave.vapi"
	_vala__error_ = _tmp2_;
#line 216 "toxencryptsave.vapi"
	ret = _tmp3_;
#line 217 "toxencryptsave.vapi"
	if (ret) {
#line 598 "Profile.c"
		guint8* _tmp5_;
		gint _tmp5__length1;
#line 217 "toxencryptsave.vapi"
		_tmp5_ = t;
#line 217 "toxencryptsave.vapi"
		_tmp5__length1 = t_length1;
#line 217 "toxencryptsave.vapi"
		_tmp4_ = _tmp5_;
#line 217 "toxencryptsave.vapi"
		_tmp4__length1 = _tmp5__length1;
#line 217 "toxencryptsave.vapi"
		__tmp4__size_ = _tmp4__length1;
#line 611 "Profile.c"
	} else {
#line 217 "toxencryptsave.vapi"
		_tmp4_ = NULL;
#line 217 "toxencryptsave.vapi"
		_tmp4__length1 = 0;
#line 217 "toxencryptsave.vapi"
		__tmp4__size_ = _tmp4__length1;
#line 619 "Profile.c"
	}
#line 217 "toxencryptsave.vapi"
	_tmp6_ = (_tmp4_ != NULL) ? _vala_array_dup2 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 217 "toxencryptsave.vapi"
	_tmp6__length1 = _tmp4__length1;
#line 217 "toxencryptsave.vapi"
	_tmp7_ = _tmp6_;
#line 217 "toxencryptsave.vapi"
	_tmp7__length1 = _tmp6__length1;
#line 217 "toxencryptsave.vapi"
	if (result_length1) {
#line 217 "toxencryptsave.vapi"
		*result_length1 = _tmp7__length1;
#line 633 "Profile.c"
	}
#line 217 "toxencryptsave.vapi"
	result = _tmp7_;
#line 217 "toxencryptsave.vapi"
	t = (g_free (t), NULL);
#line 217 "toxencryptsave.vapi"
	if (_error_) {
#line 217 "toxencryptsave.vapi"
		*_error_ = _vala__error_;
#line 643 "Profile.c"
	}
#line 217 "toxencryptsave.vapi"
	return result;
#line 647 "Profile.c"
}

static const char*
_tox_err_encryption_to_string (TOX_ERR_ENCRYPTION value)
{
#line 77 "../src/core/Profile.vala"
	switch (value) {
#line 77 "../src/core/Profile.vala"
		case TOX_ERR_ENCRYPTION_OK:
#line 77 "../src/core/Profile.vala"
		return "TOX_ERR_ENCRYPTION_OK";
#line 77 "../src/core/Profile.vala"
		case TOX_ERR_ENCRYPTION_NULL:
#line 77 "../src/core/Profile.vala"
		return "TOX_ERR_ENCRYPTION_NULL";
#line 77 "../src/core/Profile.vala"
		case TOX_ERR_ENCRYPTION_KEY_DERIVATION_FAILED:
#line 77 "../src/core/Profile.vala"
		return "TOX_ERR_ENCRYPTION_KEY_DERIVATION_FAILED";
#line 77 "../src/core/Profile.vala"
		case TOX_ERR_ENCRYPTION_FAILED:
#line 77 "../src/core/Profile.vala"
		return "TOX_ERR_ENCRYPTION_FAILED";
#line 671 "Profile.c"
	}
#line 77 "../src/core/Profile.vala"
	return NULL;
#line 675 "Profile.c"
}

void
venom_profile_save_sessiondata (VenomProfile* self,
                                guint8* sessiondata,
                                gint sessiondata_length1,
                                GError** error)
{
	Tox_Pass_Key* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 72 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/core/Profile.vala"
	_tmp0_ = self->pass_key;
#line 73 "../src/core/Profile.vala"
	if (_tmp0_ != NULL) {
#line 692 "Profile.c"
		TOX_ERR_ENCRYPTION err = 0;
		guint8* data = NULL;
		Tox_Pass_Key* _tmp1_;
		TOX_ERR_ENCRYPTION _tmp2_ = 0;
		gint _tmp3_ = 0;
		guint8* _tmp4_;
		gint data_length1;
		gint _data_size_;
		TOX_ERR_ENCRYPTION _tmp5_;
		const gchar* _tmp12_;
		guint8* _tmp13_;
		gint _tmp13__length1;
#line 75 "../src/core/Profile.vala"
		_tmp1_ = self->pass_key;
#line 75 "../src/core/Profile.vala"
		_tmp4_ = vala_tox_pass_key_encrypt (_tmp1_, sessiondata, (gint) sessiondata_length1, &_tmp2_, &_tmp3_);
#line 75 "../src/core/Profile.vala"
		err = _tmp2_;
#line 75 "../src/core/Profile.vala"
		data = _tmp4_;
#line 75 "../src/core/Profile.vala"
		data_length1 = _tmp3_;
#line 75 "../src/core/Profile.vala"
		_data_size_ = data_length1;
#line 76 "../src/core/Profile.vala"
		_tmp5_ = err;
#line 76 "../src/core/Profile.vala"
		if (_tmp5_ != TOX_ERR_ENCRYPTION_OK) {
#line 721 "Profile.c"
			TOX_ERR_ENCRYPTION _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GError* _tmp10_;
			GError* _tmp11_;
#line 77 "../src/core/Profile.vala"
			_tmp6_ = err;
#line 77 "../src/core/Profile.vala"
			_tmp7_ = _tox_err_encryption_to_string (_tmp6_);
#line 77 "../src/core/Profile.vala"
			_tmp8_ = g_strconcat ("Failed to encrypt data: ", _tmp7_, NULL);
#line 77 "../src/core/Profile.vala"
			_tmp9_ = _tmp8_;
#line 77 "../src/core/Profile.vala"
			_tmp10_ = g_error_new_literal (ERROR_ENCRYPTION, ERROR_ENCRYPTION_ENCRYPT, _tmp9_);
#line 77 "../src/core/Profile.vala"
			_tmp11_ = _tmp10_;
#line 77 "../src/core/Profile.vala"
			_g_free0 (_tmp9_);
#line 77 "../src/core/Profile.vala"
			_inner_error0_ = _tmp11_;
#line 77 "../src/core/Profile.vala"
			g_propagate_error (error, _inner_error0_);
#line 77 "../src/core/Profile.vala"
			data = (g_free (data), NULL);
#line 77 "../src/core/Profile.vala"
			return;
#line 750 "Profile.c"
		}
#line 79 "../src/core/Profile.vala"
		_tmp12_ = self->priv->_toxfile;
#line 79 "../src/core/Profile.vala"
		_tmp13_ = data;
#line 79 "../src/core/Profile.vala"
		_tmp13__length1 = data_length1;
#line 79 "../src/core/Profile.vala"
		g_file_set_contents (_tmp12_, (const char*) _tmp13_, (size_t) _tmp13__length1, &_inner_error0_);
#line 79 "../src/core/Profile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/core/Profile.vala"
			g_propagate_error (error, _inner_error0_);
#line 79 "../src/core/Profile.vala"
			data = (g_free (data), NULL);
#line 79 "../src/core/Profile.vala"
			return;
#line 768 "Profile.c"
		}
#line 73 "../src/core/Profile.vala"
		data = (g_free (data), NULL);
#line 772 "Profile.c"
	} else {
		const gchar* _tmp14_;
#line 81 "../src/core/Profile.vala"
		_tmp14_ = self->priv->_toxfile;
#line 81 "../src/core/Profile.vala"
		g_file_set_contents (_tmp14_, (const char*) sessiondata, (size_t) sessiondata_length1, &_inner_error0_);
#line 81 "../src/core/Profile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 81 "../src/core/Profile.vala"
			g_propagate_error (error, _inner_error0_);
#line 81 "../src/core/Profile.vala"
			return;
#line 785 "Profile.c"
		}
	}
}

gboolean
venom_profile_test_is_encrypted (VenomProfile* self)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	guint8* contents = NULL;
	gint contents_length1 = 0;
	gint _contents_size_ = 0;
	guint8* _tmp6_;
	gint _tmp6__length1;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 85 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_toxfile;
#line 86 "../src/core/Profile.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 86 "../src/core/Profile.vala"
	file = _tmp1_;
#line 811 "Profile.c"
	{
		GFile* _tmp2_;
		guint8* _tmp3_ = NULL;
		gsize _tmp4_ = 0;
#line 89 "../src/core/Profile.vala"
		_tmp2_ = file;
#line 89 "../src/core/Profile.vala"
		g_file_load_contents (_tmp2_, NULL, &_tmp3_, &_tmp4_, NULL, &_inner_error0_);
#line 89 "../src/core/Profile.vala"
		contents = (g_free (contents), NULL);
#line 89 "../src/core/Profile.vala"
		contents = _tmp3_;
#line 89 "../src/core/Profile.vala"
		contents_length1 = _tmp4_;
#line 89 "../src/core/Profile.vala"
		_contents_size_ = contents_length1;
#line 89 "../src/core/Profile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 830 "Profile.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 88 "../src/core/Profile.vala"
		g_clear_error (&_inner_error0_);
#line 91 "../src/core/Profile.vala"
		result = FALSE;
#line 91 "../src/core/Profile.vala"
		contents = (g_free (contents), NULL);
#line 91 "../src/core/Profile.vala"
		_g_object_unref0 (file);
#line 91 "../src/core/Profile.vala"
		return result;
#line 847 "Profile.c"
	}
	__finally0:
#line 88 "../src/core/Profile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 852 "Profile.c"
		gboolean _tmp5_ = FALSE;
#line 88 "../src/core/Profile.vala"
		contents = (g_free (contents), NULL);
#line 88 "../src/core/Profile.vala"
		_g_object_unref0 (file);
#line 88 "../src/core/Profile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../src/core/Profile.vala"
		g_clear_error (&_inner_error0_);
#line 88 "../src/core/Profile.vala"
		return _tmp5_;
#line 864 "Profile.c"
	}
#line 93 "../src/core/Profile.vala"
	_tmp6_ = contents;
#line 93 "../src/core/Profile.vala"
	_tmp6__length1 = contents_length1;
#line 93 "../src/core/Profile.vala"
	result = tox_is_data_encrypted (_tmp6_);
#line 93 "../src/core/Profile.vala"
	contents = (g_free (contents), NULL);
#line 93 "../src/core/Profile.vala"
	_g_object_unref0 (file);
#line 93 "../src/core/Profile.vala"
	return result;
#line 878 "Profile.c"
}

/**
     * This is the inverse of {@link PassKey.encrypt}, also using only keys produced by
     * {@link PassKey.PassKey.derive} or {@link PassKey.PassKey.derive_with_salt}.
     *
     * @param ciphertext A byte array of length ``ciphertext.length``.
     *
     * @return plaintext on success.
     */
static guint8*
_vala_array_dup3 (guint8* self,
                  gint length)
{
#line 235 "toxencryptsave.vapi"
	return g_memdup (self, length * sizeof (guint8));
#line 895 "Profile.c"
}

static guint8*
vala_tox_pass_key_decrypt (Tox_Pass_Key* self,
                           guint8* ciphertext,
                           gint ciphertext_length1,
                           TOX_ERR_DECRYPTION* _error_,
                           gint* result_length1)
{
	TOX_ERR_DECRYPTION _vala__error_ = 0;
	guint8* t = NULL;
	guint8* _tmp0_;
	gint t_length1;
	gint _t_size_;
	gboolean ret = FALSE;
	guint8* _tmp1_;
	gint _tmp1__length1;
	TOX_ERR_DECRYPTION _tmp2_ = 0;
	gboolean _tmp3_;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint __tmp4__size_ = 0;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* result = NULL;
#line 232 "toxencryptsave.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "toxencryptsave.vapi"
	_tmp0_ = g_new0 (guint8, ciphertext_length1 + TOX_PASS_ENCRYPTION_EXTRA_LENGTH);
#line 233 "toxencryptsave.vapi"
	t = _tmp0_;
#line 233 "toxencryptsave.vapi"
	t_length1 = ciphertext_length1 + TOX_PASS_ENCRYPTION_EXTRA_LENGTH;
#line 233 "toxencryptsave.vapi"
	_t_size_ = t_length1;
#line 234 "toxencryptsave.vapi"
	_tmp1_ = t;
#line 234 "toxencryptsave.vapi"
	_tmp1__length1 = t_length1;
#line 234 "toxencryptsave.vapi"
	_tmp3_ = tox_pass_key_decrypt (self, ciphertext, (gint) ciphertext_length1, _tmp1_, &_tmp2_);
#line 234 "toxencryptsave.vapi"
	_vala__error_ = _tmp2_;
#line 234 "toxencryptsave.vapi"
	ret = _tmp3_;
#line 235 "toxencryptsave.vapi"
	if (ret) {
#line 945 "Profile.c"
		guint8* _tmp5_;
		gint _tmp5__length1;
#line 235 "toxencryptsave.vapi"
		_tmp5_ = t;
#line 235 "toxencryptsave.vapi"
		_tmp5__length1 = t_length1;
#line 235 "toxencryptsave.vapi"
		_tmp4_ = _tmp5_;
#line 235 "toxencryptsave.vapi"
		_tmp4__length1 = _tmp5__length1;
#line 235 "toxencryptsave.vapi"
		__tmp4__size_ = _tmp4__length1;
#line 958 "Profile.c"
	} else {
#line 235 "toxencryptsave.vapi"
		_tmp4_ = NULL;
#line 235 "toxencryptsave.vapi"
		_tmp4__length1 = 0;
#line 235 "toxencryptsave.vapi"
		__tmp4__size_ = _tmp4__length1;
#line 966 "Profile.c"
	}
#line 235 "toxencryptsave.vapi"
	_tmp6_ = (_tmp4_ != NULL) ? _vala_array_dup3 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 235 "toxencryptsave.vapi"
	_tmp6__length1 = _tmp4__length1;
#line 235 "toxencryptsave.vapi"
	_tmp7_ = _tmp6_;
#line 235 "toxencryptsave.vapi"
	_tmp7__length1 = _tmp6__length1;
#line 235 "toxencryptsave.vapi"
	if (result_length1) {
#line 235 "toxencryptsave.vapi"
		*result_length1 = _tmp7__length1;
#line 980 "Profile.c"
	}
#line 235 "toxencryptsave.vapi"
	result = _tmp7_;
#line 235 "toxencryptsave.vapi"
	t = (g_free (t), NULL);
#line 235 "toxencryptsave.vapi"
	if (_error_) {
#line 235 "toxencryptsave.vapi"
		*_error_ = _vala__error_;
#line 990 "Profile.c"
	}
#line 235 "toxencryptsave.vapi"
	return result;
#line 994 "Profile.c"
}

static const char*
_tox_err_decryption_to_string (TOX_ERR_DECRYPTION value)
{
#line 100 "../src/core/Profile.vala"
	switch (value) {
#line 100 "../src/core/Profile.vala"
		case TOX_ERR_DECRYPTION_OK:
#line 100 "../src/core/Profile.vala"
		return "TOX_ERR_DECRYPTION_OK";
#line 100 "../src/core/Profile.vala"
		case TOX_ERR_DECRYPTION_NULL:
#line 100 "../src/core/Profile.vala"
		return "TOX_ERR_DECRYPTION_NULL";
#line 100 "../src/core/Profile.vala"
		case TOX_ERR_DECRYPTION_INVALID_LENGTH:
#line 100 "../src/core/Profile.vala"
		return "TOX_ERR_DECRYPTION_INVALID_LENGTH";
#line 100 "../src/core/Profile.vala"
		case TOX_ERR_DECRYPTION_BAD_FORMAT:
#line 100 "../src/core/Profile.vala"
		return "TOX_ERR_DECRYPTION_BAD_FORMAT";
#line 100 "../src/core/Profile.vala"
		case TOX_ERR_DECRYPTION_KEY_DERIVATION_FAILED:
#line 100 "../src/core/Profile.vala"
		return "TOX_ERR_DECRYPTION_KEY_DERIVATION_FAILED";
#line 100 "../src/core/Profile.vala"
		case TOX_ERR_DECRYPTION_FAILED:
#line 100 "../src/core/Profile.vala"
		return "TOX_ERR_DECRYPTION_FAILED";
#line 1026 "Profile.c"
	}
#line 100 "../src/core/Profile.vala"
	return NULL;
#line 1030 "Profile.c"
}

static guint8*
venom_profile_decrypt (VenomProfile* self,
                       guint8* data,
                       gint data_length1,
                       gint* result_length1,
                       GError** error)
{
	TOX_ERR_DECRYPTION err_decrypt = 0;
	guint8* plain = NULL;
	Tox_Pass_Key* _tmp0_;
	TOX_ERR_DECRYPTION _tmp1_ = 0;
	gint _tmp2_ = 0;
	guint8* _tmp3_;
	gint plain_length1;
	gint _plain_size_;
	TOX_ERR_DECRYPTION _tmp4_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	GError* _inner_error0_ = NULL;
	guint8* result = NULL;
#line 96 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/core/Profile.vala"
	_tmp0_ = self->pass_key;
#line 98 "../src/core/Profile.vala"
	_tmp3_ = vala_tox_pass_key_decrypt (_tmp0_, data, (gint) data_length1, &_tmp1_, &_tmp2_);
#line 98 "../src/core/Profile.vala"
	err_decrypt = _tmp1_;
#line 98 "../src/core/Profile.vala"
	plain = _tmp3_;
#line 98 "../src/core/Profile.vala"
	plain_length1 = _tmp2_;
#line 98 "../src/core/Profile.vala"
	_plain_size_ = plain_length1;
#line 99 "../src/core/Profile.vala"
	_tmp4_ = err_decrypt;
#line 99 "../src/core/Profile.vala"
	if (_tmp4_ != TOX_ERR_DECRYPTION_OK) {
#line 1071 "Profile.c"
		TOX_ERR_DECRYPTION _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		GError* _tmp10_;
#line 100 "../src/core/Profile.vala"
		_tmp5_ = err_decrypt;
#line 100 "../src/core/Profile.vala"
		_tmp6_ = _tox_err_decryption_to_string (_tmp5_);
#line 100 "../src/core/Profile.vala"
		_tmp7_ = g_strconcat ("Decryption failed: ", _tmp6_, NULL);
#line 100 "../src/core/Profile.vala"
		_tmp8_ = _tmp7_;
#line 100 "../src/core/Profile.vala"
		_tmp9_ = g_error_new_literal (ERROR_ENCRYPTION, ERROR_ENCRYPTION_DECRYPT, _tmp8_);
#line 100 "../src/core/Profile.vala"
		_tmp10_ = _tmp9_;
#line 100 "../src/core/Profile.vala"
		_g_free0 (_tmp8_);
#line 100 "../src/core/Profile.vala"
		_inner_error0_ = _tmp10_;
#line 100 "../src/core/Profile.vala"
		g_propagate_error (error, _inner_error0_);
#line 100 "../src/core/Profile.vala"
		plain = (g_free (plain), NULL);
#line 100 "../src/core/Profile.vala"
		return NULL;
#line 1100 "Profile.c"
	}
#line 102 "../src/core/Profile.vala"
	_tmp11_ = plain;
#line 102 "../src/core/Profile.vala"
	_tmp11__length1 = plain_length1;
#line 102 "../src/core/Profile.vala"
	if (result_length1) {
#line 102 "../src/core/Profile.vala"
		*result_length1 = _tmp11__length1;
#line 1110 "Profile.c"
	}
#line 102 "../src/core/Profile.vala"
	result = _tmp11_;
#line 102 "../src/core/Profile.vala"
	return result;
#line 1116 "Profile.c"
}

/**
   * Retrieves the salt used to encrypt the given data.
   *
   * The retrieved salt can then be passed to {@link PassKey.PassKey.derive_with_salt} to
   * produce the same key as was previously used. Any data encrypted with this
   * module can be used as input.
   *
   * The cipher text must be at least {@link pass_encryption_extra_length} bytes in length.
   * The salt must be {@link pass_salt_length} bytes in length.
   * If the passed byte arrays are smaller than required, the behaviour is
   * undefined.
   *
   * If the cipher text pointer or the salt is NULL, this function returns null.
   *
   * Success does not say anything about the validity of the data, only that
   * data of the appropriate size was copied.
   *
   * @return true on success.
   */
static guint8*
_vala_array_dup4 (guint8* self,
                  gint length)
{
#line 282 "toxencryptsave.vapi"
	return g_memdup (self, length * sizeof (guint8));
#line 1144 "Profile.c"
}

static guint8*
vala_tox_get_salt (guint8* ciphertext,
                   gint ciphertext_length1,
                   TOX_ERR_GET_SALT* _error_,
                   gint* result_length1)
{
	TOX_ERR_GET_SALT _vala__error_ = 0;
	guint8* t = NULL;
	guint8* _tmp0_;
	gint t_length1;
	gint _t_size_;
	gboolean ret = FALSE;
	guint8* _tmp1_;
	gint _tmp1__length1;
	TOX_ERR_GET_SALT _tmp2_ = 0;
	gboolean _tmp3_;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint __tmp4__size_ = 0;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* result = NULL;
#line 280 "toxencryptsave.vapi"
	_tmp0_ = g_new0 (guint8, TOX_PASS_SALT_LENGTH);
#line 280 "toxencryptsave.vapi"
	t = _tmp0_;
#line 280 "toxencryptsave.vapi"
	t_length1 = TOX_PASS_SALT_LENGTH;
#line 280 "toxencryptsave.vapi"
	_t_size_ = t_length1;
#line 281 "toxencryptsave.vapi"
	_tmp1_ = t;
#line 281 "toxencryptsave.vapi"
	_tmp1__length1 = t_length1;
#line 281 "toxencryptsave.vapi"
	_tmp3_ = tox_get_salt (ciphertext, _tmp1_, &_tmp2_);
#line 281 "toxencryptsave.vapi"
	_vala__error_ = _tmp2_;
#line 281 "toxencryptsave.vapi"
	ret = _tmp3_;
#line 282 "toxencryptsave.vapi"
	if (ret) {
#line 1191 "Profile.c"
		guint8* _tmp5_;
		gint _tmp5__length1;
#line 282 "toxencryptsave.vapi"
		_tmp5_ = t;
#line 282 "toxencryptsave.vapi"
		_tmp5__length1 = t_length1;
#line 282 "toxencryptsave.vapi"
		_tmp4_ = _tmp5_;
#line 282 "toxencryptsave.vapi"
		_tmp4__length1 = _tmp5__length1;
#line 282 "toxencryptsave.vapi"
		__tmp4__size_ = _tmp4__length1;
#line 1204 "Profile.c"
	} else {
#line 282 "toxencryptsave.vapi"
		_tmp4_ = NULL;
#line 282 "toxencryptsave.vapi"
		_tmp4__length1 = 0;
#line 282 "toxencryptsave.vapi"
		__tmp4__size_ = _tmp4__length1;
#line 1212 "Profile.c"
	}
#line 282 "toxencryptsave.vapi"
	_tmp6_ = (_tmp4_ != NULL) ? _vala_array_dup4 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 282 "toxencryptsave.vapi"
	_tmp6__length1 = _tmp4__length1;
#line 282 "toxencryptsave.vapi"
	_tmp7_ = _tmp6_;
#line 282 "toxencryptsave.vapi"
	_tmp7__length1 = _tmp6__length1;
#line 282 "toxencryptsave.vapi"
	if (result_length1) {
#line 282 "toxencryptsave.vapi"
		*result_length1 = _tmp7__length1;
#line 1226 "Profile.c"
	}
#line 282 "toxencryptsave.vapi"
	result = _tmp7_;
#line 282 "toxencryptsave.vapi"
	t = (g_free (t), NULL);
#line 282 "toxencryptsave.vapi"
	if (_error_) {
#line 282 "toxencryptsave.vapi"
		*_error_ = _vala__error_;
#line 1236 "Profile.c"
	}
#line 282 "toxencryptsave.vapi"
	return result;
#line 1240 "Profile.c"
}

static const char*
_tox_err_get_salt_to_string (TOX_ERR_GET_SALT value)
{
#line 111 "../src/core/Profile.vala"
	switch (value) {
#line 111 "../src/core/Profile.vala"
		case TOX_ERR_GET_SALT_OK:
#line 111 "../src/core/Profile.vala"
		return "TOX_ERR_GET_SALT_OK";
#line 111 "../src/core/Profile.vala"
		case TOX_ERR_GET_SALT_NULL:
#line 111 "../src/core/Profile.vala"
		return "TOX_ERR_GET_SALT_NULL";
#line 111 "../src/core/Profile.vala"
		case TOX_ERR_GET_SALT_BAD_FORMAT:
#line 111 "../src/core/Profile.vala"
		return "TOX_ERR_GET_SALT_BAD_FORMAT";
#line 1260 "Profile.c"
	}
#line 111 "../src/core/Profile.vala"
	return NULL;
#line 1264 "Profile.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1555 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1556 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1556 "glib-2.0.vapi"
	res_length1 = -1;
#line 1556 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1557 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1557 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1557 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1558 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1558 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1558 "glib-2.0.vapi"
	if (result_length1) {
#line 1558 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1301 "Profile.c"
	}
#line 1558 "glib-2.0.vapi"
	result = _tmp2_;
#line 1558 "glib-2.0.vapi"
	return result;
#line 1307 "Profile.c"
}

static const char*
_tox_err_key_derivation_to_string (TOX_ERR_KEY_DERIVATION value)
{
#line 117 "../src/core/Profile.vala"
	switch (value) {
#line 117 "../src/core/Profile.vala"
		case TOX_ERR_KEY_DERIVATION_OK:
#line 117 "../src/core/Profile.vala"
		return "TOX_ERR_KEY_DERIVATION_OK";
#line 117 "../src/core/Profile.vala"
		case TOX_ERR_KEY_DERIVATION_NULL:
#line 117 "../src/core/Profile.vala"
		return "TOX_ERR_KEY_DERIVATION_NULL";
#line 117 "../src/core/Profile.vala"
		case TOX_ERR_KEY_DERIVATION_FAILED:
#line 117 "../src/core/Profile.vala"
		return "TOX_ERR_KEY_DERIVATION_FAILED";
#line 1327 "Profile.c"
	}
#line 117 "../src/core/Profile.vala"
	return NULL;
#line 1331 "Profile.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 124 "../src/core/Profile.vala"
	return self ? g_error_copy (self) : NULL;
#line 1339 "Profile.c"
}

guint8*
venom_profile_load (VenomProfile* self,
                    const gchar* password,
                    gint* result_length1,
                    GError** error)
{
	guint8* data = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_;
	gint data_length1;
	gint _data_size_;
	gboolean _tmp2_;
	guint8* _tmp36_;
	gint _tmp36__length1;
	GError* _inner_error0_ = NULL;
	guint8* result = NULL;
#line 105 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../src/core/Profile.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 106 "../src/core/Profile.vala"
	_tmp1_ = venom_profile_load_sessiondata (self, &_tmp0_, &_inner_error0_);
#line 106 "../src/core/Profile.vala"
	data = _tmp1_;
#line 106 "../src/core/Profile.vala"
	data_length1 = _tmp0_;
#line 106 "../src/core/Profile.vala"
	_data_size_ = data_length1;
#line 106 "../src/core/Profile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/core/Profile.vala"
		g_propagate_error (error, _inner_error0_);
#line 106 "../src/core/Profile.vala"
		return NULL;
#line 1376 "Profile.c"
	}
#line 107 "../src/core/Profile.vala"
	_tmp2_ = self->priv->_is_encrypted;
#line 107 "../src/core/Profile.vala"
	if (_tmp2_) {
#line 1382 "Profile.c"
		TOX_ERR_GET_SALT err_salt = 0;
		guint8* salt = NULL;
		guint8* _tmp3_;
		gint _tmp3__length1;
		TOX_ERR_GET_SALT _tmp4_ = 0;
		gint _tmp5_ = 0;
		guint8* _tmp6_;
		gint salt_length1;
		gint _salt_size_;
		TOX_ERR_GET_SALT _tmp7_;
		TOX_ERR_KEY_DERIVATION err_deriv = 0;
		guint8* _tmp14_;
		gint _tmp14__length1;
		gint _tmp15_ = 0;
		guint8* _tmp16_;
		gint _tmp16__length1;
		guint8* _tmp17_;
		gint _tmp17__length1;
		Tox_Pass_Key* _tmp18_;
		gboolean _tmp19_ = FALSE;
		TOX_ERR_KEY_DERIVATION _tmp20_;
#line 109 "../src/core/Profile.vala"
		_tmp3_ = data;
#line 109 "../src/core/Profile.vala"
		_tmp3__length1 = data_length1;
#line 109 "../src/core/Profile.vala"
		_tmp6_ = vala_tox_get_salt (_tmp3_, (gint) _tmp3__length1, &_tmp4_, &_tmp5_);
#line 109 "../src/core/Profile.vala"
		err_salt = _tmp4_;
#line 109 "../src/core/Profile.vala"
		salt = _tmp6_;
#line 109 "../src/core/Profile.vala"
		salt_length1 = _tmp5_;
#line 109 "../src/core/Profile.vala"
		_salt_size_ = salt_length1;
#line 110 "../src/core/Profile.vala"
		_tmp7_ = err_salt;
#line 110 "../src/core/Profile.vala"
		if (_tmp7_ != TOX_ERR_GET_SALT_OK) {
#line 1422 "Profile.c"
			TOX_ERR_GET_SALT _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GError* _tmp12_;
			GError* _tmp13_;
#line 111 "../src/core/Profile.vala"
			_tmp8_ = err_salt;
#line 111 "../src/core/Profile.vala"
			_tmp9_ = _tox_err_get_salt_to_string (_tmp8_);
#line 111 "../src/core/Profile.vala"
			_tmp10_ = g_strconcat ("Retrieving salt failed: ", _tmp9_, NULL);
#line 111 "../src/core/Profile.vala"
			_tmp11_ = _tmp10_;
#line 111 "../src/core/Profile.vala"
			_tmp12_ = g_error_new_literal (ERROR_ENCRYPTION, ERROR_ENCRYPTION_DECRYPT, _tmp11_);
#line 111 "../src/core/Profile.vala"
			_tmp13_ = _tmp12_;
#line 111 "../src/core/Profile.vala"
			_g_free0 (_tmp11_);
#line 111 "../src/core/Profile.vala"
			_inner_error0_ = _tmp13_;
#line 111 "../src/core/Profile.vala"
			g_propagate_error (error, _inner_error0_);
#line 111 "../src/core/Profile.vala"
			salt = (g_free (salt), NULL);
#line 111 "../src/core/Profile.vala"
			data = (g_free (data), NULL);
#line 111 "../src/core/Profile.vala"
			return NULL;
#line 1453 "Profile.c"
		}
#line 115 "../src/core/Profile.vala"
		_tmp14_ = string_get_data (password, &_tmp15_);
#line 115 "../src/core/Profile.vala"
		_tmp14__length1 = _tmp15_;
#line 115 "../src/core/Profile.vala"
		_tmp16_ = _tmp14_;
#line 115 "../src/core/Profile.vala"
		_tmp16__length1 = _tmp14__length1;
#line 115 "../src/core/Profile.vala"
		_tmp17_ = salt;
#line 115 "../src/core/Profile.vala"
		_tmp17__length1 = salt_length1;
#line 115 "../src/core/Profile.vala"
		_tmp18_ = tox_pass_key_derive_with_salt (_tmp16_, _tmp16__length1, _tmp17_, &err_deriv);
#line 115 "../src/core/Profile.vala"
		_tox_pass_key_free0 (self->pass_key);
#line 115 "../src/core/Profile.vala"
		self->pass_key = _tmp18_;
#line 116 "../src/core/Profile.vala"
		_tmp20_ = err_deriv;
#line 116 "../src/core/Profile.vala"
		if (_tmp20_ != TOX_ERR_KEY_DERIVATION_OK) {
#line 116 "../src/core/Profile.vala"
			_tmp19_ = TRUE;
#line 1479 "Profile.c"
		} else {
			Tox_Pass_Key* _tmp21_;
#line 116 "../src/core/Profile.vala"
			_tmp21_ = self->pass_key;
#line 116 "../src/core/Profile.vala"
			_tmp19_ = _tmp21_ == NULL;
#line 1486 "Profile.c"
		}
#line 116 "../src/core/Profile.vala"
		if (_tmp19_) {
#line 1490 "Profile.c"
			TOX_ERR_KEY_DERIVATION _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			GError* _tmp26_;
			GError* _tmp27_;
#line 117 "../src/core/Profile.vala"
			_tmp22_ = err_deriv;
#line 117 "../src/core/Profile.vala"
			_tmp23_ = _tox_err_key_derivation_to_string (_tmp22_);
#line 117 "../src/core/Profile.vala"
			_tmp24_ = g_strconcat ("PassKey derivation failed: ", _tmp23_, NULL);
#line 117 "../src/core/Profile.vala"
			_tmp25_ = _tmp24_;
#line 117 "../src/core/Profile.vala"
			_tmp26_ = g_error_new_literal (ERROR_ENCRYPTION, ERROR_ENCRYPTION_DECRYPT, _tmp25_);
#line 117 "../src/core/Profile.vala"
			_tmp27_ = _tmp26_;
#line 117 "../src/core/Profile.vala"
			_g_free0 (_tmp25_);
#line 117 "../src/core/Profile.vala"
			_inner_error0_ = _tmp27_;
#line 117 "../src/core/Profile.vala"
			g_propagate_error (error, _inner_error0_);
#line 117 "../src/core/Profile.vala"
			salt = (g_free (salt), NULL);
#line 117 "../src/core/Profile.vala"
			data = (g_free (data), NULL);
#line 117 "../src/core/Profile.vala"
			return NULL;
#line 1521 "Profile.c"
		}
		{
			guint8* _tmp28_ = NULL;
			guint8* _tmp29_;
			gint _tmp29__length1;
			gint _tmp30_ = 0;
			guint8* _tmp31_;
			gint _tmp28__length1;
			gint __tmp28__size_;
			guint8* _tmp32_;
			gint _tmp32__length1;
			guint8* _tmp33_;
			gint _tmp33__length1;
#line 121 "../src/core/Profile.vala"
			_tmp29_ = data;
#line 121 "../src/core/Profile.vala"
			_tmp29__length1 = data_length1;
#line 121 "../src/core/Profile.vala"
			_tmp31_ = venom_profile_decrypt (self, _tmp29_, (gint) _tmp29__length1, &_tmp30_, &_inner_error0_);
#line 121 "../src/core/Profile.vala"
			_tmp28_ = _tmp31_;
#line 121 "../src/core/Profile.vala"
			_tmp28__length1 = _tmp30_;
#line 121 "../src/core/Profile.vala"
			__tmp28__size_ = _tmp28__length1;
#line 121 "../src/core/Profile.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1549 "Profile.c"
				goto __catch0_g_error;
			}
#line 121 "../src/core/Profile.vala"
			_tmp32_ = _tmp28_;
#line 121 "../src/core/Profile.vala"
			_tmp32__length1 = _tmp28__length1;
#line 121 "../src/core/Profile.vala"
			_tmp28_ = NULL;
#line 121 "../src/core/Profile.vala"
			_tmp28__length1 = 0;
#line 121 "../src/core/Profile.vala"
			_tmp33_ = _tmp32_;
#line 121 "../src/core/Profile.vala"
			_tmp33__length1 = _tmp32__length1;
#line 121 "../src/core/Profile.vala"
			if (result_length1) {
#line 121 "../src/core/Profile.vala"
				*result_length1 = _tmp33__length1;
#line 1568 "Profile.c"
			}
#line 121 "../src/core/Profile.vala"
			result = _tmp33_;
#line 121 "../src/core/Profile.vala"
			_tmp28_ = (g_free (_tmp28_), NULL);
#line 121 "../src/core/Profile.vala"
			salt = (g_free (salt), NULL);
#line 121 "../src/core/Profile.vala"
			data = (g_free (data), NULL);
#line 121 "../src/core/Profile.vala"
			return result;
#line 1580 "Profile.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp34_;
			GError* _tmp35_;
#line 120 "../src/core/Profile.vala"
			e = _inner_error0_;
#line 120 "../src/core/Profile.vala"
			_inner_error0_ = NULL;
#line 123 "../src/core/Profile.vala"
			_tox_pass_key_free0 (self->pass_key);
#line 123 "../src/core/Profile.vala"
			self->pass_key = NULL;
#line 124 "../src/core/Profile.vala"
			_tmp34_ = e;
#line 124 "../src/core/Profile.vala"
			_tmp35_ = _g_error_copy0 (_tmp34_);
#line 124 "../src/core/Profile.vala"
			_inner_error0_ = _tmp35_;
#line 124 "../src/core/Profile.vala"
			_g_error_free0 (e);
#line 1604 "Profile.c"
			goto __finally0;
		}
		__finally0:
#line 120 "../src/core/Profile.vala"
		g_propagate_error (error, _inner_error0_);
#line 120 "../src/core/Profile.vala"
		salt = (g_free (salt), NULL);
#line 120 "../src/core/Profile.vala"
		data = (g_free (data), NULL);
#line 120 "../src/core/Profile.vala"
		return NULL;
#line 1616 "Profile.c"
	}
#line 127 "../src/core/Profile.vala"
	_tmp36_ = data;
#line 127 "../src/core/Profile.vala"
	_tmp36__length1 = data_length1;
#line 127 "../src/core/Profile.vala"
	if (result_length1) {
#line 127 "../src/core/Profile.vala"
		*result_length1 = _tmp36__length1;
#line 1626 "Profile.c"
	}
#line 127 "../src/core/Profile.vala"
	result = _tmp36_;
#line 127 "../src/core/Profile.vala"
	return result;
#line 1632 "Profile.c"
}

gboolean
venom_profile_is_sane (VenomProfile* self)
{
	gchar* baseprof = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	gboolean result = FALSE;
#line 130 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_dir;
#line 131 "../src/core/Profile.vala"
	_tmp1_ = self->priv->_name;
#line 131 "../src/core/Profile.vala"
	_tmp2_ = g_build_filename (_tmp0_, _tmp1_, NULL);
#line 131 "../src/core/Profile.vala"
	baseprof = _tmp2_;
#line 132 "../src/core/Profile.vala"
	_tmp4_ = baseprof;
#line 132 "../src/core/Profile.vala"
	_tmp5_ = g_strconcat (_tmp4_, ".tox", NULL);
#line 132 "../src/core/Profile.vala"
	_tmp6_ = _tmp5_;
#line 132 "../src/core/Profile.vala"
	_tmp7_ = venom_profile_exists (_tmp6_);
#line 132 "../src/core/Profile.vala"
	_g_free0 (_tmp6_);
#line 132 "../src/core/Profile.vala"
	if (_tmp7_) {
#line 1670 "Profile.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 132 "../src/core/Profile.vala"
		_tmp8_ = baseprof;
#line 132 "../src/core/Profile.vala"
		_tmp9_ = g_strconcat (_tmp8_, ".db", NULL);
#line 132 "../src/core/Profile.vala"
		_tmp10_ = _tmp9_;
#line 132 "../src/core/Profile.vala"
		_tmp3_ = venom_profile_exists (_tmp10_);
#line 132 "../src/core/Profile.vala"
		_g_free0 (_tmp10_);
#line 1684 "Profile.c"
	} else {
#line 132 "../src/core/Profile.vala"
		_tmp3_ = FALSE;
#line 1688 "Profile.c"
	}
#line 132 "../src/core/Profile.vala"
	result = _tmp3_;
#line 132 "../src/core/Profile.vala"
	_g_free0 (baseprof);
#line 132 "../src/core/Profile.vala"
	return result;
#line 1696 "Profile.c"
}

VenomProfile*
venom_profile_create (const gchar* path,
                      const gchar* username,
                      const gchar* password,
                      GError** error)
{
	VenomProfile* profile = NULL;
	VenomProfile* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GError* _inner_error0_ = NULL;
	VenomProfile* result = NULL;
#line 135 "../src/core/Profile.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 135 "../src/core/Profile.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 135 "../src/core/Profile.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 136 "../src/core/Profile.vala"
	_tmp0_ = venom_profile_new (path, username);
#line 136 "../src/core/Profile.vala"
	profile = _tmp0_;
#line 138 "../src/core/Profile.vala"
	_tmp1_ = strlen (password);
#line 138 "../src/core/Profile.vala"
	_tmp2_ = _tmp1_;
#line 138 "../src/core/Profile.vala"
	if (_tmp2_ > 0) {
#line 1727 "Profile.c"
		TOX_ERR_KEY_DERIVATION err = 0;
		VenomProfile* _tmp3_;
		guint8* _tmp4_;
		gint _tmp4__length1;
		gint _tmp5_ = 0;
		guint8* _tmp6_;
		gint _tmp6__length1;
		Tox_Pass_Key* _tmp7_;
		TOX_ERR_KEY_DERIVATION _tmp8_;
		VenomProfile* _tmp15_;
#line 140 "../src/core/Profile.vala"
		_tmp3_ = profile;
#line 140 "../src/core/Profile.vala"
		_tmp4_ = string_get_data (password, &_tmp5_);
#line 140 "../src/core/Profile.vala"
		_tmp4__length1 = _tmp5_;
#line 140 "../src/core/Profile.vala"
		_tmp6_ = _tmp4_;
#line 140 "../src/core/Profile.vala"
		_tmp6__length1 = _tmp4__length1;
#line 140 "../src/core/Profile.vala"
		_tmp7_ = tox_pass_key_derive (_tmp6_, _tmp6__length1, &err);
#line 140 "../src/core/Profile.vala"
		_tox_pass_key_free0 (_tmp3_->pass_key);
#line 140 "../src/core/Profile.vala"
		_tmp3_->pass_key = _tmp7_;
#line 141 "../src/core/Profile.vala"
		_tmp8_ = err;
#line 141 "../src/core/Profile.vala"
		if (_tmp8_ != TOX_ERR_KEY_DERIVATION_OK) {
#line 1758 "Profile.c"
			TOX_ERR_KEY_DERIVATION _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			GError* _tmp13_;
			GError* _tmp14_;
#line 142 "../src/core/Profile.vala"
			_tmp9_ = err;
#line 142 "../src/core/Profile.vala"
			_tmp10_ = _tox_err_key_derivation_to_string (_tmp9_);
#line 142 "../src/core/Profile.vala"
			_tmp11_ = g_strconcat ("PassKey derivation failed: ", _tmp10_, NULL);
#line 142 "../src/core/Profile.vala"
			_tmp12_ = _tmp11_;
#line 142 "../src/core/Profile.vala"
			_tmp13_ = g_error_new_literal (ERROR_ENCRYPTION, ERROR_ENCRYPTION_CREATE, _tmp12_);
#line 142 "../src/core/Profile.vala"
			_tmp14_ = _tmp13_;
#line 142 "../src/core/Profile.vala"
			_g_free0 (_tmp12_);
#line 142 "../src/core/Profile.vala"
			_inner_error0_ = _tmp14_;
#line 142 "../src/core/Profile.vala"
			g_propagate_error (error, _inner_error0_);
#line 142 "../src/core/Profile.vala"
			_g_object_unref0 (profile);
#line 142 "../src/core/Profile.vala"
			return NULL;
#line 1787 "Profile.c"
		}
#line 144 "../src/core/Profile.vala"
		_tmp15_ = profile;
#line 144 "../src/core/Profile.vala"
		venom_profile_set_is_encrypted (_tmp15_, TRUE);
#line 1793 "Profile.c"
	}
#line 147 "../src/core/Profile.vala"
	result = profile;
#line 147 "../src/core/Profile.vala"
	return result;
#line 1799 "Profile.c"
}

gboolean
venom_profile_is_username_available (const gchar* path,
                                     const gchar* username)
{
	gchar* baseprof = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	gboolean result = FALSE;
#line 150 "../src/core/Profile.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 150 "../src/core/Profile.vala"
	g_return_val_if_fail (username != NULL, FALSE);
#line 151 "../src/core/Profile.vala"
	_tmp0_ = g_build_filename (path, username, NULL);
#line 151 "../src/core/Profile.vala"
	baseprof = _tmp0_;
#line 152 "../src/core/Profile.vala"
	_tmp4_ = baseprof;
#line 152 "../src/core/Profile.vala"
	_tmp5_ = g_strconcat (_tmp4_, ".tox", NULL);
#line 152 "../src/core/Profile.vala"
	_tmp6_ = _tmp5_;
#line 152 "../src/core/Profile.vala"
	_tmp7_ = !venom_profile_exists (_tmp6_);
#line 152 "../src/core/Profile.vala"
	_g_free0 (_tmp6_);
#line 152 "../src/core/Profile.vala"
	if (_tmp7_) {
#line 1836 "Profile.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 152 "../src/core/Profile.vala"
		_tmp8_ = baseprof;
#line 152 "../src/core/Profile.vala"
		_tmp9_ = g_strconcat (_tmp8_, ".db", NULL);
#line 152 "../src/core/Profile.vala"
		_tmp10_ = _tmp9_;
#line 152 "../src/core/Profile.vala"
		_tmp3_ = !venom_profile_exists (_tmp10_);
#line 152 "../src/core/Profile.vala"
		_g_free0 (_tmp10_);
#line 1850 "Profile.c"
	} else {
#line 152 "../src/core/Profile.vala"
		_tmp3_ = FALSE;
#line 1854 "Profile.c"
	}
#line 152 "../src/core/Profile.vala"
	if (_tmp3_) {
#line 1858 "Profile.c"
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 153 "../src/core/Profile.vala"
		_tmp11_ = baseprof;
#line 153 "../src/core/Profile.vala"
		_tmp12_ = g_strconcat (_tmp11_, ".json", NULL);
#line 153 "../src/core/Profile.vala"
		_tmp13_ = _tmp12_;
#line 153 "../src/core/Profile.vala"
		_tmp2_ = !venom_profile_exists (_tmp13_);
#line 153 "../src/core/Profile.vala"
		_g_free0 (_tmp13_);
#line 1872 "Profile.c"
	} else {
#line 152 "../src/core/Profile.vala"
		_tmp2_ = FALSE;
#line 1876 "Profile.c"
	}
#line 152 "../src/core/Profile.vala"
	if (_tmp2_) {
#line 1880 "Profile.c"
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 153 "../src/core/Profile.vala"
		_tmp14_ = baseprof;
#line 153 "../src/core/Profile.vala"
		_tmp15_ = g_strconcat (_tmp14_, ".accels", NULL);
#line 153 "../src/core/Profile.vala"
		_tmp16_ = _tmp15_;
#line 153 "../src/core/Profile.vala"
		_tmp1_ = !venom_profile_exists (_tmp16_);
#line 153 "../src/core/Profile.vala"
		_g_free0 (_tmp16_);
#line 1894 "Profile.c"
	} else {
#line 152 "../src/core/Profile.vala"
		_tmp1_ = FALSE;
#line 1898 "Profile.c"
	}
#line 152 "../src/core/Profile.vala"
	result = _tmp1_;
#line 152 "../src/core/Profile.vala"
	_g_free0 (baseprof);
#line 152 "../src/core/Profile.vala"
	return result;
#line 1906 "Profile.c"
}

static gboolean
venom_profile_exists (const gchar* path)
{
	gboolean result = FALSE;
#line 156 "../src/core/Profile.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 157 "../src/core/Profile.vala"
	result = g_file_test (path, G_FILE_TEST_EXISTS);
#line 157 "../src/core/Profile.vala"
	return result;
#line 1919 "Profile.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
#line 1447 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1447 "glib-2.0.vapi"
	end = _tmp0_;
#line 1448 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1448 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1449 "glib-2.0.vapi"
		result = maxlen;
#line 1449 "glib-2.0.vapi"
		return result;
#line 1942 "Profile.c"
	} else {
		gchar* _tmp2_;
#line 1451 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1451 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1451 "glib-2.0.vapi"
		return result;
#line 1951 "Profile.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 1458 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1970 "Profile.c"
	} else {
#line 1460 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1974 "Profile.c"
	}
#line 1460 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1462 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1980 "Profile.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1464 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1464 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1464 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1990 "Profile.c"
	}
#line 1467 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1469 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1998 "Profile.c"
	} else {
#line 1471 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 2002 "Profile.c"
	}
#line 1473 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1474 "glib-2.0.vapi"
		len = string_length - offset;
#line 2008 "Profile.c"
	}
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1477 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1477 "glib-2.0.vapi"
	result = _tmp3_;
#line 1477 "glib-2.0.vapi"
	return result;
#line 2018 "Profile.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1143 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1144 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1144 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1146 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1146 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 2042 "Profile.c"
		gchar* _tmp2_;
#line 1147 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1147 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1147 "glib-2.0.vapi"
		return result;
#line 2050 "Profile.c"
	} else {
#line 1149 "glib-2.0.vapi"
		result = -1;
#line 1149 "glib-2.0.vapi"
		return result;
#line 2056 "Profile.c"
	}
}

GeeIterable*
venom_profile_scan_profiles (VenomLogger* logger,
                             const gchar* directory)
{
	GeeLinkedList* profiles = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeIterable* result = NULL;
#line 160 "../src/core/Profile.vala"
	g_return_val_if_fail (logger != NULL, NULL);
#line 160 "../src/core/Profile.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 161 "../src/core/Profile.vala"
	_tmp0_ = gee_linked_list_new (VENOM_TYPE_PROFILE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 161 "../src/core/Profile.vala"
	profiles = _tmp0_;
#line 2076 "Profile.c"
	{
		GDir* dir = NULL;
		GDir* _tmp1_;
		gchar* name = NULL;
#line 163 "../src/core/Profile.vala"
		_tmp1_ = g_dir_open (directory, (guint) 0, &_inner_error0_);
#line 163 "../src/core/Profile.vala"
		dir = _tmp1_;
#line 163 "../src/core/Profile.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../src/core/Profile.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2089 "Profile.c"
				goto __catch0_g_file_error;
			}
#line 163 "../src/core/Profile.vala"
			_g_object_unref0 (profiles);
#line 163 "../src/core/Profile.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 163 "../src/core/Profile.vala"
			g_clear_error (&_inner_error0_);
#line 163 "../src/core/Profile.vala"
			return NULL;
#line 2100 "Profile.c"
		}
#line 164 "../src/core/Profile.vala"
		name = NULL;
#line 166 "../src/core/Profile.vala"
		while (TRUE) {
#line 2106 "Profile.c"
			GDir* _tmp2_;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* path = NULL;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gboolean _tmp8_ = FALSE;
			const gchar* _tmp9_;
#line 166 "../src/core/Profile.vala"
			_tmp2_ = dir;
#line 166 "../src/core/Profile.vala"
			_tmp3_ = g_dir_read_name (_tmp2_);
#line 166 "../src/core/Profile.vala"
			_tmp4_ = g_strdup (_tmp3_);
#line 166 "../src/core/Profile.vala"
			_g_free0 (name);
#line 166 "../src/core/Profile.vala"
			name = _tmp4_;
#line 166 "../src/core/Profile.vala"
			_tmp5_ = name;
#line 166 "../src/core/Profile.vala"
			if (!(_tmp5_ != NULL)) {
#line 166 "../src/core/Profile.vala"
				break;
#line 2132 "Profile.c"
			}
#line 167 "../src/core/Profile.vala"
			_tmp6_ = name;
#line 167 "../src/core/Profile.vala"
			_tmp7_ = g_build_filename (directory, _tmp6_, NULL);
#line 167 "../src/core/Profile.vala"
			path = _tmp7_;
#line 168 "../src/core/Profile.vala"
			_tmp9_ = name;
#line 168 "../src/core/Profile.vala"
			if (g_str_has_suffix (_tmp9_, ".tox")) {
#line 2144 "Profile.c"
				const gchar* _tmp10_;
#line 168 "../src/core/Profile.vala"
				_tmp10_ = path;
#line 168 "../src/core/Profile.vala"
				_tmp8_ = g_file_test (_tmp10_, G_FILE_TEST_IS_REGULAR);
#line 2150 "Profile.c"
			} else {
#line 168 "../src/core/Profile.vala"
				_tmp8_ = FALSE;
#line 2154 "Profile.c"
			}
#line 168 "../src/core/Profile.vala"
			if (_tmp8_) {
#line 2158 "Profile.c"
				VenomProfile* profile = NULL;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				VenomProfile* _tmp15_;
				VenomProfile* _tmp16_;
				VenomProfile* _tmp17_;
				VenomProfile* _tmp18_;
				GeeLinkedList* _tmp19_;
				VenomProfile* _tmp20_;
#line 169 "../src/core/Profile.vala"
				_tmp11_ = name;
#line 169 "../src/core/Profile.vala"
				_tmp12_ = name;
#line 169 "../src/core/Profile.vala"
				_tmp13_ = string_substring (_tmp11_, (glong) 0, (glong) string_last_index_of (_tmp12_, ".tox", 0));
#line 169 "../src/core/Profile.vala"
				_tmp14_ = _tmp13_;
#line 169 "../src/core/Profile.vala"
				_tmp15_ = venom_profile_new (directory, _tmp14_);
#line 169 "../src/core/Profile.vala"
				_tmp16_ = _tmp15_;
#line 169 "../src/core/Profile.vala"
				_g_free0 (_tmp14_);
#line 169 "../src/core/Profile.vala"
				profile = _tmp16_;
#line 170 "../src/core/Profile.vala"
				_tmp17_ = profile;
#line 170 "../src/core/Profile.vala"
				_tmp18_ = profile;
#line 170 "../src/core/Profile.vala"
				venom_profile_set_is_encrypted (_tmp17_, venom_profile_test_is_encrypted (_tmp18_));
#line 171 "../src/core/Profile.vala"
				_tmp19_ = profiles;
#line 171 "../src/core/Profile.vala"
				_tmp20_ = profile;
#line 171 "../src/core/Profile.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 168 "../src/core/Profile.vala"
				_g_object_unref0 (profile);
#line 2200 "Profile.c"
			}
#line 166 "../src/core/Profile.vala"
			_g_free0 (path);
#line 2204 "Profile.c"
		}
#line 162 "../src/core/Profile.vala"
		_g_free0 (name);
#line 162 "../src/core/Profile.vala"
		_g_dir_close0 (dir);
#line 2210 "Profile.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 162 "../src/core/Profile.vala"
		e = _inner_error0_;
#line 162 "../src/core/Profile.vala"
		_inner_error0_ = NULL;
#line 175 "../src/core/Profile.vala"
		_tmp21_ = e;
#line 175 "../src/core/Profile.vala"
		_tmp22_ = _tmp21_->message;
#line 175 "../src/core/Profile.vala"
		_tmp23_ = g_strconcat ("When scanning profiles: ", _tmp22_, NULL);
#line 175 "../src/core/Profile.vala"
		_tmp24_ = _tmp23_;
#line 175 "../src/core/Profile.vala"
		venom_logger_w (logger, _tmp24_);
#line 175 "../src/core/Profile.vala"
		_g_free0 (_tmp24_);
#line 162 "../src/core/Profile.vala"
		_g_error_free0 (e);
#line 2238 "Profile.c"
	}
	__finally0:
#line 162 "../src/core/Profile.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "../src/core/Profile.vala"
		_g_object_unref0 (profiles);
#line 162 "../src/core/Profile.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../src/core/Profile.vala"
		g_clear_error (&_inner_error0_);
#line 162 "../src/core/Profile.vala"
		return NULL;
#line 2251 "Profile.c"
	}
#line 177 "../src/core/Profile.vala"
	result = (GeeIterable*) profiles;
#line 177 "../src/core/Profile.vala"
	return result;
#line 2257 "Profile.c"
}

const gchar*
venom_profile_get_name (VenomProfile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_name;
#line 30 "../src/core/Profile.vala"
	result = _tmp0_;
#line 30 "../src/core/Profile.vala"
	return result;
#line 2273 "Profile.c"
}

void
venom_profile_set_name (VenomProfile* self,
                        const gchar* value)
{
#line 30 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/core/Profile.vala"
	if (g_strcmp0 (value, venom_profile_get_name (self)) != 0) {
#line 2284 "Profile.c"
		gchar* _tmp0_;
#line 30 "../src/core/Profile.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/core/Profile.vala"
		_g_free0 (self->priv->_name);
#line 30 "../src/core/Profile.vala"
		self->priv->_name = _tmp0_;
#line 30 "../src/core/Profile.vala"
		g_object_notify_by_pspec ((GObject *) self, venom_profile_properties[VENOM_PROFILE_NAME_PROPERTY]);
#line 2294 "Profile.c"
	}
}

const gchar*
venom_profile_get_dir (VenomProfile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_dir;
#line 31 "../src/core/Profile.vala"
	result = _tmp0_;
#line 31 "../src/core/Profile.vala"
	return result;
#line 2311 "Profile.c"
}

void
venom_profile_set_dir (VenomProfile* self,
                       const gchar* value)
{
#line 31 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/core/Profile.vala"
	if (g_strcmp0 (value, venom_profile_get_dir (self)) != 0) {
#line 2322 "Profile.c"
		gchar* _tmp0_;
#line 31 "../src/core/Profile.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/core/Profile.vala"
		_g_free0 (self->priv->_dir);
#line 31 "../src/core/Profile.vala"
		self->priv->_dir = _tmp0_;
#line 31 "../src/core/Profile.vala"
		g_object_notify_by_pspec ((GObject *) self, venom_profile_properties[VENOM_PROFILE_DIR_PROPERTY]);
#line 2332 "Profile.c"
	}
}

const gchar*
venom_profile_get_toxfile (VenomProfile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_toxfile;
#line 32 "../src/core/Profile.vala"
	result = _tmp0_;
#line 32 "../src/core/Profile.vala"
	return result;
#line 2349 "Profile.c"
}

void
venom_profile_set_toxfile (VenomProfile* self,
                           const gchar* value)
{
#line 32 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/core/Profile.vala"
	if (g_strcmp0 (value, venom_profile_get_toxfile (self)) != 0) {
#line 2360 "Profile.c"
		gchar* _tmp0_;
#line 32 "../src/core/Profile.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/core/Profile.vala"
		_g_free0 (self->priv->_toxfile);
#line 32 "../src/core/Profile.vala"
		self->priv->_toxfile = _tmp0_;
#line 32 "../src/core/Profile.vala"
		g_object_notify_by_pspec ((GObject *) self, venom_profile_properties[VENOM_PROFILE_TOXFILE_PROPERTY]);
#line 2370 "Profile.c"
	}
}

const gchar*
venom_profile_get_windowstatefile (VenomProfile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_windowstatefile;
#line 33 "../src/core/Profile.vala"
	result = _tmp0_;
#line 33 "../src/core/Profile.vala"
	return result;
#line 2387 "Profile.c"
}

void
venom_profile_set_windowstatefile (VenomProfile* self,
                                   const gchar* value)
{
#line 33 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/core/Profile.vala"
	if (g_strcmp0 (value, venom_profile_get_windowstatefile (self)) != 0) {
#line 2398 "Profile.c"
		gchar* _tmp0_;
#line 33 "../src/core/Profile.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/core/Profile.vala"
		_g_free0 (self->priv->_windowstatefile);
#line 33 "../src/core/Profile.vala"
		self->priv->_windowstatefile = _tmp0_;
#line 33 "../src/core/Profile.vala"
		g_object_notify_by_pspec ((GObject *) self, venom_profile_properties[VENOM_PROFILE_WINDOWSTATEFILE_PROPERTY]);
#line 2408 "Profile.c"
	}
}

const gchar*
venom_profile_get_dbfile (VenomProfile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_dbfile;
#line 34 "../src/core/Profile.vala"
	result = _tmp0_;
#line 34 "../src/core/Profile.vala"
	return result;
#line 2425 "Profile.c"
}

void
venom_profile_set_dbfile (VenomProfile* self,
                          const gchar* value)
{
#line 34 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/core/Profile.vala"
	if (g_strcmp0 (value, venom_profile_get_dbfile (self)) != 0) {
#line 2436 "Profile.c"
		gchar* _tmp0_;
#line 34 "../src/core/Profile.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/core/Profile.vala"
		_g_free0 (self->priv->_dbfile);
#line 34 "../src/core/Profile.vala"
		self->priv->_dbfile = _tmp0_;
#line 34 "../src/core/Profile.vala"
		g_object_notify_by_pspec ((GObject *) self, venom_profile_properties[VENOM_PROFILE_DBFILE_PROPERTY]);
#line 2446 "Profile.c"
	}
}

const gchar*
venom_profile_get_accelsfile (VenomProfile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/core/Profile.vala"
	_tmp0_ = self->priv->_accelsfile;
#line 35 "../src/core/Profile.vala"
	result = _tmp0_;
#line 35 "../src/core/Profile.vala"
	return result;
#line 2463 "Profile.c"
}

void
venom_profile_set_accelsfile (VenomProfile* self,
                              const gchar* value)
{
#line 35 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/core/Profile.vala"
	if (g_strcmp0 (value, venom_profile_get_accelsfile (self)) != 0) {
#line 2474 "Profile.c"
		gchar* _tmp0_;
#line 35 "../src/core/Profile.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/core/Profile.vala"
		_g_free0 (self->priv->_accelsfile);
#line 35 "../src/core/Profile.vala"
		self->priv->_accelsfile = _tmp0_;
#line 35 "../src/core/Profile.vala"
		g_object_notify_by_pspec ((GObject *) self, venom_profile_properties[VENOM_PROFILE_ACCELSFILE_PROPERTY]);
#line 2484 "Profile.c"
	}
}

gboolean
venom_profile_get_is_encrypted (VenomProfile* self)
{
	gboolean result;
#line 36 "../src/core/Profile.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/core/Profile.vala"
	result = self->priv->_is_encrypted;
#line 36 "../src/core/Profile.vala"
	return result;
#line 2498 "Profile.c"
}

void
venom_profile_set_is_encrypted (VenomProfile* self,
                                gboolean value)
{
#line 36 "../src/core/Profile.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/core/Profile.vala"
	if (venom_profile_get_is_encrypted (self) != value) {
#line 36 "../src/core/Profile.vala"
		self->priv->_is_encrypted = value;
#line 36 "../src/core/Profile.vala"
		g_object_notify_by_pspec ((GObject *) self, venom_profile_properties[VENOM_PROFILE_IS_ENCRYPTED_PROPERTY]);
#line 2513 "Profile.c"
	}
}

static void
venom_profile_class_init (VenomProfileClass * klass,
                          gpointer klass_data)
{
#line 29 "../src/core/Profile.vala"
	venom_profile_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/core/Profile.vala"
	g_type_class_adjust_private_offset (klass, &VenomProfile_private_offset);
#line 29 "../src/core/Profile.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_venom_profile_get_property;
#line 29 "../src/core/Profile.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_venom_profile_set_property;
#line 29 "../src/core/Profile.vala"
	G_OBJECT_CLASS (klass)->finalize = venom_profile_finalize;
#line 29 "../src/core/Profile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VENOM_PROFILE_NAME_PROPERTY, venom_profile_properties[VENOM_PROFILE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/core/Profile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VENOM_PROFILE_DIR_PROPERTY, venom_profile_properties[VENOM_PROFILE_DIR_PROPERTY] = g_param_spec_string ("dir", "dir", "dir", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/core/Profile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VENOM_PROFILE_TOXFILE_PROPERTY, venom_profile_properties[VENOM_PROFILE_TOXFILE_PROPERTY] = g_param_spec_string ("toxfile", "toxfile", "toxfile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/core/Profile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VENOM_PROFILE_WINDOWSTATEFILE_PROPERTY, venom_profile_properties[VENOM_PROFILE_WINDOWSTATEFILE_PROPERTY] = g_param_spec_string ("windowstatefile", "windowstatefile", "windowstatefile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/core/Profile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VENOM_PROFILE_DBFILE_PROPERTY, venom_profile_properties[VENOM_PROFILE_DBFILE_PROPERTY] = g_param_spec_string ("dbfile", "dbfile", "dbfile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/core/Profile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VENOM_PROFILE_ACCELSFILE_PROPERTY, venom_profile_properties[VENOM_PROFILE_ACCELSFILE_PROPERTY] = g_param_spec_string ("accelsfile", "accelsfile", "accelsfile", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/core/Profile.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VENOM_PROFILE_IS_ENCRYPTED_PROPERTY, venom_profile_properties[VENOM_PROFILE_IS_ENCRYPTED_PROPERTY] = g_param_spec_boolean ("is-encrypted", "is-encrypted", "is-encrypted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2545 "Profile.c"
}

static void
venom_profile_instance_init (VenomProfile * self,
                             gpointer klass)
{
#line 29 "../src/core/Profile.vala"
	self->priv = venom_profile_get_instance_private (self);
#line 37 "../src/core/Profile.vala"
	self->pass_key = NULL;
#line 2556 "Profile.c"
}

static void
venom_profile_finalize (GObject * obj)
{
	VenomProfile * self;
#line 29 "../src/core/Profile.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VENOM_TYPE_PROFILE, VenomProfile);
#line 30 "../src/core/Profile.vala"
	_g_free0 (self->priv->_name);
#line 31 "../src/core/Profile.vala"
	_g_free0 (self->priv->_dir);
#line 32 "../src/core/Profile.vala"
	_g_free0 (self->priv->_toxfile);
#line 33 "../src/core/Profile.vala"
	_g_free0 (self->priv->_windowstatefile);
#line 34 "../src/core/Profile.vala"
	_g_free0 (self->priv->_dbfile);
#line 35 "../src/core/Profile.vala"
	_g_free0 (self->priv->_accelsfile);
#line 37 "../src/core/Profile.vala"
	_tox_pass_key_free0 (self->pass_key);
#line 29 "../src/core/Profile.vala"
	G_OBJECT_CLASS (venom_profile_parent_class)->finalize (obj);
#line 2581 "Profile.c"
}

static GType
venom_profile_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomProfileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_profile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VenomProfile), 0, (GInstanceInitFunc) venom_profile_instance_init, NULL };
	GType venom_profile_type_id;
	venom_profile_type_id = g_type_register_static (G_TYPE_OBJECT, "VenomProfile", &g_define_type_info, 0);
	VenomProfile_private_offset = g_type_add_instance_private (venom_profile_type_id, sizeof (VenomProfilePrivate));
	return venom_profile_type_id;
}

GType
venom_profile_get_type (void)
{
	static volatile gsize venom_profile_type_id__volatile = 0;
	if (g_once_init_enter (&venom_profile_type_id__volatile)) {
		GType venom_profile_type_id;
		venom_profile_type_id = venom_profile_get_type_once ();
		g_once_init_leave (&venom_profile_type_id__volatile, venom_profile_type_id);
	}
	return venom_profile_type_id__volatile;
}

static void
_vala_venom_profile_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	VenomProfile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VENOM_TYPE_PROFILE, VenomProfile);
#line 29 "../src/core/Profile.vala"
	switch (property_id) {
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_NAME_PROPERTY:
#line 29 "../src/core/Profile.vala"
		g_value_set_string (value, venom_profile_get_name (self));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_DIR_PROPERTY:
#line 29 "../src/core/Profile.vala"
		g_value_set_string (value, venom_profile_get_dir (self));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_TOXFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		g_value_set_string (value, venom_profile_get_toxfile (self));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_WINDOWSTATEFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		g_value_set_string (value, venom_profile_get_windowstatefile (self));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_DBFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		g_value_set_string (value, venom_profile_get_dbfile (self));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_ACCELSFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		g_value_set_string (value, venom_profile_get_accelsfile (self));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_IS_ENCRYPTED_PROPERTY:
#line 29 "../src/core/Profile.vala"
		g_value_set_boolean (value, venom_profile_get_is_encrypted (self));
#line 29 "../src/core/Profile.vala"
		break;
#line 2658 "Profile.c"
		default:
#line 29 "../src/core/Profile.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/core/Profile.vala"
		break;
#line 2664 "Profile.c"
	}
}

static void
_vala_venom_profile_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	VenomProfile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VENOM_TYPE_PROFILE, VenomProfile);
#line 29 "../src/core/Profile.vala"
	switch (property_id) {
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_NAME_PROPERTY:
#line 29 "../src/core/Profile.vala"
		venom_profile_set_name (self, g_value_get_string (value));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_DIR_PROPERTY:
#line 29 "../src/core/Profile.vala"
		venom_profile_set_dir (self, g_value_get_string (value));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_TOXFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		venom_profile_set_toxfile (self, g_value_get_string (value));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_WINDOWSTATEFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		venom_profile_set_windowstatefile (self, g_value_get_string (value));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_DBFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		venom_profile_set_dbfile (self, g_value_get_string (value));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_ACCELSFILE_PROPERTY:
#line 29 "../src/core/Profile.vala"
		venom_profile_set_accelsfile (self, g_value_get_string (value));
#line 29 "../src/core/Profile.vala"
		break;
#line 29 "../src/core/Profile.vala"
		case VENOM_PROFILE_IS_ENCRYPTED_PROPERTY:
#line 29 "../src/core/Profile.vala"
		venom_profile_set_is_encrypted (self, g_value_get_boolean (value));
#line 29 "../src/core/Profile.vala"
		break;
#line 2720 "Profile.c"
		default:
#line 29 "../src/core/Profile.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/core/Profile.vala"
		break;
#line 2726 "Profile.c"
	}
}

