/* TimeStamp.c generated by valac 0.48.3, the Vala compiler
 * generated from TimeStamp.vala, do not modify */

/*
 *    TimeStamp.vala
 *
 *    Copyright (C) 2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

gchar* venom_time_stamp_get_pretty_timestamp (GDateTime* timestamp,
                                              GDateTime* now);

gchar*
venom_time_stamp_get_pretty_timestamp (GDateTime* timestamp,
                                       GDateTime* now)
{
	GDateTime* just_now = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* minutes_ago = NULL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* hours_ago = NULL;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	GDateTime* midnight = NULL;
	GDateTime* _tmp9_;
	GDateTime* _tmp10_;
	GDateTime* yesterday = NULL;
	GDateTime* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	gchar* _tmp22_;
	gchar* result = NULL;
#line 23 "../src/core/TimeStamp.vala"
	g_return_val_if_fail (timestamp != NULL, NULL);
#line 23 "../src/core/TimeStamp.vala"
	g_return_val_if_fail (now != NULL, NULL);
#line 24 "../src/core/TimeStamp.vala"
	_tmp0_ = g_date_time_add_minutes (now, -1);
#line 24 "../src/core/TimeStamp.vala"
	just_now = _tmp0_;
#line 25 "../src/core/TimeStamp.vala"
	_tmp1_ = just_now;
#line 25 "../src/core/TimeStamp.vala"
	if (g_date_time_compare (timestamp, _tmp1_) > 0) {
#line 73 "TimeStamp.c"
		gchar* _tmp2_;
#line 26 "../src/core/TimeStamp.vala"
		_tmp2_ = g_strdup (_ ("Just now"));
#line 26 "../src/core/TimeStamp.vala"
		result = _tmp2_;
#line 26 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (just_now);
#line 26 "../src/core/TimeStamp.vala"
		return result;
#line 83 "TimeStamp.c"
	}
#line 28 "../src/core/TimeStamp.vala"
	_tmp3_ = g_date_time_add_minutes (now, -59);
#line 28 "../src/core/TimeStamp.vala"
	minutes_ago = _tmp3_;
#line 29 "../src/core/TimeStamp.vala"
	_tmp4_ = minutes_ago;
#line 29 "../src/core/TimeStamp.vala"
	if (g_date_time_compare (timestamp, _tmp4_) > 0) {
#line 93 "TimeStamp.c"
		guint minutes = 0U;
		gchar* _tmp5_;
#line 30 "../src/core/TimeStamp.vala"
		minutes = (guint) (g_date_time_difference (now, timestamp) / G_TIME_SPAN_MINUTE);
#line 31 "../src/core/TimeStamp.vala"
		_tmp5_ = g_strdup_printf (ngettext ("%u minute ago", "%u minutes ago", (gulong) minutes), minutes);
#line 31 "../src/core/TimeStamp.vala"
		result = _tmp5_;
#line 31 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (minutes_ago);
#line 31 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (just_now);
#line 31 "../src/core/TimeStamp.vala"
		return result;
#line 108 "TimeStamp.c"
	}
#line 33 "../src/core/TimeStamp.vala"
	_tmp6_ = g_date_time_add_hours (now, -6);
#line 33 "../src/core/TimeStamp.vala"
	hours_ago = _tmp6_;
#line 34 "../src/core/TimeStamp.vala"
	_tmp7_ = hours_ago;
#line 34 "../src/core/TimeStamp.vala"
	if (g_date_time_compare (timestamp, _tmp7_) > 0) {
#line 118 "TimeStamp.c"
		guint hours = 0U;
		gchar* _tmp8_;
#line 35 "../src/core/TimeStamp.vala"
		hours = (guint) (g_date_time_difference (now, timestamp) / G_TIME_SPAN_HOUR);
#line 36 "../src/core/TimeStamp.vala"
		_tmp8_ = g_strdup_printf (ngettext ("%u hour ago", "%u hours ago", (gulong) hours), hours);
#line 36 "../src/core/TimeStamp.vala"
		result = _tmp8_;
#line 36 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (hours_ago);
#line 36 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (minutes_ago);
#line 36 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (just_now);
#line 36 "../src/core/TimeStamp.vala"
		return result;
#line 135 "TimeStamp.c"
	}
#line 38 "../src/core/TimeStamp.vala"
	_tmp9_ = g_date_time_new_local (g_date_time_get_year (now), g_date_time_get_month (now), g_date_time_get_day_of_month (now), 0, 0, (gdouble) 0);
#line 38 "../src/core/TimeStamp.vala"
	midnight = _tmp9_;
#line 39 "../src/core/TimeStamp.vala"
	_tmp10_ = midnight;
#line 39 "../src/core/TimeStamp.vala"
	if (g_date_time_compare (timestamp, _tmp10_) > 0) {
#line 145 "TimeStamp.c"
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 40 "../src/core/TimeStamp.vala"
		_tmp11_ = g_date_time_format (timestamp, "%X");
#line 40 "../src/core/TimeStamp.vala"
		_tmp12_ = _tmp11_;
#line 40 "../src/core/TimeStamp.vala"
		_tmp13_ = g_strdup_printf (_ ("Today at %s"), _tmp12_);
#line 40 "../src/core/TimeStamp.vala"
		_tmp14_ = _tmp13_;
#line 40 "../src/core/TimeStamp.vala"
		_g_free0 (_tmp12_);
#line 40 "../src/core/TimeStamp.vala"
		result = _tmp14_;
#line 40 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (midnight);
#line 40 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (hours_ago);
#line 40 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (minutes_ago);
#line 40 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (just_now);
#line 40 "../src/core/TimeStamp.vala"
		return result;
#line 172 "TimeStamp.c"
	}
#line 42 "../src/core/TimeStamp.vala"
	_tmp15_ = midnight;
#line 42 "../src/core/TimeStamp.vala"
	_tmp16_ = g_date_time_add_days (_tmp15_, -1);
#line 42 "../src/core/TimeStamp.vala"
	yesterday = _tmp16_;
#line 43 "../src/core/TimeStamp.vala"
	_tmp17_ = yesterday;
#line 43 "../src/core/TimeStamp.vala"
	if (g_date_time_compare (timestamp, _tmp17_) > 0) {
#line 184 "TimeStamp.c"
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 44 "../src/core/TimeStamp.vala"
		_tmp18_ = g_date_time_format (timestamp, "%X");
#line 44 "../src/core/TimeStamp.vala"
		_tmp19_ = _tmp18_;
#line 44 "../src/core/TimeStamp.vala"
		_tmp20_ = g_strdup_printf (_ ("Yesterday at %s"), _tmp19_);
#line 44 "../src/core/TimeStamp.vala"
		_tmp21_ = _tmp20_;
#line 44 "../src/core/TimeStamp.vala"
		_g_free0 (_tmp19_);
#line 44 "../src/core/TimeStamp.vala"
		result = _tmp21_;
#line 44 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (yesterday);
#line 44 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (midnight);
#line 44 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (hours_ago);
#line 44 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (minutes_ago);
#line 44 "../src/core/TimeStamp.vala"
		_g_date_time_unref0 (just_now);
#line 44 "../src/core/TimeStamp.vala"
		return result;
#line 213 "TimeStamp.c"
	}
#line 46 "../src/core/TimeStamp.vala"
	_tmp22_ = g_date_time_format (timestamp, "%c");
#line 46 "../src/core/TimeStamp.vala"
	result = _tmp22_;
#line 46 "../src/core/TimeStamp.vala"
	_g_date_time_unref0 (yesterday);
#line 46 "../src/core/TimeStamp.vala"
	_g_date_time_unref0 (midnight);
#line 46 "../src/core/TimeStamp.vala"
	_g_date_time_unref0 (hours_ago);
#line 46 "../src/core/TimeStamp.vala"
	_g_date_time_unref0 (minutes_ago);
#line 46 "../src/core/TimeStamp.vala"
	_g_date_time_unref0 (just_now);
#line 46 "../src/core/TimeStamp.vala"
	return result;
#line 231 "TimeStamp.c"
}

