/* UndoStack.c generated by valac 0.48.3, the Vala compiler
 * generated from UndoStack.vala, do not modify */

/*
 *    UndoStack.vala
 *
 *    Copyright (C) 2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define UNDO_TYPE_UNDO_STACK (undo_undo_stack_get_type ())
#define UNDO_UNDO_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNDO_TYPE_UNDO_STACK, UndoUndoStack))
#define UNDO_IS_UNDO_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNDO_TYPE_UNDO_STACK))
#define UNDO_UNDO_STACK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UNDO_TYPE_UNDO_STACK, UndoUndoStackIface))

typedef struct _UndoUndoStack UndoUndoStack;
typedef struct _UndoUndoStackIface UndoUndoStackIface;

#define UNDO_TYPE_UNDO_COMMAND (undo_undo_command_get_type ())
#define UNDO_UNDO_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNDO_TYPE_UNDO_COMMAND, UndoUndoCommand))
#define UNDO_IS_UNDO_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNDO_TYPE_UNDO_COMMAND))
#define UNDO_UNDO_COMMAND_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UNDO_TYPE_UNDO_COMMAND, UndoUndoCommandIface))

typedef struct _UndoUndoCommand UndoUndoCommand;
typedef struct _UndoUndoCommandIface UndoUndoCommandIface;

struct _UndoUndoCommandIface {
	GTypeInterface parent_iface;
	void (*redo) (UndoUndoCommand* self);
	void (*undo) (UndoUndoCommand* self);
	gboolean (*run_on_init) (UndoUndoCommand* self);
	gboolean (*try_merge) (UndoUndoCommand* self, UndoUndoCommand* command);
};

struct _UndoUndoStackIface {
	GTypeInterface parent_iface;
	void (*offer) (UndoUndoStack* self, UndoUndoCommand* command);
	void (*clear) (UndoUndoStack* self);
	GAction* (*create_undo_action) (UndoUndoStack* self, const gchar* name);
	GAction* (*create_redo_action) (UndoUndoStack* self, const gchar* name);
	gboolean (*get_is_busy) (UndoUndoStack* self);
	void (*set_is_busy) (UndoUndoStack* self, gboolean value);
};

GType undo_undo_command_get_type (void) G_GNUC_CONST;
GType undo_undo_stack_get_type (void) G_GNUC_CONST;
void undo_undo_stack_offer (UndoUndoStack* self,
                            UndoUndoCommand* command);
void undo_undo_stack_clear (UndoUndoStack* self);
GAction* undo_undo_stack_create_undo_action (UndoUndoStack* self,
                                             const gchar* name);
GAction* undo_undo_stack_create_redo_action (UndoUndoStack* self,
                                             const gchar* name);
gboolean undo_undo_stack_get_is_busy (UndoUndoStack* self);
void undo_undo_stack_set_is_busy (UndoUndoStack* self,
                                  gboolean value);
static GType undo_undo_stack_get_type_once (void);

void
undo_undo_stack_offer (UndoUndoStack* self,
                       UndoUndoCommand* command)
{
#line 25 "../src/undo/UndoStack.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/undo/UndoStack.vala"
	UNDO_UNDO_STACK_GET_INTERFACE (self)->offer (self, command);
#line 88 "UndoStack.c"
}

void
undo_undo_stack_clear (UndoUndoStack* self)
{
#line 26 "../src/undo/UndoStack.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/undo/UndoStack.vala"
	UNDO_UNDO_STACK_GET_INTERFACE (self)->clear (self);
#line 98 "UndoStack.c"
}

GAction*
undo_undo_stack_create_undo_action (UndoUndoStack* self,
                                    const gchar* name)
{
#line 27 "../src/undo/UndoStack.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/undo/UndoStack.vala"
	return UNDO_UNDO_STACK_GET_INTERFACE (self)->create_undo_action (self, name);
#line 109 "UndoStack.c"
}

GAction*
undo_undo_stack_create_redo_action (UndoUndoStack* self,
                                    const gchar* name)
{
#line 28 "../src/undo/UndoStack.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/undo/UndoStack.vala"
	return UNDO_UNDO_STACK_GET_INTERFACE (self)->create_redo_action (self, name);
#line 120 "UndoStack.c"
}

gboolean
undo_undo_stack_get_is_busy (UndoUndoStack* self)
{
#line 24 "../src/undo/UndoStack.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../src/undo/UndoStack.vala"
	return UNDO_UNDO_STACK_GET_INTERFACE (self)->get_is_busy (self);
#line 130 "UndoStack.c"
}

void
undo_undo_stack_set_is_busy (UndoUndoStack* self,
                             gboolean value)
{
#line 24 "../src/undo/UndoStack.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/undo/UndoStack.vala"
	UNDO_UNDO_STACK_GET_INTERFACE (self)->set_is_busy (self, value);
#line 141 "UndoStack.c"
}

static void
undo_undo_stack_default_init (UndoUndoStackIface * iface,
                              gpointer iface_data)
{
#line 23 "../src/undo/UndoStack.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("is-busy", "is-busy", "is-busy", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 150 "UndoStack.c"
}

static GType
undo_undo_stack_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UndoUndoStackIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_undo_stack_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType undo_undo_stack_type_id;
	undo_undo_stack_type_id = g_type_register_static (G_TYPE_INTERFACE, "UndoUndoStack", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (undo_undo_stack_type_id, G_TYPE_OBJECT);
	return undo_undo_stack_type_id;
}

GType
undo_undo_stack_get_type (void)
{
	static volatile gsize undo_undo_stack_type_id__volatile = 0;
	if (g_once_init_enter (&undo_undo_stack_type_id__volatile)) {
		GType undo_undo_stack_type_id;
		undo_undo_stack_type_id = undo_undo_stack_get_type_once ();
		g_once_init_leave (&undo_undo_stack_type_id__volatile, undo_undo_stack_type_id);
	}
	return undo_undo_stack_type_id__volatile;
}

