/* NodeWidget.c generated by valac 0.48.3, the Vala compiler
 * generated from NodeWidget.vala, do not modify */

/*
 *    NodeWidget.vala
 *
 *    Copyright (C) 2013-2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define VENOM_TYPE_NODE_WIDGET (venom_node_widget_get_type ())
#define VENOM_NODE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_NODE_WIDGET, VenomNodeWidget))
#define VENOM_NODE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VENOM_TYPE_NODE_WIDGET, VenomNodeWidgetClass))
#define VENOM_IS_NODE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_NODE_WIDGET))
#define VENOM_IS_NODE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VENOM_TYPE_NODE_WIDGET))
#define VENOM_NODE_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VENOM_TYPE_NODE_WIDGET, VenomNodeWidgetClass))

typedef struct _VenomNodeWidget VenomNodeWidget;
typedef struct _VenomNodeWidgetClass VenomNodeWidgetClass;
typedef struct _VenomNodeWidgetPrivate VenomNodeWidgetPrivate;

#define VENOM_TYPE_LOGGER (venom_logger_get_type ())
#define VENOM_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_LOGGER, VenomLogger))
#define VENOM_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_LOGGER))
#define VENOM_LOGGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VENOM_TYPE_LOGGER, VenomLoggerIface))

typedef struct _VenomLogger VenomLogger;
typedef struct _VenomLoggerIface VenomLoggerIface;

#define VENOM_TYPE_DHT_NODE (venom_dht_node_get_type ())
#define VENOM_DHT_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VENOM_TYPE_DHT_NODE, VenomDhtNode))
#define VENOM_DHT_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VENOM_TYPE_DHT_NODE, VenomDhtNodeClass))
#define VENOM_IS_DHT_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VENOM_TYPE_DHT_NODE))
#define VENOM_IS_DHT_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VENOM_TYPE_DHT_NODE))
#define VENOM_DHT_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VENOM_TYPE_DHT_NODE, VenomDhtNodeClass))

typedef struct _VenomDhtNode VenomDhtNode;
typedef struct _VenomDhtNodeClass VenomDhtNodeClass;
enum  {
	VENOM_NODE_WIDGET_0_PROPERTY,
	VENOM_NODE_WIDGET_NUM_PROPERTIES
};
static GParamSpec* venom_node_widget_properties[VENOM_NODE_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	VENOM_NODE_WIDGET_NODE_CHANGED_SIGNAL,
	VENOM_NODE_WIDGET_NUM_SIGNALS
};
static guint venom_node_widget_signals[VENOM_NODE_WIDGET_NUM_SIGNALS] = {0};

struct _VenomNodeWidget {
	GtkListBoxRow parent_instance;
	VenomNodeWidgetPrivate * priv;
};

struct _VenomNodeWidgetClass {
	GtkListBoxRowClass parent_class;
};

struct _VenomLoggerIface {
	GTypeInterface parent_iface;
	void (*d) (VenomLogger* self, const gchar* message);
	void (*i) (VenomLogger* self, const gchar* message);
	void (*w) (VenomLogger* self, const gchar* message);
	void (*e) (VenomLogger* self, const gchar* message);
	void (*f) (VenomLogger* self, const gchar* message);
	gchar* (*get_log) (VenomLogger* self);
	void (*attach_to_glib) (VenomLogger* self);
};

struct _VenomNodeWidgetPrivate {
	GtkLabel* host;
	GtkLabel* public_key;
	GtkLabel* maintainer;
	GtkLabel* location;
	GtkSwitch* enabled;
	VenomLogger* logger;
	VenomDhtNode* node;
};

static gint VenomNodeWidget_private_offset;
static gpointer venom_node_widget_parent_class = NULL;

GType venom_node_widget_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VenomNodeWidget, g_object_unref)
GType venom_logger_get_type (void) G_GNUC_CONST;
GType venom_dht_node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VenomDhtNode, g_object_unref)
void venom_logger_d (VenomLogger* self,
                     const gchar* message);
VenomNodeWidget* venom_node_widget_new (VenomLogger* logger,
                                        VenomDhtNode* node);
VenomNodeWidget* venom_node_widget_construct (GType object_type,
                                              VenomLogger* logger,
                                              VenomDhtNode* node);
const gchar* venom_dht_node_get_host (VenomDhtNode* self);
guint venom_dht_node_get_port (VenomDhtNode* self);
const gchar* venom_dht_node_get_maintainer (VenomDhtNode* self);
const gchar* venom_dht_node_get_pub_key (VenomDhtNode* self);
static gchar* venom_node_widget_emoji_flag (VenomNodeWidget* self,
                                     const gchar* location);
const gchar* venom_dht_node_get_location (VenomDhtNode* self);
gboolean venom_dht_node_get_is_blocked (VenomDhtNode* self);
static void venom_node_widget_on_active_changed (VenomNodeWidget* self);
static void _venom_node_widget_on_active_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self);
void venom_dht_node_set_is_blocked (VenomDhtNode* self,
                                    gboolean value);
static void venom_node_widget_finalize (GObject * obj);
static GType venom_node_widget_get_type_once (void);

static inline gpointer
venom_node_widget_get_instance_private (VenomNodeWidget* self)
{
	return G_STRUCT_MEMBER_P (self, VenomNodeWidget_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../src/view/NodeWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 146 "NodeWidget.c"
}

static void
_venom_node_widget_on_active_changed_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self)
{
#line 47 "../src/view/NodeWidget.vala"
	venom_node_widget_on_active_changed ((VenomNodeWidget*) self);
#line 156 "NodeWidget.c"
}

VenomNodeWidget*
venom_node_widget_construct (GType object_type,
                             VenomLogger* logger,
                             VenomDhtNode* node)
{
	VenomNodeWidget * self = NULL;
	VenomLogger* _tmp0_;
	VenomDhtNode* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkLabel* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GtkLabel* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GtkLabel* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GtkSwitch* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	GtkSwitch* _tmp26_;
#line 36 "../src/view/NodeWidget.vala"
	g_return_val_if_fail (logger != NULL, NULL);
#line 36 "../src/view/NodeWidget.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 36 "../src/view/NodeWidget.vala"
	self = (VenomNodeWidget*) g_object_new (object_type, NULL);
#line 37 "../src/view/NodeWidget.vala"
	_tmp0_ = _g_object_ref0 (logger);
#line 37 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->logger);
#line 37 "../src/view/NodeWidget.vala"
	self->priv->logger = _tmp0_;
#line 38 "../src/view/NodeWidget.vala"
	_tmp1_ = _g_object_ref0 (node);
#line 38 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->node);
#line 38 "../src/view/NodeWidget.vala"
	self->priv->node = _tmp1_;
#line 40 "../src/view/NodeWidget.vala"
	_tmp2_ = self->priv->host;
#line 40 "../src/view/NodeWidget.vala"
	_tmp3_ = venom_dht_node_get_host (node);
#line 40 "../src/view/NodeWidget.vala"
	_tmp4_ = _tmp3_;
#line 40 "../src/view/NodeWidget.vala"
	_tmp5_ = venom_dht_node_get_port (node);
#line 40 "../src/view/NodeWidget.vala"
	_tmp6_ = _tmp5_;
#line 40 "../src/view/NodeWidget.vala"
	_tmp7_ = g_strdup_printf ("%s:%u", _tmp4_, _tmp6_);
#line 40 "../src/view/NodeWidget.vala"
	_tmp8_ = _tmp7_;
#line 40 "../src/view/NodeWidget.vala"
	gtk_label_set_label (_tmp2_, _tmp8_);
#line 40 "../src/view/NodeWidget.vala"
	_g_free0 (_tmp8_);
#line 41 "../src/view/NodeWidget.vala"
	_tmp9_ = self->priv->maintainer;
#line 41 "../src/view/NodeWidget.vala"
	_tmp10_ = venom_dht_node_get_maintainer (node);
#line 41 "../src/view/NodeWidget.vala"
	_tmp11_ = _tmp10_;
#line 41 "../src/view/NodeWidget.vala"
	gtk_label_set_label (_tmp9_, _tmp11_);
#line 42 "../src/view/NodeWidget.vala"
	_tmp12_ = self->priv->public_key;
#line 42 "../src/view/NodeWidget.vala"
	_tmp13_ = venom_dht_node_get_pub_key (node);
#line 42 "../src/view/NodeWidget.vala"
	_tmp14_ = _tmp13_;
#line 42 "../src/view/NodeWidget.vala"
	gtk_label_set_label (_tmp12_, _tmp14_);
#line 43 "../src/view/NodeWidget.vala"
	_tmp15_ = self->priv->location;
#line 43 "../src/view/NodeWidget.vala"
	_tmp16_ = venom_dht_node_get_location (node);
#line 43 "../src/view/NodeWidget.vala"
	_tmp17_ = _tmp16_;
#line 43 "../src/view/NodeWidget.vala"
	_tmp18_ = venom_node_widget_emoji_flag (self, _tmp17_);
#line 43 "../src/view/NodeWidget.vala"
	_tmp19_ = _tmp18_;
#line 43 "../src/view/NodeWidget.vala"
	gtk_label_set_label (_tmp15_, _tmp19_);
#line 43 "../src/view/NodeWidget.vala"
	_g_free0 (_tmp19_);
#line 44 "../src/view/NodeWidget.vala"
	_tmp20_ = self->priv->location;
#line 44 "../src/view/NodeWidget.vala"
	_tmp21_ = venom_dht_node_get_location (node);
#line 44 "../src/view/NodeWidget.vala"
	_tmp22_ = _tmp21_;
#line 44 "../src/view/NodeWidget.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp20_, _tmp22_);
#line 45 "../src/view/NodeWidget.vala"
	_tmp23_ = self->priv->enabled;
#line 45 "../src/view/NodeWidget.vala"
	_tmp24_ = venom_dht_node_get_is_blocked (node);
#line 45 "../src/view/NodeWidget.vala"
	_tmp25_ = _tmp24_;
#line 45 "../src/view/NodeWidget.vala"
	gtk_switch_set_active (_tmp23_, !_tmp25_);
#line 47 "../src/view/NodeWidget.vala"
	_tmp26_ = self->priv->enabled;
#line 47 "../src/view/NodeWidget.vala"
	g_signal_connect_object ((GObject*) _tmp26_, "notify::active", (GCallback) _venom_node_widget_on_active_changed_g_object_notify, self, 0);
#line 48 "../src/view/NodeWidget.vala"
	venom_logger_d (logger, "NodeWidget created.");
#line 36 "../src/view/NodeWidget.vala"
	return self;
#line 282 "NodeWidget.c"
}

VenomNodeWidget*
venom_node_widget_new (VenomLogger* logger,
                       VenomDhtNode* node)
{
#line 36 "../src/view/NodeWidget.vala"
	return venom_node_widget_construct (VENOM_TYPE_NODE_WIDGET, logger, node);
#line 291 "NodeWidget.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
#line 1232 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1233 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1233 "glib-2.0.vapi"
	result = _tmp0_;
#line 1233 "glib-2.0.vapi"
	return result;
#line 308 "NodeWidget.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1071 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1071 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1072 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1073 "glib-2.0.vapi"
	result = str;
#line 1073 "glib-2.0.vapi"
	return result;
#line 327 "NodeWidget.c"
}

static gchar*
venom_node_widget_emoji_flag (VenomNodeWidget* self,
                              const gchar* location)
{
	gchar* country = NULL;
	gchar* _tmp0_;
	gchar* ret = NULL;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 51 "../src/view/NodeWidget.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/view/NodeWidget.vala"
	g_return_val_if_fail (location != NULL, NULL);
#line 52 "../src/view/NodeWidget.vala"
	_tmp0_ = g_utf8_strup (location, (gssize) -1);
#line 52 "../src/view/NodeWidget.vala"
	country = _tmp0_;
#line 53 "../src/view/NodeWidget.vala"
	_tmp1_ = g_strdup ("");
#line 53 "../src/view/NodeWidget.vala"
	ret = _tmp1_;
#line 351 "NodeWidget.c"
	{
		gint i = 0;
#line 54 "../src/view/NodeWidget.vala"
		i = 0;
#line 356 "NodeWidget.c"
		{
			gboolean _tmp2_ = FALSE;
#line 54 "../src/view/NodeWidget.vala"
			_tmp2_ = TRUE;
#line 54 "../src/view/NodeWidget.vala"
			while (TRUE) {
#line 363 "NodeWidget.c"
				const gchar* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gchar* c = NULL;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				gchar* _tmp11_;
#line 54 "../src/view/NodeWidget.vala"
				if (!_tmp2_) {
#line 375 "NodeWidget.c"
					gint _tmp3_;
#line 54 "../src/view/NodeWidget.vala"
					_tmp3_ = i;
#line 54 "../src/view/NodeWidget.vala"
					i = _tmp3_ + 1;
#line 381 "NodeWidget.c"
				}
#line 54 "../src/view/NodeWidget.vala"
				_tmp2_ = FALSE;
#line 54 "../src/view/NodeWidget.vala"
				_tmp4_ = country;
#line 54 "../src/view/NodeWidget.vala"
				_tmp5_ = strlen (_tmp4_);
#line 54 "../src/view/NodeWidget.vala"
				_tmp6_ = _tmp5_;
#line 54 "../src/view/NodeWidget.vala"
				if (!(i < _tmp6_)) {
#line 54 "../src/view/NodeWidget.vala"
					break;
#line 395 "NodeWidget.c"
				}
#line 55 "../src/view/NodeWidget.vala"
				_tmp7_ = country;
#line 55 "../src/view/NodeWidget.vala"
				_tmp8_ = g_unichar_to_string ((gunichar) (0x1F1A5 + string_get (_tmp7_, (glong) i)));
#line 55 "../src/view/NodeWidget.vala"
				c = _tmp8_;
#line 56 "../src/view/NodeWidget.vala"
				_tmp9_ = ret;
#line 56 "../src/view/NodeWidget.vala"
				_tmp10_ = c;
#line 56 "../src/view/NodeWidget.vala"
				_tmp11_ = g_strconcat (_tmp9_, (const gchar*) _tmp10_, NULL);
#line 56 "../src/view/NodeWidget.vala"
				_g_free0 (ret);
#line 56 "../src/view/NodeWidget.vala"
				ret = _tmp11_;
#line 54 "../src/view/NodeWidget.vala"
				_g_free0 (c);
#line 415 "NodeWidget.c"
			}
		}
	}
#line 58 "../src/view/NodeWidget.vala"
	result = ret;
#line 58 "../src/view/NodeWidget.vala"
	_g_free0 (country);
#line 58 "../src/view/NodeWidget.vala"
	return result;
#line 425 "NodeWidget.c"
}

static void
venom_node_widget_on_active_changed (VenomNodeWidget* self)
{
	VenomDhtNode* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	VenomDhtNode* _tmp4_;
#line 61 "../src/view/NodeWidget.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/view/NodeWidget.vala"
	_tmp0_ = self->priv->node;
#line 62 "../src/view/NodeWidget.vala"
	_tmp1_ = self->priv->enabled;
#line 62 "../src/view/NodeWidget.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 62 "../src/view/NodeWidget.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/view/NodeWidget.vala"
	venom_dht_node_set_is_blocked (_tmp0_, !_tmp3_);
#line 63 "../src/view/NodeWidget.vala"
	_tmp4_ = self->priv->node;
#line 63 "../src/view/NodeWidget.vala"
	g_signal_emit (self, venom_node_widget_signals[VENOM_NODE_WIDGET_NODE_CHANGED_SIGNAL], 0, _tmp4_);
#line 452 "NodeWidget.c"
}

static void
venom_node_widget_class_init (VenomNodeWidgetClass * klass,
                              gpointer klass_data)
{
#line 24 "../src/view/NodeWidget.vala"
	venom_node_widget_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/view/NodeWidget.vala"
	g_type_class_adjust_private_offset (klass, &VenomNodeWidget_private_offset);
#line 24 "../src/view/NodeWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = venom_node_widget_finalize;
#line 24 "../src/view/NodeWidget.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/github/naxuroqa/venom/ui/node_widget.ui");
#line 24 "../src/view/NodeWidget.vala"
	venom_node_widget_signals[VENOM_NODE_WIDGET_NODE_CHANGED_SIGNAL] = g_signal_new ("node-changed", VENOM_TYPE_NODE_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, VENOM_TYPE_DHT_NODE);
#line 24 "../src/view/NodeWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "host", FALSE, VenomNodeWidget_private_offset + G_STRUCT_OFFSET (VenomNodeWidgetPrivate, host));
#line 24 "../src/view/NodeWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "public_key", FALSE, VenomNodeWidget_private_offset + G_STRUCT_OFFSET (VenomNodeWidgetPrivate, public_key));
#line 24 "../src/view/NodeWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "maintainer", FALSE, VenomNodeWidget_private_offset + G_STRUCT_OFFSET (VenomNodeWidgetPrivate, maintainer));
#line 24 "../src/view/NodeWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "location", FALSE, VenomNodeWidget_private_offset + G_STRUCT_OFFSET (VenomNodeWidgetPrivate, location));
#line 24 "../src/view/NodeWidget.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "enabled", FALSE, VenomNodeWidget_private_offset + G_STRUCT_OFFSET (VenomNodeWidgetPrivate, enabled));
#line 479 "NodeWidget.c"
}

static void
venom_node_widget_instance_init (VenomNodeWidget * self,
                                 gpointer klass)
{
#line 24 "../src/view/NodeWidget.vala"
	self->priv = venom_node_widget_get_instance_private (self);
#line 24 "../src/view/NodeWidget.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 490 "NodeWidget.c"
}

static void
venom_node_widget_finalize (GObject * obj)
{
	VenomNodeWidget * self;
	VenomLogger* _tmp0_;
#line 24 "../src/view/NodeWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VENOM_TYPE_NODE_WIDGET, VenomNodeWidget);
#line 67 "../src/view/NodeWidget.vala"
	_tmp0_ = self->priv->logger;
#line 67 "../src/view/NodeWidget.vala"
	venom_logger_d (_tmp0_, "NodeWidget destroyed.");
#line 25 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->host);
#line 26 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->public_key);
#line 27 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->maintainer);
#line 28 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->location);
#line 29 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->enabled);
#line 33 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->logger);
#line 34 "../src/view/NodeWidget.vala"
	_g_object_unref0 (self->priv->node);
#line 24 "../src/view/NodeWidget.vala"
	G_OBJECT_CLASS (venom_node_widget_parent_class)->finalize (obj);
#line 520 "NodeWidget.c"
}

static GType
venom_node_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VenomNodeWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) venom_node_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VenomNodeWidget), 0, (GInstanceInitFunc) venom_node_widget_instance_init, NULL };
	GType venom_node_widget_type_id;
	venom_node_widget_type_id = g_type_register_static (gtk_list_box_row_get_type (), "VenomNodeWidget", &g_define_type_info, 0);
	VenomNodeWidget_private_offset = g_type_add_instance_private (venom_node_widget_type_id, sizeof (VenomNodeWidgetPrivate));
	return venom_node_widget_type_id;
}

GType
venom_node_widget_get_type (void)
{
	static volatile gsize venom_node_widget_type_id__volatile = 0;
	if (g_once_init_enter (&venom_node_widget_type_id__volatile)) {
		GType venom_node_widget_type_id;
		venom_node_widget_type_id = venom_node_widget_get_type_once ();
		g_once_init_leave (&venom_node_widget_type_id__volatile, venom_node_widget_type_id);
	}
	return venom_node_widget_type_id__volatile;
}

