/* Assert.c generated by valac 0.48.3, the Vala compiler
 * generated from Assert.vala, do not modify */

/*
 *    Assert.vala
 *
 *    Copyright (C) 2018 Venom authors and contributors
 *
 *    This file is part of Venom.
 *
 *    Venom is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Venom is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Venom.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#define TESTING_TYPE_ASSERT (testing_assert_get_type ())
#define TESTING_ASSERT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TESTING_TYPE_ASSERT, TestingAssert))
#define TESTING_ASSERT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TESTING_TYPE_ASSERT, TestingAssertClass))
#define TESTING_IS_ASSERT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TESTING_TYPE_ASSERT))
#define TESTING_IS_ASSERT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TESTING_TYPE_ASSERT))
#define TESTING_ASSERT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TESTING_TYPE_ASSERT, TestingAssertClass))

typedef struct _TestingAssert TestingAssert;
typedef struct _TestingAssertClass TestingAssertClass;
typedef struct _TestingAssertPrivate TestingAssertPrivate;
typedef struct _TestingParamSpecAssert TestingParamSpecAssert;

typedef enum  {
	TESTING_ASSERTION_ERROR_FAILED
} TestingAssertionError;
#define TESTING_ASSERTION_ERROR testing_assertion_error_quark ()
struct _TestingAssert {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TestingAssertPrivate * priv;
};

struct _TestingAssertClass {
	GTypeClass parent_class;
	void (*finalize) (TestingAssert *self);
};

struct _TestingParamSpecAssert {
	GParamSpec parent_instance;
};

static gpointer testing_assert_parent_class = NULL;

GQuark testing_assertion_error_quark (void);
gpointer testing_assert_ref (gpointer instance);
void testing_assert_unref (gpointer instance);
GParamSpec* testing_param_spec_assert (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void testing_value_set_assert (GValue* value,
                               gpointer v_object);
void testing_value_take_assert (GValue* value,
                                gpointer v_object);
gpointer testing_value_get_assert (const GValue* value);
GType testing_assert_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TestingAssert, testing_assert_unref)
static TestingAssert* testing_assert_new (void);
static TestingAssert* testing_assert_construct (GType object_type);
void testing_assert_fail (const gchar* message,
                          GError** error);
void testing_assert_assert_true (gboolean condition,
                                 GError** error);
void testing_assert_assert_false (gboolean condition,
                                  GError** error);
void testing_assert_assert_same (void* expected,
                                 void* actual,
                                 GError** error);
void testing_assert_assert_not_same (void* unexpected,
                                     void* actual,
                                     GError** error);
void testing_assert_assert_null (void* o,
                                 GError** error);
void testing_assert_assert_not_null (void* o,
                                     GError** error);
void testing_assert_assert_array_equals (guint8* expected,
                                         gint expected_length1,
                                         guint8* actual,
                                         gint actual_length1,
                                         GError** error);
void testing_assert_assert_equals (GType t_type,
                                   GBoxedCopyFunc t_dup_func,
                                   GDestroyNotify t_destroy_func,
                                   gconstpointer expected,
                                   gconstpointer actual,
                                   GError** error);
void testing_assert_assert_not_equals (GType t_type,
                                       GBoxedCopyFunc t_dup_func,
                                       GDestroyNotify t_destroy_func,
                                       gconstpointer unexpected,
                                       gconstpointer actual,
                                       GError** error);
static void testing_assert_finalize (TestingAssert * obj);
static GType testing_assert_get_type_once (void);

GQuark
testing_assertion_error_quark (void)
{
	return g_quark_from_static_string ("testing-assertion-error-quark");
}

static TestingAssert*
testing_assert_construct (GType object_type)
{
	TestingAssert* self = NULL;
#line 28 "../src/testing/util/Assert.vala"
	self = (TestingAssert*) g_type_create_instance (object_type);
#line 28 "../src/testing/util/Assert.vala"
	return self;
#line 133 "Assert.c"
}

static TestingAssert*
testing_assert_new (void)
{
#line 28 "../src/testing/util/Assert.vala"
	return testing_assert_construct (TESTING_TYPE_ASSERT);
#line 141 "Assert.c"
}

void
testing_assert_fail (const gchar* message,
                     GError** error)
{
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 30 "../src/testing/util/Assert.vala"
	g_return_if_fail (message != NULL);
#line 31 "../src/testing/util/Assert.vala"
	_tmp0_ = g_error_new_literal (TESTING_ASSERTION_ERROR, TESTING_ASSERTION_ERROR_FAILED, message);
#line 31 "../src/testing/util/Assert.vala"
	_inner_error0_ = _tmp0_;
#line 31 "../src/testing/util/Assert.vala"
	if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 31 "../src/testing/util/Assert.vala"
		g_propagate_error (error, _inner_error0_);
#line 31 "../src/testing/util/Assert.vala"
		return;
#line 162 "Assert.c"
	} else {
#line 31 "../src/testing/util/Assert.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../src/testing/util/Assert.vala"
		g_clear_error (&_inner_error0_);
#line 31 "../src/testing/util/Assert.vala"
		return;
#line 170 "Assert.c"
	}
}

void
testing_assert_assert_true (gboolean condition,
                            GError** error)
{
	GError* _inner_error0_ = NULL;
#line 35 "../src/testing/util/Assert.vala"
	if (!condition) {
#line 35 "../src/testing/util/Assert.vala"
		testing_assert_fail ("Condition != true", &_inner_error0_);
#line 35 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 35 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 35 "../src/testing/util/Assert.vala"
				return;
#line 191 "Assert.c"
			} else {
#line 35 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 35 "../src/testing/util/Assert.vala"
				return;
#line 199 "Assert.c"
			}
		}
	}
}

void
testing_assert_assert_false (gboolean condition,
                             GError** error)
{
	GError* _inner_error0_ = NULL;
#line 39 "../src/testing/util/Assert.vala"
	if (condition) {
#line 39 "../src/testing/util/Assert.vala"
		testing_assert_fail ("Condition != false", &_inner_error0_);
#line 39 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 39 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 39 "../src/testing/util/Assert.vala"
				return;
#line 222 "Assert.c"
			} else {
#line 39 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 39 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 39 "../src/testing/util/Assert.vala"
				return;
#line 230 "Assert.c"
			}
		}
	}
}

void
testing_assert_assert_same (void* expected,
                            void* actual,
                            GError** error)
{
	GError* _inner_error0_ = NULL;
#line 43 "../src/testing/util/Assert.vala"
	if (expected != actual) {
#line 43 "../src/testing/util/Assert.vala"
		testing_assert_fail ("expected == actual", &_inner_error0_);
#line 43 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 43 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 43 "../src/testing/util/Assert.vala"
				return;
#line 254 "Assert.c"
			} else {
#line 43 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 43 "../src/testing/util/Assert.vala"
				return;
#line 262 "Assert.c"
			}
		}
	}
}

void
testing_assert_assert_not_same (void* unexpected,
                                void* actual,
                                GError** error)
{
	GError* _inner_error0_ = NULL;
#line 47 "../src/testing/util/Assert.vala"
	if (unexpected == actual) {
#line 47 "../src/testing/util/Assert.vala"
		testing_assert_fail ("unexpected != actual", &_inner_error0_);
#line 47 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 47 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 47 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 47 "../src/testing/util/Assert.vala"
				return;
#line 286 "Assert.c"
			} else {
#line 47 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 47 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 47 "../src/testing/util/Assert.vala"
				return;
#line 294 "Assert.c"
			}
		}
	}
}

void
testing_assert_assert_null (void* o,
                            GError** error)
{
	GError* _inner_error0_ = NULL;
#line 51 "../src/testing/util/Assert.vala"
	if (o != NULL) {
#line 51 "../src/testing/util/Assert.vala"
		testing_assert_fail ("Object is not null", &_inner_error0_);
#line 51 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 51 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 51 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 51 "../src/testing/util/Assert.vala"
				return;
#line 317 "Assert.c"
			} else {
#line 51 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 51 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 51 "../src/testing/util/Assert.vala"
				return;
#line 325 "Assert.c"
			}
		}
	}
}

void
testing_assert_assert_not_null (void* o,
                                GError** error)
{
	GError* _inner_error0_ = NULL;
#line 55 "../src/testing/util/Assert.vala"
	if (o == NULL) {
#line 55 "../src/testing/util/Assert.vala"
		testing_assert_fail ("Object is null", &_inner_error0_);
#line 55 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 55 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 55 "../src/testing/util/Assert.vala"
				return;
#line 348 "Assert.c"
			} else {
#line 55 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 55 "../src/testing/util/Assert.vala"
				return;
#line 356 "Assert.c"
			}
		}
	}
}

void
testing_assert_assert_array_equals (guint8* expected,
                                    gint expected_length1,
                                    guint8* actual,
                                    gint actual_length1,
                                    GError** error)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 59 "../src/testing/util/Assert.vala"
	if (expected_length1 != actual_length1) {
#line 59 "../src/testing/util/Assert.vala"
		_tmp0_ = TRUE;
#line 375 "Assert.c"
	} else {
#line 59 "../src/testing/util/Assert.vala"
		_tmp0_ = memcmp (expected, actual, (gsize) expected_length1) != 0;
#line 379 "Assert.c"
	}
#line 59 "../src/testing/util/Assert.vala"
	if (_tmp0_) {
#line 60 "../src/testing/util/Assert.vala"
		testing_assert_fail ("expected != actual", &_inner_error0_);
#line 60 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 60 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 60 "../src/testing/util/Assert.vala"
				return;
#line 393 "Assert.c"
			} else {
#line 60 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 60 "../src/testing/util/Assert.vala"
				return;
#line 401 "Assert.c"
			}
		}
	}
}

void
testing_assert_assert_equals (GType t_type,
                              GBoxedCopyFunc t_dup_func,
                              GDestroyNotify t_destroy_func,
                              gconstpointer expected,
                              gconstpointer actual,
                              GError** error)
{
	GeeEqualDataFunc f = NULL;
	void* _tmp0_ = NULL;
	GDestroyNotify _tmp1_ = NULL;
	GeeEqualDataFunc _tmp2_;
	gpointer f_target;
	GDestroyNotify f_target_destroy_notify;
	GeeEqualDataFunc _tmp3_;
	gpointer _tmp3__target;
	GError* _inner_error0_ = NULL;
#line 65 "../src/testing/util/Assert.vala"
	_tmp2_ = gee_functions_get_equal_func_for (t_type, &_tmp0_, &_tmp1_);
#line 65 "../src/testing/util/Assert.vala"
	f = _tmp2_;
#line 65 "../src/testing/util/Assert.vala"
	f_target = _tmp0_;
#line 65 "../src/testing/util/Assert.vala"
	f_target_destroy_notify = _tmp1_;
#line 66 "../src/testing/util/Assert.vala"
	_tmp3_ = f;
#line 66 "../src/testing/util/Assert.vala"
	_tmp3__target = f_target;
#line 66 "../src/testing/util/Assert.vala"
	if (!_tmp3_ (expected, actual, _tmp3__target)) {
#line 66 "../src/testing/util/Assert.vala"
		testing_assert_fail ("expected != actual", &_inner_error0_);
#line 66 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 66 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 66 "../src/testing/util/Assert.vala"
				(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 66 "../src/testing/util/Assert.vala"
				f = NULL;
#line 66 "../src/testing/util/Assert.vala"
				f_target = NULL;
#line 66 "../src/testing/util/Assert.vala"
				f_target_destroy_notify = NULL;
#line 66 "../src/testing/util/Assert.vala"
				return;
#line 456 "Assert.c"
			} else {
#line 66 "../src/testing/util/Assert.vala"
				(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 66 "../src/testing/util/Assert.vala"
				f = NULL;
#line 66 "../src/testing/util/Assert.vala"
				f_target = NULL;
#line 66 "../src/testing/util/Assert.vala"
				f_target_destroy_notify = NULL;
#line 66 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 66 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 66 "../src/testing/util/Assert.vala"
				return;
#line 472 "Assert.c"
			}
		}
	}
#line 64 "../src/testing/util/Assert.vala"
	(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 64 "../src/testing/util/Assert.vala"
	f = NULL;
#line 64 "../src/testing/util/Assert.vala"
	f_target = NULL;
#line 64 "../src/testing/util/Assert.vala"
	f_target_destroy_notify = NULL;
#line 484 "Assert.c"
}

void
testing_assert_assert_not_equals (GType t_type,
                                  GBoxedCopyFunc t_dup_func,
                                  GDestroyNotify t_destroy_func,
                                  gconstpointer unexpected,
                                  gconstpointer actual,
                                  GError** error)
{
	GeeEqualDataFunc f = NULL;
	void* _tmp0_ = NULL;
	GDestroyNotify _tmp1_ = NULL;
	GeeEqualDataFunc _tmp2_;
	gpointer f_target;
	GDestroyNotify f_target_destroy_notify;
	GeeEqualDataFunc _tmp3_;
	gpointer _tmp3__target;
	GError* _inner_error0_ = NULL;
#line 70 "../src/testing/util/Assert.vala"
	_tmp2_ = gee_functions_get_equal_func_for (t_type, &_tmp0_, &_tmp1_);
#line 70 "../src/testing/util/Assert.vala"
	f = _tmp2_;
#line 70 "../src/testing/util/Assert.vala"
	f_target = _tmp0_;
#line 70 "../src/testing/util/Assert.vala"
	f_target_destroy_notify = _tmp1_;
#line 71 "../src/testing/util/Assert.vala"
	_tmp3_ = f;
#line 71 "../src/testing/util/Assert.vala"
	_tmp3__target = f_target;
#line 71 "../src/testing/util/Assert.vala"
	if (_tmp3_ (unexpected, actual, _tmp3__target)) {
#line 71 "../src/testing/util/Assert.vala"
		testing_assert_fail ("expected == actual", &_inner_error0_);
#line 71 "../src/testing/util/Assert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/testing/util/Assert.vala"
			if (_inner_error0_->domain == TESTING_ASSERTION_ERROR) {
#line 71 "../src/testing/util/Assert.vala"
				g_propagate_error (error, _inner_error0_);
#line 71 "../src/testing/util/Assert.vala"
				(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 71 "../src/testing/util/Assert.vala"
				f = NULL;
#line 71 "../src/testing/util/Assert.vala"
				f_target = NULL;
#line 71 "../src/testing/util/Assert.vala"
				f_target_destroy_notify = NULL;
#line 71 "../src/testing/util/Assert.vala"
				return;
#line 536 "Assert.c"
			} else {
#line 71 "../src/testing/util/Assert.vala"
				(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 71 "../src/testing/util/Assert.vala"
				f = NULL;
#line 71 "../src/testing/util/Assert.vala"
				f_target = NULL;
#line 71 "../src/testing/util/Assert.vala"
				f_target_destroy_notify = NULL;
#line 71 "../src/testing/util/Assert.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 71 "../src/testing/util/Assert.vala"
				g_clear_error (&_inner_error0_);
#line 71 "../src/testing/util/Assert.vala"
				return;
#line 552 "Assert.c"
			}
		}
	}
#line 69 "../src/testing/util/Assert.vala"
	(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 69 "../src/testing/util/Assert.vala"
	f = NULL;
#line 69 "../src/testing/util/Assert.vala"
	f_target = NULL;
#line 69 "../src/testing/util/Assert.vala"
	f_target_destroy_notify = NULL;
#line 564 "Assert.c"
}

static void
testing_value_assert_init (GValue* value)
{
#line 27 "../src/testing/util/Assert.vala"
	value->data[0].v_pointer = NULL;
#line 572 "Assert.c"
}

static void
testing_value_assert_free_value (GValue* value)
{
#line 27 "../src/testing/util/Assert.vala"
	if (value->data[0].v_pointer) {
#line 27 "../src/testing/util/Assert.vala"
		testing_assert_unref (value->data[0].v_pointer);
#line 582 "Assert.c"
	}
}

static void
testing_value_assert_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 27 "../src/testing/util/Assert.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../src/testing/util/Assert.vala"
		dest_value->data[0].v_pointer = testing_assert_ref (src_value->data[0].v_pointer);
#line 594 "Assert.c"
	} else {
#line 27 "../src/testing/util/Assert.vala"
		dest_value->data[0].v_pointer = NULL;
#line 598 "Assert.c"
	}
}

static gpointer
testing_value_assert_peek_pointer (const GValue* value)
{
#line 27 "../src/testing/util/Assert.vala"
	return value->data[0].v_pointer;
#line 607 "Assert.c"
}

static gchar*
testing_value_assert_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 27 "../src/testing/util/Assert.vala"
	if (collect_values[0].v_pointer) {
#line 618 "Assert.c"
		TestingAssert * object;
		object = collect_values[0].v_pointer;
#line 27 "../src/testing/util/Assert.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../src/testing/util/Assert.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 625 "Assert.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../src/testing/util/Assert.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 629 "Assert.c"
		}
#line 27 "../src/testing/util/Assert.vala"
		value->data[0].v_pointer = testing_assert_ref (object);
#line 633 "Assert.c"
	} else {
#line 27 "../src/testing/util/Assert.vala"
		value->data[0].v_pointer = NULL;
#line 637 "Assert.c"
	}
#line 27 "../src/testing/util/Assert.vala"
	return NULL;
#line 641 "Assert.c"
}

static gchar*
testing_value_assert_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	TestingAssert ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../src/testing/util/Assert.vala"
	if (!object_p) {
#line 27 "../src/testing/util/Assert.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 656 "Assert.c"
	}
#line 27 "../src/testing/util/Assert.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../src/testing/util/Assert.vala"
		*object_p = NULL;
#line 662 "Assert.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../src/testing/util/Assert.vala"
		*object_p = value->data[0].v_pointer;
#line 666 "Assert.c"
	} else {
#line 27 "../src/testing/util/Assert.vala"
		*object_p = testing_assert_ref (value->data[0].v_pointer);
#line 670 "Assert.c"
	}
#line 27 "../src/testing/util/Assert.vala"
	return NULL;
#line 674 "Assert.c"
}

GParamSpec*
testing_param_spec_assert (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	TestingParamSpecAssert* spec;
#line 27 "../src/testing/util/Assert.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TESTING_TYPE_ASSERT), NULL);
#line 27 "../src/testing/util/Assert.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../src/testing/util/Assert.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../src/testing/util/Assert.vala"
	return G_PARAM_SPEC (spec);
#line 693 "Assert.c"
}

gpointer
testing_value_get_assert (const GValue* value)
{
#line 27 "../src/testing/util/Assert.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TESTING_TYPE_ASSERT), NULL);
#line 27 "../src/testing/util/Assert.vala"
	return value->data[0].v_pointer;
#line 703 "Assert.c"
}

void
testing_value_set_assert (GValue* value,
                          gpointer v_object)
{
	TestingAssert * old;
#line 27 "../src/testing/util/Assert.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TESTING_TYPE_ASSERT));
#line 27 "../src/testing/util/Assert.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/testing/util/Assert.vala"
	if (v_object) {
#line 27 "../src/testing/util/Assert.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TESTING_TYPE_ASSERT));
#line 27 "../src/testing/util/Assert.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/testing/util/Assert.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../src/testing/util/Assert.vala"
		testing_assert_ref (value->data[0].v_pointer);
#line 725 "Assert.c"
	} else {
#line 27 "../src/testing/util/Assert.vala"
		value->data[0].v_pointer = NULL;
#line 729 "Assert.c"
	}
#line 27 "../src/testing/util/Assert.vala"
	if (old) {
#line 27 "../src/testing/util/Assert.vala"
		testing_assert_unref (old);
#line 735 "Assert.c"
	}
}

void
testing_value_take_assert (GValue* value,
                           gpointer v_object)
{
	TestingAssert * old;
#line 27 "../src/testing/util/Assert.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TESTING_TYPE_ASSERT));
#line 27 "../src/testing/util/Assert.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/testing/util/Assert.vala"
	if (v_object) {
#line 27 "../src/testing/util/Assert.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TESTING_TYPE_ASSERT));
#line 27 "../src/testing/util/Assert.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/testing/util/Assert.vala"
		value->data[0].v_pointer = v_object;
#line 756 "Assert.c"
	} else {
#line 27 "../src/testing/util/Assert.vala"
		value->data[0].v_pointer = NULL;
#line 760 "Assert.c"
	}
#line 27 "../src/testing/util/Assert.vala"
	if (old) {
#line 27 "../src/testing/util/Assert.vala"
		testing_assert_unref (old);
#line 766 "Assert.c"
	}
}

static void
testing_assert_class_init (TestingAssertClass * klass,
                           gpointer klass_data)
{
#line 27 "../src/testing/util/Assert.vala"
	testing_assert_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/testing/util/Assert.vala"
	((TestingAssertClass *) klass)->finalize = testing_assert_finalize;
#line 778 "Assert.c"
}

static void
testing_assert_instance_init (TestingAssert * self,
                              gpointer klass)
{
#line 27 "../src/testing/util/Assert.vala"
	self->ref_count = 1;
#line 787 "Assert.c"
}

static void
testing_assert_finalize (TestingAssert * obj)
{
	TestingAssert * self;
#line 27 "../src/testing/util/Assert.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TESTING_TYPE_ASSERT, TestingAssert);
#line 27 "../src/testing/util/Assert.vala"
	g_signal_handlers_destroy (self);
#line 798 "Assert.c"
}

static GType
testing_assert_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { testing_value_assert_init, testing_value_assert_free_value, testing_value_assert_copy_value, testing_value_assert_peek_pointer, "p", testing_value_assert_collect_value, "p", testing_value_assert_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TestingAssertClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) testing_assert_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TestingAssert), 0, (GInstanceInitFunc) testing_assert_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType testing_assert_type_id;
	testing_assert_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TestingAssert", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return testing_assert_type_id;
}

GType
testing_assert_get_type (void)
{
	static volatile gsize testing_assert_type_id__volatile = 0;
	if (g_once_init_enter (&testing_assert_type_id__volatile)) {
		GType testing_assert_type_id;
		testing_assert_type_id = testing_assert_get_type_once ();
		g_once_init_leave (&testing_assert_type_id__volatile, testing_assert_type_id);
	}
	return testing_assert_type_id__volatile;
}

gpointer
testing_assert_ref (gpointer instance)
{
	TestingAssert * self;
	self = instance;
#line 27 "../src/testing/util/Assert.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../src/testing/util/Assert.vala"
	return instance;
#line 833 "Assert.c"
}

void
testing_assert_unref (gpointer instance)
{
	TestingAssert * self;
	self = instance;
#line 27 "../src/testing/util/Assert.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../src/testing/util/Assert.vala"
		TESTING_ASSERT_GET_CLASS (self)->finalize (self);
#line 27 "../src/testing/util/Assert.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 847 "Assert.c"
	}
}

